/* A Bison parser, made by GNU Bison 3.8.2.  */

/* Bison implementation for Yacc-like parsers in C

   Copyright (C) 1984, 1989-1990, 2000-2015, 2018-2021 Free Software Foundation,
   Inc.

   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <https://www.gnu.org/licenses/>.  */

/* As a special exception, you may create a larger work that contains
   part or all of the Bison parser skeleton and distribute that work
   under terms of your choice, so long as that work isn't itself a
   parser generator using the skeleton or a modified version thereof
   as a parser skeleton.  Alternatively, if you modify or redistribute
   the parser skeleton itself, you may (at your option) remove this
   special exception, which will cause the skeleton and the resulting
   Bison output files to be licensed under the GNU General Public
   License without this special exception.

   This special exception was added by the Free Software Foundation in
   version 2.2 of Bison.  */

/* C LALR(1) parser skeleton written by Richard Stallman, by
   simplifying the original so-called "semantic" parser.  */

/* DO NOT RELY ON FEATURES THAT ARE NOT DOCUMENTED in the manual,
   especially those whose name start with YY_ or yy_.  They are
   private implementation details that can be changed or removed.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output, and Bison version.  */
#define YYBISON 30802

/* Bison version string.  */
#define YYBISON_VERSION "3.8.2"

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 0

/* Push parsers.  */
#define YYPUSH 0

/* Pull parsers.  */
#define YYPULL 1


/* Substitute the variable and function names.  */
#define yyparse         CISAparse
#define yylex           CISAlex
#define yyerror         CISAerror
#define yydebug         CISAdebug
#define yynerrs         CISAnerrs
#define yylval          CISAlval
#define yychar          CISAchar

/* First part of user prologue.  */
#line 9 "CISA.y"

#include <stdio.h>
#include <math.h>
#include <string>
#include <vector>

#include "visa_igc_common_header.h"
#include "Common_ISA.h"
#include "Common_ISA_util.h"
#include "Common_ISA_framework.h"
#include "JitterDataStruct.h"
#include "VISAKernel.h"

static int lscCheckExecSize(
    CISA_IR_Builder* pBuilder,
    LSC_SFID sfid,
    LSC_OP op,
    LSC_DATA_ORDER data_order,
    int exec_size);

//VISA_Type variable_declaration_and_type_check(char *var, Common_ISA_Var_Class type);
void CISAerror(CISA_IR_Builder* builder, char const* msg);
int yylex(CISA_IR_Builder *pBuilder);
extern int CISAlineno;


static bool ParseAlign(CISA_IR_Builder* pBuilder, const char *sym, VISA_Align &value);
static VISA_Align AlignBytesToVisaAlignment(int bytes);
static int DataTypeSizeOf(VISA_Type type);
static bool ParseEMask(const char* sym, VISA_EMask_Ctrl &emask);




//
// check if the cond is true.
// if cond is false, then print errorMessage (syntax error) and YYABORT
#define MUST_HOLD(cond, errorMessage) \
  {if (!(cond)) {pBuilder->RecordParseError(CISAlineno, errorMessage); YYABORT;}}
#define PARSE_ERROR_AT(LINE,...)\
  {pBuilder->RecordParseError(LINE, __VA_ARGS__); YYABORT;}
#define PARSE_ERROR(...)\
    PARSE_ERROR_AT(CISAlineno, __VA_ARGS__)

// Use this to wrap API calls that return false, nullptr, or 0 on failure
// It's assumed that the API call reported the parse error
#define ABORT_ON_FAIL(X) \
    do \
        if (!(X)) \
            YYABORT;\
    while (0)
#define TRACE(S) \
    do { \
      if (CISAout && pBuilder->debugParse()) \
          fprintf(CISAout, "line %d: %s", CISAlineno, S); \
    } while (0)

std::deque<const char*> switchLabels;
char * switch_label_array[32];
std::vector<VISA_opnd*> RTRWOperandsVec;
int num_parameters;

VISA_RawOpnd* rawOperandArray[16];

// global var for non-kernel attribute option.
// The var needs to be cleared before each use.
std::vector<attr_gen_struct*> AttrOptVar;

#ifdef _MSC_VER
#pragma warning(disable:4065; disable:4267)
#endif


#line 152 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.12037.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"

# ifndef YY_CAST
#  ifdef __cplusplus
#   define YY_CAST(Type, Val) static_cast<Type> (Val)
#   define YY_REINTERPRET_CAST(Type, Val) reinterpret_cast<Type> (Val)
#  else
#   define YY_CAST(Type, Val) ((Type) (Val))
#   define YY_REINTERPRET_CAST(Type, Val) ((Type) (Val))
#  endif
# endif
# ifndef YY_NULLPTR
#  if defined __cplusplus
#   if 201103L <= __cplusplus
#    define YY_NULLPTR nullptr
#   else
#    define YY_NULLPTR 0
#   endif
#  else
#   define YY_NULLPTR ((void*)0)
#  endif
# endif

#include "CISA.tab.hpp"
/* Symbol kind.  */
enum yysymbol_kind_t
{
  YYSYMBOL_YYEMPTY = -2,
  YYSYMBOL_YYEOF = 0,                      /* "end of file"  */
  YYSYMBOL_YYerror = 1,                    /* error  */
  YYSYMBOL_YYUNDEF = 2,                    /* "invalid token"  */
  YYSYMBOL_ALIGN_KEYWORD = 3,              /* ALIGN_KEYWORD  */
  YYSYMBOL_ATOMIC_SUB_OP = 4,              /* ATOMIC_SUB_OP  */
  YYSYMBOL_DIRECTIVE_DECL = 5,             /* DIRECTIVE_DECL  */
  YYSYMBOL_DIRECTIVE_FUNC = 6,             /* DIRECTIVE_FUNC  */
  YYSYMBOL_DIRECTIVE_FUNCDECL = 7,         /* DIRECTIVE_FUNCDECL  */
  YYSYMBOL_DIRECTIVE_GLOBAL_FUNC = 8,      /* DIRECTIVE_GLOBAL_FUNC  */
  YYSYMBOL_DIRECTIVE_IMPLICIT = 9,         /* DIRECTIVE_IMPLICIT  */
  YYSYMBOL_DIRECTIVE_INPUT = 10,           /* DIRECTIVE_INPUT  */
  YYSYMBOL_DIRECTIVE_KERNEL = 11,          /* DIRECTIVE_KERNEL  */
  YYSYMBOL_DIRECTIVE_KERNEL_ATTR = 12,     /* DIRECTIVE_KERNEL_ATTR  */
  YYSYMBOL_DIRECTIVE_PARAMETER = 13,       /* DIRECTIVE_PARAMETER  */
  YYSYMBOL_DIRECTIVE_VERSION = 14,         /* DIRECTIVE_VERSION  */
  YYSYMBOL_ALIAS_EQ = 15,                  /* ALIAS_EQ  */
  YYSYMBOL_ALIGN_EQ = 16,                  /* ALIGN_EQ  */
  YYSYMBOL_ATTR_EQ = 17,                   /* ATTR_EQ  */
  YYSYMBOL_OFFSET_EQ = 18,                 /* OFFSET_EQ  */
  YYSYMBOL_NUM_ELTS_EQ = 19,               /* NUM_ELTS_EQ  */
  YYSYMBOL_V_NAME_EQ = 20,                 /* V_NAME_EQ  */
  YYSYMBOL_SIZE_EQ = 21,                   /* SIZE_EQ  */
  YYSYMBOL_V_TYPE_EQ_G = 22,               /* V_TYPE_EQ_G  */
  YYSYMBOL_V_TYPE_EQ_P = 23,               /* V_TYPE_EQ_P  */
  YYSYMBOL_V_TYPE_EQ_A = 24,               /* V_TYPE_EQ_A  */
  YYSYMBOL_V_TYPE_EQ_S = 25,               /* V_TYPE_EQ_S  */
  YYSYMBOL_V_TYPE_EQ_T = 26,               /* V_TYPE_EQ_T  */
  YYSYMBOL_CPS = 27,                       /* CPS  */
  YYSYMBOL_NON_UNIFORM_SAMPLER = 28,       /* NON_UNIFORM_SAMPLER  */
  YYSYMBOL_PIXEL_NULL_MASK = 29,           /* PIXEL_NULL_MASK  */
  YYSYMBOL_RAW_SENDC_STRING = 30,          /* RAW_SENDC_STRING  */
  YYSYMBOL_RAW_SENDSC_EOT_STRING = 31,     /* RAW_SENDSC_EOT_STRING  */
  YYSYMBOL_RAW_SENDSC_STRING = 32,         /* RAW_SENDSC_STRING  */
  YYSYMBOL_RAW_SENDS_EOT_STRING = 33,      /* RAW_SENDS_EOT_STRING  */
  YYSYMBOL_RAW_SENDS_STRING = 34,          /* RAW_SENDS_STRING  */
  YYSYMBOL_RAW_SEND_STRING = 35,           /* RAW_SEND_STRING  */
  YYSYMBOL_SAT = 36,                       /* SAT  */
  YYSYMBOL_SRCMOD_ABS = 37,                /* SRCMOD_ABS  */
  YYSYMBOL_SRCMOD_NEG = 38,                /* SRCMOD_NEG  */
  YYSYMBOL_SRCMOD_NEGABS = 39,             /* SRCMOD_NEGABS  */
  YYSYMBOL_SRCMOD_NOT = 40,                /* SRCMOD_NOT  */
  YYSYMBOL_BFN_OP = 41,                    /* BFN_OP  */
  YYSYMBOL_DPAS_OP = 42,                   /* DPAS_OP  */
  YYSYMBOL_NBARRIER_SIGNAL = 43,           /* NBARRIER_SIGNAL  */
  YYSYMBOL_NBARRIER_WAIT = 44,             /* NBARRIER_WAIT  */
  YYSYMBOL_ITYPE = 45,                     /* ITYPE  */
  YYSYMBOL_DECL_DATA_TYPE = 46,            /* DECL_DATA_TYPE  */
  YYSYMBOL_DFTYPE = 47,                    /* DFTYPE  */
  YYSYMBOL_FTYPE = 48,                     /* FTYPE  */
  YYSYMBOL_HFTYPE = 49,                    /* HFTYPE  */
  YYSYMBOL_VTYPE = 50,                     /* VTYPE  */
  YYSYMBOL_COND_MOD = 51,                  /* COND_MOD  */
  YYSYMBOL_LANGLE = 52,                    /* LANGLE  */
  YYSYMBOL_RANGLE = 53,                    /* RANGLE  */
  YYSYMBOL_LBRACK = 54,                    /* LBRACK  */
  YYSYMBOL_RBRACK = 55,                    /* RBRACK  */
  YYSYMBOL_IND_LBRACK = 56,                /* IND_LBRACK  */
  YYSYMBOL_LPAREN = 57,                    /* LPAREN  */
  YYSYMBOL_RPAREN = 58,                    /* RPAREN  */
  YYSYMBOL_LBRACE = 59,                    /* LBRACE  */
  YYSYMBOL_RBRACE = 60,                    /* RBRACE  */
  YYSYMBOL_DOT = 61,                       /* DOT  */
  YYSYMBOL_COMMA = 62,                     /* COMMA  */
  YYSYMBOL_SEMI = 63,                      /* SEMI  */
  YYSYMBOL_COLON = 64,                     /* COLON  */
  YYSYMBOL_SLASH = 65,                     /* SLASH  */
  YYSYMBOL_PERCENT = 66,                   /* PERCENT  */
  YYSYMBOL_EQUALS = 67,                    /* EQUALS  */
  YYSYMBOL_PLUS = 68,                      /* PLUS  */
  YYSYMBOL_MINUS = 69,                     /* MINUS  */
  YYSYMBOL_TIMES = 70,                     /* TIMES  */
  YYSYMBOL_AMP = 71,                       /* AMP  */
  YYSYMBOL_CIRC = 72,                      /* CIRC  */
  YYSYMBOL_PIPE = 73,                      /* PIPE  */
  YYSYMBOL_TILDE = 74,                     /* TILDE  */
  YYSYMBOL_BANG = 75,                      /* BANG  */
  YYSYMBOL_QUESTION = 76,                  /* QUESTION  */
  YYSYMBOL_LEQ = 77,                       /* LEQ  */
  YYSYMBOL_GEQ = 78,                       /* GEQ  */
  YYSYMBOL_EQ = 79,                        /* EQ  */
  YYSYMBOL_NEQ = 80,                       /* NEQ  */
  YYSYMBOL_SHL = 81,                       /* SHL  */
  YYSYMBOL_SHRS = 82,                      /* SHRS  */
  YYSYMBOL_SHRZ = 83,                      /* SHRZ  */
  YYSYMBOL_LABEL = 84,                     /* LABEL  */
  YYSYMBOL_IDENT = 85,                     /* IDENT  */
  YYSYMBOL_BUILTIN_NULL = 86,              /* BUILTIN_NULL  */
  YYSYMBOL_BUILTIN = 87,                   /* BUILTIN  */
  YYSYMBOL_STRING_LIT = 88,                /* STRING_LIT  */
  YYSYMBOL_NEWLINE = 89,                   /* NEWLINE  */
  YYSYMBOL_RTWRITE_OPTION = 90,            /* RTWRITE_OPTION  */
  YYSYMBOL_MEDIA_MODE = 91,                /* MEDIA_MODE  */
  YYSYMBOL_OWORD_MODIFIER = 92,            /* OWORD_MODIFIER  */
  YYSYMBOL_SAMPLER_CHANNEL = 93,           /* SAMPLER_CHANNEL  */
  YYSYMBOL_CHANNEL_OUTPUT = 94,            /* CHANNEL_OUTPUT  */
  YYSYMBOL_EXECMODE = 95,                  /* EXECMODE  */
  YYSYMBOL_CNTRL = 96,                     /* CNTRL  */
  YYSYMBOL_FENCE_OPTIONS = 97,             /* FENCE_OPTIONS  */
  YYSYMBOL_ADDR_ADD_OP = 98,               /* ADDR_ADD_OP  */
  YYSYMBOL_UNARY_LOGIC_OP = 99,            /* UNARY_LOGIC_OP  */
  YYSYMBOL_BINARY_LOGIC_OP = 100,          /* BINARY_LOGIC_OP  */
  YYSYMBOL_TERNARY_LOGIC_OP = 101,         /* TERNARY_LOGIC_OP  */
  YYSYMBOL_QUATERNARY_LOGIC_OP = 102,      /* QUATERNARY_LOGIC_OP  */
  YYSYMBOL_SEL_OP = 103,                   /* SEL_OP  */
  YYSYMBOL_MIN_OP = 104,                   /* MIN_OP  */
  YYSYMBOL_MAX_OP = 105,                   /* MAX_OP  */
  YYSYMBOL_ANTI_TRIG_OP = 106,             /* ANTI_TRIG_OP  */
  YYSYMBOL_MATH2_OP = 107,                 /* MATH2_OP  */
  YYSYMBOL_MATH3_OP = 108,                 /* MATH3_OP  */
  YYSYMBOL_ARITH2_OP = 109,                /* ARITH2_OP  */
  YYSYMBOL_ARITH3_OP = 110,                /* ARITH3_OP  */
  YYSYMBOL_ARITH4_OP = 111,                /* ARITH4_OP  */
  YYSYMBOL_ARITH4_OP2 = 112,               /* ARITH4_OP2  */
  YYSYMBOL_CMP_OP = 113,                   /* CMP_OP  */
  YYSYMBOL_SVM_OP = 114,                   /* SVM_OP  */
  YYSYMBOL_SVM_SCATTER_OP = 115,           /* SVM_SCATTER_OP  */
  YYSYMBOL_SVM_GATHER4SCALED_OP = 116,     /* SVM_GATHER4SCALED_OP  */
  YYSYMBOL_SVM_SCATTER4SCALED_OP = 117,    /* SVM_SCATTER4SCALED_OP  */
  YYSYMBOL_SVM_ATOMIC_OP = 118,            /* SVM_ATOMIC_OP  */
  YYSYMBOL_OWORD_OP = 119,                 /* OWORD_OP  */
  YYSYMBOL_MEDIA_OP = 120,                 /* MEDIA_OP  */
  YYSYMBOL_SCATTER_OP = 121,               /* SCATTER_OP  */
  YYSYMBOL_SCATTER_TYPED_OP = 122,         /* SCATTER_TYPED_OP  */
  YYSYMBOL_SCATTER_SCALED_OP = 123,        /* SCATTER_SCALED_OP  */
  YYSYMBOL_SCATTER4_SCALED_OP = 124,       /* SCATTER4_SCALED_OP  */
  YYSYMBOL_BARRIER_OP = 125,               /* BARRIER_OP  */
  YYSYMBOL_SBARRIER_SIGNAL = 126,          /* SBARRIER_SIGNAL  */
  YYSYMBOL_SBARRIER_WAIT = 127,            /* SBARRIER_WAIT  */
  YYSYMBOL_DWORD_ATOMIC_OP = 128,          /* DWORD_ATOMIC_OP  */
  YYSYMBOL_TYPED_ATOMIC_OP = 129,          /* TYPED_ATOMIC_OP  */
  YYSYMBOL_SAMPLE_OP = 130,                /* SAMPLE_OP  */
  YYSYMBOL_SAMPLE_UNORM_OP = 131,          /* SAMPLE_UNORM_OP  */
  YYSYMBOL_VME_IME_OP = 132,               /* VME_IME_OP  */
  YYSYMBOL_VME_SIC_OP = 133,               /* VME_SIC_OP  */
  YYSYMBOL_VME_FBR_OP = 134,               /* VME_FBR_OP  */
  YYSYMBOL_BRANCH_OP = 135,                /* BRANCH_OP  */
  YYSYMBOL_RET_OP = 136,                   /* RET_OP  */
  YYSYMBOL_IFCALL = 137,                   /* IFCALL  */
  YYSYMBOL_FCALL = 138,                    /* FCALL  */
  YYSYMBOL_FADDR = 139,                    /* FADDR  */
  YYSYMBOL_SWITCHJMP_OP = 140,             /* SWITCHJMP_OP  */
  YYSYMBOL_MOVS_OP = 141,                  /* MOVS_OP  */
  YYSYMBOL_SETP_OP = 142,                  /* SETP_OP  */
  YYSYMBOL_MOV_OP = 143,                   /* MOV_OP  */
  YYSYMBOL_FILE_OP = 144,                  /* FILE_OP  */
  YYSYMBOL_LOC_OP = 145,                   /* LOC_OP  */
  YYSYMBOL_CACHE_FLUSH_OP = 146,           /* CACHE_FLUSH_OP  */
  YYSYMBOL_WAIT_OP = 147,                  /* WAIT_OP  */
  YYSYMBOL_FENCE_GLOBAL_OP = 148,          /* FENCE_GLOBAL_OP  */
  YYSYMBOL_FENCE_LOCAL_OP = 149,           /* FENCE_LOCAL_OP  */
  YYSYMBOL_FENCE_SW_OP = 150,              /* FENCE_SW_OP  */
  YYSYMBOL_YIELD_OP = 151,                 /* YIELD_OP  */
  YYSYMBOL_SAMPLE_3D_OP = 152,             /* SAMPLE_3D_OP  */
  YYSYMBOL_LOAD_3D_OP = 153,               /* LOAD_3D_OP  */
  YYSYMBOL_SAMPLE4_3D_OP = 154,            /* SAMPLE4_3D_OP  */
  YYSYMBOL_RESINFO_OP_3D = 155,            /* RESINFO_OP_3D  */
  YYSYMBOL_SAMPLEINFO_OP_3D = 156,         /* SAMPLEINFO_OP_3D  */
  YYSYMBOL_RTWRITE_OP_3D = 157,            /* RTWRITE_OP_3D  */
  YYSYMBOL_URBWRITE_OP_3D = 158,           /* URBWRITE_OP_3D  */
  YYSYMBOL_LIFETIME_START_OP = 159,        /* LIFETIME_START_OP  */
  YYSYMBOL_LIFETIME_END_OP = 160,          /* LIFETIME_END_OP  */
  YYSYMBOL_AVS_OP = 161,                   /* AVS_OP  */
  YYSYMBOL_CALL_OP = 162,                  /* CALL_OP  */
  YYSYMBOL_PRED_CNTL = 163,                /* PRED_CNTL  */
  YYSYMBOL_F32_LIT = 164,                  /* F32_LIT  */
  YYSYMBOL_F64_LIT = 165,                  /* F64_LIT  */
  YYSYMBOL_DEC_LIT = 166,                  /* DEC_LIT  */
  YYSYMBOL_HEX_LIT = 167,                  /* HEX_LIT  */
  YYSYMBOL_BUILTIN_SIZEOF = 168,           /* BUILTIN_SIZEOF  */
  YYSYMBOL_BUILTIN_DISPATCH_SIMD_SIZE = 169, /* BUILTIN_DISPATCH_SIMD_SIZE  */
  YYSYMBOL_QW_SCATTER_OP = 170,            /* QW_SCATTER_OP  */
  YYSYMBOL_LSC_CACHING_OPT = 171,          /* LSC_CACHING_OPT  */
  YYSYMBOL_LSC_ADDR_SIZE_TK = 172,         /* LSC_ADDR_SIZE_TK  */
  YYSYMBOL_LSC_DATA_SHAPE_TK = 173,        /* LSC_DATA_SHAPE_TK  */
  YYSYMBOL_LSC_DATA_SHAPE_TK_CHMASK = 174, /* LSC_DATA_SHAPE_TK_CHMASK  */
  YYSYMBOL_LSC_DATA_SHAPE_TK_BLOCK2D = 175, /* LSC_DATA_SHAPE_TK_BLOCK2D  */
  YYSYMBOL_LSC_AM_FLAT = 176,              /* LSC_AM_FLAT  */
  YYSYMBOL_LSC_AM_BTI = 177,               /* LSC_AM_BTI  */
  YYSYMBOL_LSC_AM_BSS = 178,               /* LSC_AM_BSS  */
  YYSYMBOL_LSC_AM_SS = 179,                /* LSC_AM_SS  */
  YYSYMBOL_LSC_AM_ARG = 180,               /* LSC_AM_ARG  */
  YYSYMBOL_LSC_FENCE_OP_TYPE = 181,        /* LSC_FENCE_OP_TYPE  */
  YYSYMBOL_LSC_FENCE_SCOPE = 182,          /* LSC_FENCE_SCOPE  */
  YYSYMBOL_LSC_SFID_UNTYPED_TOKEN = 183,   /* LSC_SFID_UNTYPED_TOKEN  */
  YYSYMBOL_LSC_SFID_TYPED_TOKEN = 184,     /* LSC_SFID_TYPED_TOKEN  */
  YYSYMBOL_LSC_LOAD_MNEMONIC = 185,        /* LSC_LOAD_MNEMONIC  */
  YYSYMBOL_LSC_LOAD_STRIDED_MNEMONIC = 186, /* LSC_LOAD_STRIDED_MNEMONIC  */
  YYSYMBOL_LSC_LOAD_BLOCK2D_MNEMONIC = 187, /* LSC_LOAD_BLOCK2D_MNEMONIC  */
  YYSYMBOL_LSC_STORE_MNEMONIC = 188,       /* LSC_STORE_MNEMONIC  */
  YYSYMBOL_LSC_STORE_STRIDED_MNEMONIC = 189, /* LSC_STORE_STRIDED_MNEMONIC  */
  YYSYMBOL_LSC_STORE_BLOCK2D_MNEMONIC = 190, /* LSC_STORE_BLOCK2D_MNEMONIC  */
  YYSYMBOL_LSC_ATOMIC_MNEMONIC = 191,      /* LSC_ATOMIC_MNEMONIC  */
  YYSYMBOL_LSC_READ_STATE_INFO_MNEMONIC = 192, /* LSC_READ_STATE_INFO_MNEMONIC  */
  YYSYMBOL_LSC_FENCE_MNEMONIC = 193,       /* LSC_FENCE_MNEMONIC  */
  YYSYMBOL_FCVT_OP = 194,                  /* FCVT_OP  */
  YYSYMBOL_YYACCEPT = 195,                 /* $accept  */
  YYSYMBOL_Listing = 196,                  /* Listing  */
  YYSYMBOL_ListingHeader = 197,            /* ListingHeader  */
  YYSYMBOL_Statements = 198,               /* Statements  */
  YYSYMBOL_Newlines = 199,                 /* Newlines  */
  YYSYMBOL_NewlinesOpt = 200,              /* NewlinesOpt  */
  YYSYMBOL_Statement = 201,                /* Statement  */
  YYSYMBOL_Scope = 202,                    /* Scope  */
  YYSYMBOL_ScopeStart = 203,               /* ScopeStart  */
  YYSYMBOL_ScopeEnd = 204,                 /* ScopeEnd  */
  YYSYMBOL_IdentOrStringLit = 205,         /* IdentOrStringLit  */
  YYSYMBOL_DirectiveKernel = 206,          /* DirectiveKernel  */
  YYSYMBOL_DirectiveGlobalFunction = 207,  /* DirectiveGlobalFunction  */
  YYSYMBOL_DirectiveVersion = 208,         /* DirectiveVersion  */
  YYSYMBOL_DirectiveDecl = 209,            /* DirectiveDecl  */
  YYSYMBOL_DeclFunction = 210,             /* DeclFunction  */
  YYSYMBOL_DeclVariable = 211,             /* DeclVariable  */
  YYSYMBOL_DeclAddress = 212,              /* DeclAddress  */
  YYSYMBOL_DeclPredicate = 213,            /* DeclPredicate  */
  YYSYMBOL_DeclSampler = 214,              /* DeclSampler  */
  YYSYMBOL_VNameEqOpt = 215,               /* VNameEqOpt  */
  YYSYMBOL_DeclSurface = 216,              /* DeclSurface  */
  YYSYMBOL_DirectiveInput = 217,           /* DirectiveInput  */
  YYSYMBOL_DirectiveImplicitInput = 218,   /* DirectiveImplicitInput  */
  YYSYMBOL_InputOffset = 219,              /* InputOffset  */
  YYSYMBOL_InputSize = 220,                /* InputSize  */
  YYSYMBOL_DirectiveParameter = 221,       /* DirectiveParameter  */
  YYSYMBOL_DirectiveAttr = 222,            /* DirectiveAttr  */
  YYSYMBOL_DirectiveFunc = 223,            /* DirectiveFunc  */
  YYSYMBOL_AlignAttrOpt = 224,             /* AlignAttrOpt  */
  YYSYMBOL_Align = 225,                    /* Align  */
  YYSYMBOL_AliasAttrOpt = 226,             /* AliasAttrOpt  */
  YYSYMBOL_OneAttr = 227,                  /* OneAttr  */
  YYSYMBOL_AttrOpt = 228,                  /* AttrOpt  */
  YYSYMBOL_GenAttrOpt = 229,               /* GenAttrOpt  */
  YYSYMBOL_Instruction = 230,              /* Instruction  */
  YYSYMBOL_Label = 231,                    /* Label  */
  YYSYMBOL_LogicInstruction = 232,         /* LogicInstruction  */
  YYSYMBOL_UnaryLogicInstruction = 233,    /* UnaryLogicInstruction  */
  YYSYMBOL_MathInstruction_2OPND = 234,    /* MathInstruction_2OPND  */
  YYSYMBOL_MathInstruction_3OPND = 235,    /* MathInstruction_3OPND  */
  YYSYMBOL_ArithInstruction_2OPND = 236,   /* ArithInstruction_2OPND  */
  YYSYMBOL_ArithInstruction_3OPND = 237,   /* ArithInstruction_3OPND  */
  YYSYMBOL_ArithInstruction_4OPND = 238,   /* ArithInstruction_4OPND  */
  YYSYMBOL_DpasInstruction = 239,          /* DpasInstruction  */
  YYSYMBOL_BfnInstruction = 240,           /* BfnInstruction  */
  YYSYMBOL_QwScatterInstruction = 241,     /* QwScatterInstruction  */
  YYSYMBOL_FCvtInstruction = 242,          /* FCvtInstruction  */
  YYSYMBOL_AntiTrigInstruction = 243,      /* AntiTrigInstruction  */
  YYSYMBOL_AddrAddInstruction = 244,       /* AddrAddInstruction  */
  YYSYMBOL_SetpInstruction = 245,          /* SetpInstruction  */
  YYSYMBOL_SelInstruction = 246,           /* SelInstruction  */
  YYSYMBOL_MinInstruction = 247,           /* MinInstruction  */
  YYSYMBOL_MaxInstruction = 248,           /* MaxInstruction  */
  YYSYMBOL_MovInstruction = 249,           /* MovInstruction  */
  YYSYMBOL_MovsInstruction = 250,          /* MovsInstruction  */
  YYSYMBOL_CmpInstruction = 251,           /* CmpInstruction  */
  YYSYMBOL_MediaInstruction = 252,         /* MediaInstruction  */
  YYSYMBOL_MediaInstructionPlaneID = 253,  /* MediaInstructionPlaneID  */
  YYSYMBOL_ScatterInstruction = 254,       /* ScatterInstruction  */
  YYSYMBOL_ScatterTypedInstruction = 255,  /* ScatterTypedInstruction  */
  YYSYMBOL_Scatter4ScaledInstruction = 256, /* Scatter4ScaledInstruction  */
  YYSYMBOL_ScatterScaledInstruction = 257, /* ScatterScaledInstruction  */
  YYSYMBOL_SynchronizationInstruction = 258, /* SynchronizationInstruction  */
  YYSYMBOL_DwordAtomicInstruction = 259,   /* DwordAtomicInstruction  */
  YYSYMBOL_TypedAtomicInstruction = 260,   /* TypedAtomicInstruction  */
  YYSYMBOL_Atomic16Opt = 261,              /* Atomic16Opt  */
  YYSYMBOL_SampleUnormInstruction = 262,   /* SampleUnormInstruction  */
  YYSYMBOL_SampleInstruction = 263,        /* SampleInstruction  */
  YYSYMBOL_Sample3dInstruction = 264,      /* Sample3dInstruction  */
  YYSYMBOL_Sample3DInstruction = 265,      /* Sample3DInstruction  */
  YYSYMBOL_CPSEnableOpt = 266,             /* CPSEnableOpt  */
  YYSYMBOL_NonUniformSamplerEnableOpt = 267, /* NonUniformSamplerEnableOpt  */
  YYSYMBOL_Load3dInstruction = 268,        /* Load3dInstruction  */
  YYSYMBOL_Gather43dInstruction = 269,     /* Gather43dInstruction  */
  YYSYMBOL_Gather43DInstruction = 270,     /* Gather43DInstruction  */
  YYSYMBOL_PixelNullMaskEnableOpt = 271,   /* PixelNullMaskEnableOpt  */
  YYSYMBOL_ResInfo3dInstruction = 272,     /* ResInfo3dInstruction  */
  YYSYMBOL_SampleInfo3dInstruction = 273,  /* SampleInfo3dInstruction  */
  YYSYMBOL_RTWriteOperands = 274,          /* RTWriteOperands  */
  YYSYMBOL_RTWriteInstruction = 275,       /* RTWriteInstruction  */
  YYSYMBOL_RTWInstruction = 276,           /* RTWInstruction  */
  YYSYMBOL_RTWriteModeOpt = 277,           /* RTWriteModeOpt  */
  YYSYMBOL_URBWriteInstruction = 278,      /* URBWriteInstruction  */
  YYSYMBOL_AVSInstruction = 279,           /* AVSInstruction  */
  YYSYMBOL_VMEInstruction = 280,           /* VMEInstruction  */
  YYSYMBOL_OwordInstruction = 281,         /* OwordInstruction  */
  YYSYMBOL_SvmInstruction = 282,           /* SvmInstruction  */
  YYSYMBOL_AtomicBitwidthOpt = 283,        /* AtomicBitwidthOpt  */
  YYSYMBOL_LscInstruction = 284,           /* LscInstruction  */
  YYSYMBOL_LscUntypedLoad = 285,           /* LscUntypedLoad  */
  YYSYMBOL_LscUntypedStridedLoad = 286,    /* LscUntypedStridedLoad  */
  YYSYMBOL_LscUntypedBlock2dLoad = 287,    /* LscUntypedBlock2dLoad  */
  YYSYMBOL_LscUntypedStore = 288,          /* LscUntypedStore  */
  YYSYMBOL_LscUntypedStridedStore = 289,   /* LscUntypedStridedStore  */
  YYSYMBOL_LscUntypedBlock2dStore = 290,   /* LscUntypedBlock2dStore  */
  YYSYMBOL_LscUntypedAtomic = 291,         /* LscUntypedAtomic  */
  YYSYMBOL_LscTypedLoad = 292,             /* LscTypedLoad  */
  YYSYMBOL_LscTypedStore = 293,            /* LscTypedStore  */
  YYSYMBOL_LscTypedAtomic = 294,           /* LscTypedAtomic  */
  YYSYMBOL_LscTypedReadStateInfo = 295,    /* LscTypedReadStateInfo  */
  YYSYMBOL_LscFence = 296,                 /* LscFence  */
  YYSYMBOL_LscSfid = 297,                  /* LscSfid  */
  YYSYMBOL_LscCacheOpts = 298,             /* LscCacheOpts  */
  YYSYMBOL_LscUntypedAddrOperand = 299,    /* LscUntypedAddrOperand  */
  YYSYMBOL_LscUntypedStridedAddrOperand = 300, /* LscUntypedStridedAddrOperand  */
  YYSYMBOL_LscUntypedBlock2dAddrOperand = 301, /* LscUntypedBlock2dAddrOperand  */
  YYSYMBOL_LscTypedAddrOperand = 302,      /* LscTypedAddrOperand  */
  YYSYMBOL_LscAddrImmOffsetOpt = 303,      /* LscAddrImmOffsetOpt  */
  YYSYMBOL_LscAddrImmScaleOpt = 304,       /* LscAddrImmScaleOpt  */
  YYSYMBOL_LscAddrModelOpt = 305,          /* LscAddrModelOpt  */
  YYSYMBOL_LscRegAddrModel = 306,          /* LscRegAddrModel  */
  YYSYMBOL_LscRegAddrModelKind = 307,      /* LscRegAddrModelKind  */
  YYSYMBOL_LscVectorOpRegOrImm = 308,      /* LscVectorOpRegOrImm  */
  YYSYMBOL_LscVectorOpImm = 309,           /* LscVectorOpImm  */
  YYSYMBOL_LscVectorOpReg = 310,           /* LscVectorOpReg  */
  YYSYMBOL_LscDataOperand = 311,           /* LscDataOperand  */
  YYSYMBOL_LscDataOperand2D = 312,         /* LscDataOperand2D  */
  YYSYMBOL_LscPayloadReg = 313,            /* LscPayloadReg  */
  YYSYMBOL_LscPayloadNonNullReg = 314,     /* LscPayloadNonNullReg  */
  YYSYMBOL_SwitchLabels = 315,             /* SwitchLabels  */
  YYSYMBOL_BranchInstruction = 316,        /* BranchInstruction  */
  YYSYMBOL_FILE = 317,                     /* FILE  */
  YYSYMBOL_LOC = 318,                      /* LOC  */
  YYSYMBOL_RawSendInstruction = 319,       /* RawSendInstruction  */
  YYSYMBOL_LifetimeStartInst = 320,        /* LifetimeStartInst  */
  YYSYMBOL_LifetimeEndInst = 321,          /* LifetimeEndInst  */
  YYSYMBOL_RawSendsInstruction = 322,      /* RawSendsInstruction  */
  YYSYMBOL_NullaryInstruction = 323,       /* NullaryInstruction  */
  YYSYMBOL_OwordModifier = 324,            /* OwordModifier  */
  YYSYMBOL_Predicate = 325,                /* Predicate  */
  YYSYMBOL_PredSign = 326,                 /* PredSign  */
  YYSYMBOL_PredCtrlOpt = 327,              /* PredCtrlOpt  */
  YYSYMBOL_SatModOpt = 328,                /* SatModOpt  */
  YYSYMBOL_SrcModifier = 329,              /* SrcModifier  */
  YYSYMBOL_ConditionalModifier = 330,      /* ConditionalModifier  */
  YYSYMBOL_VecDstOperand_A = 331,          /* VecDstOperand_A  */
  YYSYMBOL_VecDstOperand_G = 332,          /* VecDstOperand_G  */
  YYSYMBOL_VecDstOperand_G_I = 333,        /* VecDstOperand_G_I  */
  YYSYMBOL_VecSrcOperand_G_I_IMM_A_AO = 334, /* VecSrcOperand_G_I_IMM_A_AO  */
  YYSYMBOL_VecSrcOperand_G_I_IMM_A = 335,  /* VecSrcOperand_G_I_IMM_A  */
  YYSYMBOL_VecSrcOperand_G_I_IMM = 336,    /* VecSrcOperand_G_I_IMM  */
  YYSYMBOL_VecSrcOperand_G_IMM = 337,      /* VecSrcOperand_G_IMM  */
  YYSYMBOL_VecSrcOperand_G_IMM_AO = 338,   /* VecSrcOperand_G_IMM_AO  */
  YYSYMBOL_VecSrcOperand_G_A = 339,        /* VecSrcOperand_G_A  */
  YYSYMBOL_VecSrcOperand_G_A_AO = 340,     /* VecSrcOperand_G_A_AO  */
  YYSYMBOL_VecSrcOperand_G = 341,          /* VecSrcOperand_G  */
  YYSYMBOL_VecSrcOpndSimple = 342,         /* VecSrcOpndSimple  */
  YYSYMBOL_VMEOpndIME = 343,               /* VMEOpndIME  */
  YYSYMBOL_VMEOpndFBR = 344,               /* VMEOpndFBR  */
  YYSYMBOL_SrcStateOperand = 345,          /* SrcStateOperand  */
  YYSYMBOL_DstStateOperand = 346,          /* DstStateOperand  */
  YYSYMBOL_RawOperand = 347,               /* RawOperand  */
  YYSYMBOL_RawOperandNonNull = 348,        /* RawOperandNonNull  */
  YYSYMBOL_RawOperandOffsetSuffix = 349,   /* RawOperandOffsetSuffix  */
  YYSYMBOL_RawOperandArray = 350,          /* RawOperandArray  */
  YYSYMBOL_DstAddrOperand = 351,           /* DstAddrOperand  */
  YYSYMBOL_DstGeneralOperand = 352,        /* DstGeneralOperand  */
  YYSYMBOL_DstIndirectOperand = 353,       /* DstIndirectOperand  */
  YYSYMBOL_SrcAddrOfOperand = 354,         /* SrcAddrOfOperand  */
  YYSYMBOL_AddrOfVar = 355,                /* AddrOfVar  */
  YYSYMBOL_SrcAddrOperand = 356,           /* SrcAddrOperand  */
  YYSYMBOL_SrcGeneralOperand = 357,        /* SrcGeneralOperand  */
  YYSYMBOL_SrcImmOperand = 358,            /* SrcImmOperand  */
  YYSYMBOL_FloatLit = 359,                 /* FloatLit  */
  YYSYMBOL_DoubleFloatLit = 360,           /* DoubleFloatLit  */
  YYSYMBOL_SrcIndirectOperand = 361,       /* SrcIndirectOperand  */
  YYSYMBOL_DstRegion = 362,                /* DstRegion  */
  YYSYMBOL_SrcRegionDirect = 363,          /* SrcRegionDirect  */
  YYSYMBOL_SrcRegionIndirect = 364,        /* SrcRegionIndirect  */
  YYSYMBOL_IndirectVarAccess = 365,        /* IndirectVarAccess  */
  YYSYMBOL_TwoDimOffset = 366,             /* TwoDimOffset  */
  YYSYMBOL_PredVar = 367,                  /* PredVar  */
  YYSYMBOL_AddrVarAccess = 368,            /* AddrVarAccess  */
  YYSYMBOL_AddrVarAccessWithWidth = 369,   /* AddrVarAccessWithWidth  */
  YYSYMBOL_SIMDMode = 370,                 /* SIMDMode  */
  YYSYMBOL_ElemNum = 371,                  /* ElemNum  */
  YYSYMBOL_ExecSize = 372,                 /* ExecSize  */
  YYSYMBOL_ExecSizeInt = 373,              /* ExecSizeInt  */
  YYSYMBOL_Var = 374,                      /* Var  */
  YYSYMBOL_VarNonNull = 375,               /* VarNonNull  */
  YYSYMBOL_IntExp = 376,                   /* IntExp  */
  YYSYMBOL_IntExpCond = 377,               /* IntExpCond  */
  YYSYMBOL_IntExpAND = 378,                /* IntExpAND  */
  YYSYMBOL_IntExpXOR = 379,                /* IntExpXOR  */
  YYSYMBOL_IntExpOR = 380,                 /* IntExpOR  */
  YYSYMBOL_IntExpCmp = 381,                /* IntExpCmp  */
  YYSYMBOL_IntExpRel = 382,                /* IntExpRel  */
  YYSYMBOL_IntExpNRA = 383,                /* IntExpNRA  */
  YYSYMBOL_IntExpShift = 384,              /* IntExpShift  */
  YYSYMBOL_IntExpAdd = 385,                /* IntExpAdd  */
  YYSYMBOL_IntExpMul = 386,                /* IntExpMul  */
  YYSYMBOL_IntExpUnr = 387,                /* IntExpUnr  */
  YYSYMBOL_IntExpPrim = 388,               /* IntExpPrim  */
  YYSYMBOL_DataType = 389,                 /* DataType  */
  YYSYMBOL_DataTypeIntOrVector = 390       /* DataTypeIntOrVector  */
};
typedef enum yysymbol_kind_t yysymbol_kind_t;




#ifdef short
# undef short
#endif

/* On compilers that do not define __PTRDIFF_MAX__ etc., make sure
   <limits.h> and (if available) <stdint.h> are included
   so that the code can choose integer types of a good width.  */

#ifndef __PTRDIFF_MAX__
# include <limits.h> /* INFRINGES ON USER NAME SPACE */
# if defined __STDC_VERSION__ && 199901 <= __STDC_VERSION__
#  include <stdint.h> /* INFRINGES ON USER NAME SPACE */
#  define YY_STDINT_H
# endif
#endif

/* Narrow types that promote to a signed type and that can represent a
   signed or unsigned integer of at least N bits.  In tables they can
   save space and decrease cache pressure.  Promoting to a signed type
   helps avoid bugs in integer arithmetic.  */

#ifdef __INT_LEAST8_MAX__
typedef __INT_LEAST8_TYPE__ yytype_int8;
#elif defined YY_STDINT_H
typedef int_least8_t yytype_int8;
#else
typedef signed char yytype_int8;
#endif

#ifdef __INT_LEAST16_MAX__
typedef __INT_LEAST16_TYPE__ yytype_int16;
#elif defined YY_STDINT_H
typedef int_least16_t yytype_int16;
#else
typedef short yytype_int16;
#endif

/* Work around bug in HP-UX 11.23, which defines these macros
   incorrectly for preprocessor constants.  This workaround can likely
   be removed in 2023, as HPE has promised support for HP-UX 11.23
   (aka HP-UX 11i v2) only through the end of 2022; see Table 2 of
   <https://h20195.www2.hpe.com/V2/getpdf.aspx/4AA4-7673ENW.pdf>.  */
#ifdef __hpux
# undef UINT_LEAST8_MAX
# undef UINT_LEAST16_MAX
# define UINT_LEAST8_MAX 255
# define UINT_LEAST16_MAX 65535
#endif

#if defined __UINT_LEAST8_MAX__ && __UINT_LEAST8_MAX__ <= __INT_MAX__
typedef __UINT_LEAST8_TYPE__ yytype_uint8;
#elif (!defined __UINT_LEAST8_MAX__ && defined YY_STDINT_H \
       && UINT_LEAST8_MAX <= INT_MAX)
typedef uint_least8_t yytype_uint8;
#elif !defined __UINT_LEAST8_MAX__ && UCHAR_MAX <= INT_MAX
typedef unsigned char yytype_uint8;
#else
typedef short yytype_uint8;
#endif

#if defined __UINT_LEAST16_MAX__ && __UINT_LEAST16_MAX__ <= __INT_MAX__
typedef __UINT_LEAST16_TYPE__ yytype_uint16;
#elif (!defined __UINT_LEAST16_MAX__ && defined YY_STDINT_H \
       && UINT_LEAST16_MAX <= INT_MAX)
typedef uint_least16_t yytype_uint16;
#elif !defined __UINT_LEAST16_MAX__ && USHRT_MAX <= INT_MAX
typedef unsigned short yytype_uint16;
#else
typedef int yytype_uint16;
#endif

#ifndef YYPTRDIFF_T
# if defined __PTRDIFF_TYPE__ && defined __PTRDIFF_MAX__
#  define YYPTRDIFF_T __PTRDIFF_TYPE__
#  define YYPTRDIFF_MAXIMUM __PTRDIFF_MAX__
# elif defined PTRDIFF_MAX
#  ifndef ptrdiff_t
#   include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  endif
#  define YYPTRDIFF_T ptrdiff_t
#  define YYPTRDIFF_MAXIMUM PTRDIFF_MAX
# else
#  define YYPTRDIFF_T long
#  define YYPTRDIFF_MAXIMUM LONG_MAX
# endif
#endif

#ifndef YYSIZE_T
# ifdef __SIZE_TYPE__
#  define YYSIZE_T __SIZE_TYPE__
# elif defined size_t
#  define YYSIZE_T size_t
# elif defined __STDC_VERSION__ && 199901 <= __STDC_VERSION__
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# else
#  define YYSIZE_T unsigned
# endif
#endif

#define YYSIZE_MAXIMUM                                  \
  YY_CAST (YYPTRDIFF_T,                                 \
           (YYPTRDIFF_MAXIMUM < YY_CAST (YYSIZE_T, -1)  \
            ? YYPTRDIFF_MAXIMUM                         \
            : YY_CAST (YYSIZE_T, -1)))

#define YYSIZEOF(X) YY_CAST (YYPTRDIFF_T, sizeof (X))


/* Stored state numbers (used for stacks). */
typedef yytype_int16 yy_state_t;

/* State numbers in computations.  */
typedef int yy_state_fast_t;

#ifndef YY_
# if defined YYENABLE_NLS && YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> /* INFRINGES ON USER NAME SPACE */
#   define YY_(Msgid) dgettext ("bison-runtime", Msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(Msgid) Msgid
# endif
#endif


#ifndef YY_ATTRIBUTE_PURE
# if defined __GNUC__ && 2 < __GNUC__ + (96 <= __GNUC_MINOR__)
#  define YY_ATTRIBUTE_PURE __attribute__ ((__pure__))
# else
#  define YY_ATTRIBUTE_PURE
# endif
#endif

#ifndef YY_ATTRIBUTE_UNUSED
# if defined __GNUC__ && 2 < __GNUC__ + (7 <= __GNUC_MINOR__)
#  define YY_ATTRIBUTE_UNUSED __attribute__ ((__unused__))
# else
#  define YY_ATTRIBUTE_UNUSED
# endif
#endif

/* Suppress unused-variable warnings by "using" E.  */
#if ! defined lint || defined __GNUC__
# define YY_USE(E) ((void) (E))
#else
# define YY_USE(E) /* empty */
#endif

/* Suppress an incorrect diagnostic about yylval being uninitialized.  */
#if defined __GNUC__ && ! defined __ICC && 406 <= __GNUC__ * 100 + __GNUC_MINOR__
# if __GNUC__ * 100 + __GNUC_MINOR__ < 407
#  define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN                           \
    _Pragma ("GCC diagnostic push")                                     \
    _Pragma ("GCC diagnostic ignored \"-Wuninitialized\"")
# else
#  define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN                           \
    _Pragma ("GCC diagnostic push")                                     \
    _Pragma ("GCC diagnostic ignored \"-Wuninitialized\"")              \
    _Pragma ("GCC diagnostic ignored \"-Wmaybe-uninitialized\"")
# endif
# define YY_IGNORE_MAYBE_UNINITIALIZED_END      \
    _Pragma ("GCC diagnostic pop")
#else
# define YY_INITIAL_VALUE(Value) Value
#endif
#ifndef YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_END
#endif
#ifndef YY_INITIAL_VALUE
# define YY_INITIAL_VALUE(Value) /* Nothing. */
#endif

#if defined __cplusplus && defined __GNUC__ && ! defined __ICC && 6 <= __GNUC__
# define YY_IGNORE_USELESS_CAST_BEGIN                          \
    _Pragma ("GCC diagnostic push")                            \
    _Pragma ("GCC diagnostic ignored \"-Wuseless-cast\"")
# define YY_IGNORE_USELESS_CAST_END            \
    _Pragma ("GCC diagnostic pop")
#endif
#ifndef YY_IGNORE_USELESS_CAST_BEGIN
# define YY_IGNORE_USELESS_CAST_BEGIN
# define YY_IGNORE_USELESS_CAST_END
#endif


#define YY_ASSERT(E) ((void) (0 && (E)))

#if 1

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# ifdef YYSTACK_USE_ALLOCA
#  if YYSTACK_USE_ALLOCA
#   ifdef __GNUC__
#    define YYSTACK_ALLOC __builtin_alloca
#   elif defined __BUILTIN_VA_ARG_INCR
#    include <alloca.h> /* INFRINGES ON USER NAME SPACE */
#   elif defined _AIX
#    define YYSTACK_ALLOC __alloca
#   elif defined _MSC_VER
#    include <malloc.h> /* INFRINGES ON USER NAME SPACE */
#    define alloca _alloca
#   else
#    define YYSTACK_ALLOC alloca
#    if ! defined _ALLOCA_H && ! defined EXIT_SUCCESS
#     include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
      /* Use EXIT_SUCCESS as a witness for stdlib.h.  */
#     ifndef EXIT_SUCCESS
#      define EXIT_SUCCESS 0
#     endif
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's 'empty if-body' warning.  */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (0)
#  ifndef YYSTACK_ALLOC_MAXIMUM
    /* The OS might guarantee only one guard page at the bottom of the stack,
       and a page size can be as small as 4096 bytes.  So we cannot safely
       invoke alloca (N) if N exceeds 4096.  Use a slightly smaller number
       to allow for a few compiler-allocated temporary stack slots.  */
#   define YYSTACK_ALLOC_MAXIMUM 4032 /* reasonable circa 2006 */
#  endif
# else
#  define YYSTACK_ALLOC YYMALLOC
#  define YYSTACK_FREE YYFREE
#  ifndef YYSTACK_ALLOC_MAXIMUM
#   define YYSTACK_ALLOC_MAXIMUM YYSIZE_MAXIMUM
#  endif
#  if (defined __cplusplus && ! defined EXIT_SUCCESS \
       && ! ((defined YYMALLOC || defined malloc) \
             && (defined YYFREE || defined free)))
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   ifndef EXIT_SUCCESS
#    define EXIT_SUCCESS 0
#   endif
#  endif
#  ifndef YYMALLOC
#   define YYMALLOC malloc
#   if ! defined malloc && ! defined EXIT_SUCCESS
void *malloc (YYSIZE_T); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
#  ifndef YYFREE
#   define YYFREE free
#   if ! defined free && ! defined EXIT_SUCCESS
void free (void *); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
# endif
#endif /* 1 */

#if (! defined yyoverflow \
     && (! defined __cplusplus \
         || (defined YYSTYPE_IS_TRIVIAL && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  yy_state_t yyss_alloc;
  YYSTYPE yyvs_alloc;
};

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (YYSIZEOF (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (YYSIZEOF (yy_state_t) + YYSIZEOF (YYSTYPE)) \
      + YYSTACK_GAP_MAXIMUM)

# define YYCOPY_NEEDED 1

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack_alloc, Stack)                           \
    do                                                                  \
      {                                                                 \
        YYPTRDIFF_T yynewbytes;                                         \
        YYCOPY (&yyptr->Stack_alloc, Stack, yysize);                    \
        Stack = &yyptr->Stack_alloc;                                    \
        yynewbytes = yystacksize * YYSIZEOF (*Stack) + YYSTACK_GAP_MAXIMUM; \
        yyptr += yynewbytes / YYSIZEOF (*yyptr);                        \
      }                                                                 \
    while (0)

#endif

#if defined YYCOPY_NEEDED && YYCOPY_NEEDED
/* Copy COUNT objects from SRC to DST.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if defined __GNUC__ && 1 < __GNUC__
#   define YYCOPY(Dst, Src, Count) \
      __builtin_memcpy (Dst, Src, YY_CAST (YYSIZE_T, (Count)) * sizeof (*(Src)))
#  else
#   define YYCOPY(Dst, Src, Count)              \
      do                                        \
        {                                       \
          YYPTRDIFF_T yyi;                      \
          for (yyi = 0; yyi < (Count); yyi++)   \
            (Dst)[yyi] = (Src)[yyi];            \
        }                                       \
      while (0)
#  endif
# endif
#endif /* !YYCOPY_NEEDED */

/* YYFINAL -- State number of the termination state.  */
#define YYFINAL  5
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   3074

/* YYNTOKENS -- Number of terminals.  */
#define YYNTOKENS  195
/* YYNNTS -- Number of nonterminals.  */
#define YYNNTS  196
/* YYNRULES -- Number of rules.  */
#define YYNRULES  436
/* YYNSTATES -- Number of states.  */
#define YYNSTATES  1097

/* YYMAXUTOK -- Last valid token kind.  */
#define YYMAXUTOK   449


/* YYTRANSLATE(TOKEN-NUM) -- Symbol number corresponding to TOKEN-NUM
   as returned by yylex, with out-of-bounds checking.  */
#define YYTRANSLATE(YYX)                                \
  (0 <= (YYX) && (YYX) <= YYMAXUTOK                     \
   ? YY_CAST (yysymbol_kind_t, yytranslate[YYX])        \
   : YYSYMBOL_YYUNDEF)

/* YYTRANSLATE[TOKEN-NUM] -- Symbol number corresponding to TOKEN-NUM
   as returned by yylex.  */
static const yytype_uint8 yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    46,    47,    48,    49,    50,    51,    52,    53,    54,
      55,    56,    57,    58,    59,    60,    61,    62,    63,    64,
      65,    66,    67,    68,    69,    70,    71,    72,    73,    74,
      75,    76,    77,    78,    79,    80,    81,    82,    83,    84,
      85,    86,    87,    88,    89,    90,    91,    92,    93,    94,
      95,    96,    97,    98,    99,   100,   101,   102,   103,   104,
     105,   106,   107,   108,   109,   110,   111,   112,   113,   114,
     115,   116,   117,   118,   119,   120,   121,   122,   123,   124,
     125,   126,   127,   128,   129,   130,   131,   132,   133,   134,
     135,   136,   137,   138,   139,   140,   141,   142,   143,   144,
     145,   146,   147,   148,   149,   150,   151,   152,   153,   154,
     155,   156,   157,   158,   159,   160,   161,   162,   163,   164,
     165,   166,   167,   168,   169,   170,   171,   172,   173,   174,
     175,   176,   177,   178,   179,   180,   181,   182,   183,   184,
     185,   186,   187,   188,   189,   190,   191,   192,   193,   194
};

#if YYDEBUG
/* YYRLINE[YYN] -- Source line where rule number YYN was defined.  */
static const yytype_int16 yyrline[] =
{
       0,   623,   623,   628,   630,   630,   632,   632,   633,   633,
     636,   637,   638,   639,   640,   641,   642,   643,   644,   645,
     646,   651,   652,   653,   657,   661,   664,   664,   671,   679,
     687,   694,   695,   696,   697,   698,   699,   701,   708,   716,
     724,   731,   735,   735,   738,   746,   751,   763,   770,   778,
     778,   779,   786,   792,   796,   800,   804,   809,   815,   815,
     817,   821,   827,   835,   841,   846,   851,   857,   861,   865,
     871,   876,   882,   886,   896,   897,   898,   899,   900,   901,
     902,   903,   904,   905,   906,   907,   908,   909,   910,   911,
     912,   913,   914,   915,   916,   917,   918,   919,   920,   921,
     922,   923,   924,   925,   926,   927,   928,   929,   930,   931,
     932,   933,   934,   935,   936,   937,   938,   939,   940,   941,
     942,   943,   944,   945,   948,   952,   958,   963,   969,   977,
     983,   990,   997,  1004,  1011,  1023,  1030,  1039,  1049,  1055,
    1062,  1068,  1077,  1087,  1094,  1101,  1109,  1118,  1125,  1132,
    1138,  1144,  1150,  1168,  1175,  1185,  1193,  1200,  1207,  1216,
    1225,  1234,  1242,  1245,  1248,  1251,  1254,  1259,  1266,  1274,
    1275,  1281,  1290,  1298,  1305,  1308,  1323,  1323,  1325,  1325,
    1328,  1340,  1343,  1356,  1356,  1359,  1367,  1375,  1378,  1382,
    1387,  1390,  1402,  1402,  1406,  1414,  1426,  1442,  1448,  1461,
    1469,  1476,  1482,  1488,  1494,  1501,  1502,  1511,  1512,  1513,
    1515,  1516,  1517,  1519,  1522,  1523,  1524,  1525,  1527,  1549,
    1580,  1609,  1634,  1658,  1685,  1711,  1745,  1785,  1825,  1856,
    1891,  1896,  1896,  1899,  1900,  1901,  1905,  1914,  1920,  1928,
    1951,  1962,  1973,  1984,  1997,  1998,  1999,  2006,  2007,  2010,
    2011,  2012,  2013,  2017,  2022,  2023,  2024,  2026,  2026,  2029,
    2034,  2042,  2050,  2064,  2068,  2074,  2079,  2082,  2086,  2089,
    2094,  2097,  2100,  2107,  2111,  2115,  2119,  2125,  2130,  2137,
    2142,  2147,  2153,  2160,  2167,  2173,  2179,  2187,  2195,  2203,
    2212,  2217,  2222,  2227,  2232,  2237,  2242,  2247,  2252,  2252,
    2258,  2263,  2268,  2268,  2270,  2270,  2273,  2273,  2276,  2277,
    2278,  2279,  2281,  2281,  2286,  2287,  2289,  2290,  2294,  2295,
    2298,  2299,  2302,  2303,  2304,  2307,  2308,  2311,  2312,  2313,
    2316,  2317,  2320,  2321,  2323,  2325,  2335,  2342,  2350,  2358,
    2377,  2389,  2396,  2408,  2413,  2420,  2425,  2433,  2441,  2447,
    2452,  2474,  2478,  2484,  2494,  2502,  2509,  2519,  2525,  2532,
    2536,  2541,  2545,  2551,  2552,  2559,  2567,  2568,  2574,  2584,
    2592,  2601,  2619,  2633,  2636,  2647,  2658,  2663,  2668,  2676,
    2685,  2697,  2711,  2713,  2724,  2736,  2742,  2750,  2759,  2759,
    2760,  2760,  2763,  2765,  2766,  2768,  2769,  2771,  2772,  2774,
    2775,  2777,  2778,  2779,  2781,  2782,  2783,  2784,  2785,  2802,
    2805,  2806,  2807,  2808,  2810,  2811,  2812,  2814,  2815,  2820,
    2825,  2827,  2828,  2829,  2830,  2834,  2835,  2837,  2841,  2845,
    2851,  2860,  2861,  2862,  2863,  2865,  2866
};
#endif

/** Accessing symbol of state STATE.  */
#define YY_ACCESSING_SYMBOL(State) YY_CAST (yysymbol_kind_t, yystos[State])

#if 1
/* The user-facing name of the symbol whose (internal) number is
   YYSYMBOL.  No bounds checking.  */
static const char *yysymbol_name (yysymbol_kind_t yysymbol) YY_ATTRIBUTE_UNUSED;

/* YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals.  */
static const char *const yytname[] =
{
  "\"end of file\"", "error", "\"invalid token\"", "ALIGN_KEYWORD",
  "ATOMIC_SUB_OP", "DIRECTIVE_DECL", "DIRECTIVE_FUNC",
  "DIRECTIVE_FUNCDECL", "DIRECTIVE_GLOBAL_FUNC", "DIRECTIVE_IMPLICIT",
  "DIRECTIVE_INPUT", "DIRECTIVE_KERNEL", "DIRECTIVE_KERNEL_ATTR",
  "DIRECTIVE_PARAMETER", "DIRECTIVE_VERSION", "ALIAS_EQ", "ALIGN_EQ",
  "ATTR_EQ", "OFFSET_EQ", "NUM_ELTS_EQ", "V_NAME_EQ", "SIZE_EQ",
  "V_TYPE_EQ_G", "V_TYPE_EQ_P", "V_TYPE_EQ_A", "V_TYPE_EQ_S",
  "V_TYPE_EQ_T", "CPS", "NON_UNIFORM_SAMPLER", "PIXEL_NULL_MASK",
  "RAW_SENDC_STRING", "RAW_SENDSC_EOT_STRING", "RAW_SENDSC_STRING",
  "RAW_SENDS_EOT_STRING", "RAW_SENDS_STRING", "RAW_SEND_STRING", "SAT",
  "SRCMOD_ABS", "SRCMOD_NEG", "SRCMOD_NEGABS", "SRCMOD_NOT", "BFN_OP",
  "DPAS_OP", "NBARRIER_SIGNAL", "NBARRIER_WAIT", "ITYPE", "DECL_DATA_TYPE",
  "DFTYPE", "FTYPE", "HFTYPE", "VTYPE", "COND_MOD", "LANGLE", "RANGLE",
  "LBRACK", "RBRACK", "IND_LBRACK", "LPAREN", "RPAREN", "LBRACE", "RBRACE",
  "DOT", "COMMA", "SEMI", "COLON", "SLASH", "PERCENT", "EQUALS", "PLUS",
  "MINUS", "TIMES", "AMP", "CIRC", "PIPE", "TILDE", "BANG", "QUESTION",
  "LEQ", "GEQ", "EQ", "NEQ", "SHL", "SHRS", "SHRZ", "LABEL", "IDENT",
  "BUILTIN_NULL", "BUILTIN", "STRING_LIT", "NEWLINE", "RTWRITE_OPTION",
  "MEDIA_MODE", "OWORD_MODIFIER", "SAMPLER_CHANNEL", "CHANNEL_OUTPUT",
  "EXECMODE", "CNTRL", "FENCE_OPTIONS", "ADDR_ADD_OP", "UNARY_LOGIC_OP",
  "BINARY_LOGIC_OP", "TERNARY_LOGIC_OP", "QUATERNARY_LOGIC_OP", "SEL_OP",
  "MIN_OP", "MAX_OP", "ANTI_TRIG_OP", "MATH2_OP", "MATH3_OP", "ARITH2_OP",
  "ARITH3_OP", "ARITH4_OP", "ARITH4_OP2", "CMP_OP", "SVM_OP",
  "SVM_SCATTER_OP", "SVM_GATHER4SCALED_OP", "SVM_SCATTER4SCALED_OP",
  "SVM_ATOMIC_OP", "OWORD_OP", "MEDIA_OP", "SCATTER_OP",
  "SCATTER_TYPED_OP", "SCATTER_SCALED_OP", "SCATTER4_SCALED_OP",
  "BARRIER_OP", "SBARRIER_SIGNAL", "SBARRIER_WAIT", "DWORD_ATOMIC_OP",
  "TYPED_ATOMIC_OP", "SAMPLE_OP", "SAMPLE_UNORM_OP", "VME_IME_OP",
  "VME_SIC_OP", "VME_FBR_OP", "BRANCH_OP", "RET_OP", "IFCALL", "FCALL",
  "FADDR", "SWITCHJMP_OP", "MOVS_OP", "SETP_OP", "MOV_OP", "FILE_OP",
  "LOC_OP", "CACHE_FLUSH_OP", "WAIT_OP", "FENCE_GLOBAL_OP",
  "FENCE_LOCAL_OP", "FENCE_SW_OP", "YIELD_OP", "SAMPLE_3D_OP",
  "LOAD_3D_OP", "SAMPLE4_3D_OP", "RESINFO_OP_3D", "SAMPLEINFO_OP_3D",
  "RTWRITE_OP_3D", "URBWRITE_OP_3D", "LIFETIME_START_OP",
  "LIFETIME_END_OP", "AVS_OP", "CALL_OP", "PRED_CNTL", "F32_LIT",
  "F64_LIT", "DEC_LIT", "HEX_LIT", "BUILTIN_SIZEOF",
  "BUILTIN_DISPATCH_SIMD_SIZE", "QW_SCATTER_OP", "LSC_CACHING_OPT",
  "LSC_ADDR_SIZE_TK", "LSC_DATA_SHAPE_TK", "LSC_DATA_SHAPE_TK_CHMASK",
  "LSC_DATA_SHAPE_TK_BLOCK2D", "LSC_AM_FLAT", "LSC_AM_BTI", "LSC_AM_BSS",
  "LSC_AM_SS", "LSC_AM_ARG", "LSC_FENCE_OP_TYPE", "LSC_FENCE_SCOPE",
  "LSC_SFID_UNTYPED_TOKEN", "LSC_SFID_TYPED_TOKEN", "LSC_LOAD_MNEMONIC",
  "LSC_LOAD_STRIDED_MNEMONIC", "LSC_LOAD_BLOCK2D_MNEMONIC",
  "LSC_STORE_MNEMONIC", "LSC_STORE_STRIDED_MNEMONIC",
  "LSC_STORE_BLOCK2D_MNEMONIC", "LSC_ATOMIC_MNEMONIC",
  "LSC_READ_STATE_INFO_MNEMONIC", "LSC_FENCE_MNEMONIC", "FCVT_OP",
  "$accept", "Listing", "ListingHeader", "Statements", "Newlines",
  "NewlinesOpt", "Statement", "Scope", "ScopeStart", "ScopeEnd",
  "IdentOrStringLit", "DirectiveKernel", "DirectiveGlobalFunction",
  "DirectiveVersion", "DirectiveDecl", "DeclFunction", "DeclVariable",
  "DeclAddress", "DeclPredicate", "DeclSampler", "VNameEqOpt",
  "DeclSurface", "DirectiveInput", "DirectiveImplicitInput", "InputOffset",
  "InputSize", "DirectiveParameter", "DirectiveAttr", "DirectiveFunc",
  "AlignAttrOpt", "Align", "AliasAttrOpt", "OneAttr", "AttrOpt",
  "GenAttrOpt", "Instruction", "Label", "LogicInstruction",
  "UnaryLogicInstruction", "MathInstruction_2OPND",
  "MathInstruction_3OPND", "ArithInstruction_2OPND",
  "ArithInstruction_3OPND", "ArithInstruction_4OPND", "DpasInstruction",
  "BfnInstruction", "QwScatterInstruction", "FCvtInstruction",
  "AntiTrigInstruction", "AddrAddInstruction", "SetpInstruction",
  "SelInstruction", "MinInstruction", "MaxInstruction", "MovInstruction",
  "MovsInstruction", "CmpInstruction", "MediaInstruction",
  "MediaInstructionPlaneID", "ScatterInstruction",
  "ScatterTypedInstruction", "Scatter4ScaledInstruction",
  "ScatterScaledInstruction", "SynchronizationInstruction",
  "DwordAtomicInstruction", "TypedAtomicInstruction", "Atomic16Opt",
  "SampleUnormInstruction", "SampleInstruction", "Sample3dInstruction",
  "Sample3DInstruction", "CPSEnableOpt", "NonUniformSamplerEnableOpt",
  "Load3dInstruction", "Gather43dInstruction", "Gather43DInstruction",
  "PixelNullMaskEnableOpt", "ResInfo3dInstruction",
  "SampleInfo3dInstruction", "RTWriteOperands", "RTWriteInstruction",
  "RTWInstruction", "RTWriteModeOpt", "URBWriteInstruction",
  "AVSInstruction", "VMEInstruction", "OwordInstruction", "SvmInstruction",
  "AtomicBitwidthOpt", "LscInstruction", "LscUntypedLoad",
  "LscUntypedStridedLoad", "LscUntypedBlock2dLoad", "LscUntypedStore",
  "LscUntypedStridedStore", "LscUntypedBlock2dStore", "LscUntypedAtomic",
  "LscTypedLoad", "LscTypedStore", "LscTypedAtomic",
  "LscTypedReadStateInfo", "LscFence", "LscSfid", "LscCacheOpts",
  "LscUntypedAddrOperand", "LscUntypedStridedAddrOperand",
  "LscUntypedBlock2dAddrOperand", "LscTypedAddrOperand",
  "LscAddrImmOffsetOpt", "LscAddrImmScaleOpt", "LscAddrModelOpt",
  "LscRegAddrModel", "LscRegAddrModelKind", "LscVectorOpRegOrImm",
  "LscVectorOpImm", "LscVectorOpReg", "LscDataOperand", "LscDataOperand2D",
  "LscPayloadReg", "LscPayloadNonNullReg", "SwitchLabels",
  "BranchInstruction", "FILE", "LOC", "RawSendInstruction",
  "LifetimeStartInst", "LifetimeEndInst", "RawSendsInstruction",
  "NullaryInstruction", "OwordModifier", "Predicate", "PredSign",
  "PredCtrlOpt", "SatModOpt", "SrcModifier", "ConditionalModifier",
  "VecDstOperand_A", "VecDstOperand_G", "VecDstOperand_G_I",
  "VecSrcOperand_G_I_IMM_A_AO", "VecSrcOperand_G_I_IMM_A",
  "VecSrcOperand_G_I_IMM", "VecSrcOperand_G_IMM", "VecSrcOperand_G_IMM_AO",
  "VecSrcOperand_G_A", "VecSrcOperand_G_A_AO", "VecSrcOperand_G",
  "VecSrcOpndSimple", "VMEOpndIME", "VMEOpndFBR", "SrcStateOperand",
  "DstStateOperand", "RawOperand", "RawOperandNonNull",
  "RawOperandOffsetSuffix", "RawOperandArray", "DstAddrOperand",
  "DstGeneralOperand", "DstIndirectOperand", "SrcAddrOfOperand",
  "AddrOfVar", "SrcAddrOperand", "SrcGeneralOperand", "SrcImmOperand",
  "FloatLit", "DoubleFloatLit", "SrcIndirectOperand", "DstRegion",
  "SrcRegionDirect", "SrcRegionIndirect", "IndirectVarAccess",
  "TwoDimOffset", "PredVar", "AddrVarAccess", "AddrVarAccessWithWidth",
  "SIMDMode", "ElemNum", "ExecSize", "ExecSizeInt", "Var", "VarNonNull",
  "IntExp", "IntExpCond", "IntExpAND", "IntExpXOR", "IntExpOR",
  "IntExpCmp", "IntExpRel", "IntExpNRA", "IntExpShift", "IntExpAdd",
  "IntExpMul", "IntExpUnr", "IntExpPrim", "DataType",
  "DataTypeIntOrVector", YY_NULLPTR
};

static const char *
yysymbol_name (yysymbol_kind_t yysymbol)
{
  return yytname[yysymbol];
}
#endif

#define YYPACT_NINF (-983)

#define yypact_value_is_default(Yyn) \
  ((Yyn) == YYPACT_NINF)

#define YYTABLE_NINF (-426)

#define yytable_value_is_error(Yyn) \
  0

/* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
   STATE-NUM.  */
static const yytype_int16 yypact[] =
{
      -9,  -983,    70,    -3,    87,  -983,  -983,   -57,    -9,  -983,
      83,  2880,   -45,    65,   182,    68,   182,   124,   140,   182,
     162,   177,    97,   566,   566,   196,  -983,  -983,    97,   222,
      97,   201,   184,   246,  -983,  -983,  -983,   219,   242,   281,
     107,   295,   182,    97,    97,    97,   301,   188,  -983,  1124,
     331,   333,  -983,  -983,   338,   340,   309,   349,   342,   -18,
     400,    -9,  -983,  -983,  2557,  -983,  -983,  -983,  -983,  -983,
    -983,  -983,  -983,  -983,  -983,  -983,  -983,  -983,  -983,  -983,
    -983,  -983,  -983,  -983,  -983,  -983,  -983,  -983,  -983,  -983,
    -983,  -983,  -983,  -983,  -983,  -983,  -983,  -983,  -983,  -983,
    -983,  -983,  -983,  -983,  -983,  -983,  -983,  -983,  -983,  -983,
    -983,  -983,  -983,  -983,  -983,  -983,  -983,  -983,  -983,  -983,
    -983,  -983,  -983,  -983,  -983,  -983,  -983,  -983,  -983,  -983,
    -983,  -983,  -983,  -983,  -983,  -983,  -983,  -983,  -983,  -983,
    -983,  -983,  -983,  -983,  -983,  -983,  2797,  -983,   308,  -983,
    -983,  -983,  -983,  -983,   420,   420,  -983,   372,   419,   -51,
     288,  -983,  -983,  -983,  -983,   107,   189,   116,   189,   189,
    -983,  -983,  -983,  -983,  -983,   134,   330,   -24,  -983,   -11,
     566,  -983,  -983,  -983,  -983,  -983,  -983,   389,   385,  -983,
      -1,  -983,  -983,  -983,   107,   107,  -983,    97,   566,  -983,
      97,   385,   278,    97,   386,   352,   282,   107,   288,   566,
     107,   -11,   566,   107,   107,  -983,  -983,   107,  -983,  -983,
    -983,  -983,  -983,    97,    97,  -983,  -983,   107,  -983,  -983,
     268,  -983,    97,  2392,  -983,  -983,  2723,    97,   246,   246,
     246,   246,    97,   400,   400,   400,   400,   400,   400,   400,
     400,   400,   400,   400,   400,   400,   400,    97,   390,   354,
     357,   448,   362,   396,   367,   458,   462,    97,    97,    97,
      97,   400,   438,   438,   438,   379,    97,    97,   409,    20,
     289,   290,    48,   291,   292,    72,   293,   430,   459,   461,
     463,   464,   189,   110,   419,   446,   189,   467,  -983,   429,
     431,   434,   288,  -983,   436,    -2,   435,   189,  -983,  -983,
     433,  -983,    -4,   427,   428,  -983,   207,     5,  -983,   223,
      46,  -983,   270,  -983,  -983,  -983,  -983,  -983,  -983,  -983,
    -983,  -983,  -983,   415,  -983,   389,   385,  -983,   189,  -983,
     266,   189,   454,  -983,  -983,  -983,   339,  -983,   258,  -983,
    -983,   455,   -11,   288,   107,   107,  -983,   201,   345,   107,
     107,   451,   288,   288,   456,   288,  -983,  -983,  -983,   465,
      37,   466,   107,   566,  -983,    66,   566,   107,   107,   107,
     334,   107,  -983,  -983,    -9,  -983,   355,   246,   246,   246,
     246,   360,    97,    97,    97,    97,    97,    97,    97,    97,
      97,    97,    97,    97,    97,    97,   -11,   365,    97,    97,
     471,    97,   369,    97,   476,   476,   182,  -983,   566,   457,
      97,  -983,   516,   452,   453,  -983,    97,   381,   182,   382,
     380,   380,   380,   380,   380,   380,   380,   380,   380,   380,
     299,   531,   189,   189,   189,   189,  -983,   493,   467,  -983,
    -983,  -983,  -983,  -983,  -983,  -983,   387,   391,   288,   -26,
    -983,  -983,   189,   189,  -983,   189,   189,   189,   189,   189,
     189,   189,   189,   189,   189,   189,   189,   189,   189,   189,
     189,   189,   189,   497,   266,   454,   259,    10,  -983,  -983,
    -983,  -983,  -983,   494,   189,  -983,  -983,   500,   107,  -983,
    1062,  -983,  -983,   505,  -983,  -983,   503,   189,   566,   566,
      37,  -983,   566,  1103,   107,   504,   299,   107,   397,   288,
     288,   566,   288,   189,   266,  -983,   465,   -19,  -983,   509,
    -983,  -983,   511,   189,  -983,   288,   288,   566,  -983,  1124,
     512,   405,   246,   246,   246,   246,   407,   -11,   -11,   -11,
     -11,   -11,   -11,   -11,   -11,   -11,   -11,   -11,   -11,   -11,
     -11,   -11,   513,   566,   566,   412,    97,   107,    97,   107,
     414,    97,    97,  -983,   416,   417,   -11,  -983,   553,    97,
      97,   107,   418,  -983,    97,   421,    97,    97,    97,    97,
      97,    97,    97,    97,    97,    97,   434,   214,  -983,  -983,
     436,   189,   467,   467,   568,   568,   506,  -983,   532,  -983,
     107,   189,  -983,   534,   536,   427,     0,   428,  -983,  -983,
    -983,  -983,  -983,  -983,  -983,    46,    46,   273,   273,   273,
    -983,  -983,  -983,  -983,  -983,  -983,   432,   189,   189,   189,
     533,  -983,  -983,  -983,  -983,  -983,  -983,   189,   189,   537,
     566,   566,   288,   152,   566,   566,   566,  -983,   288,   288,
     566,   539,   288,  -983,   540,   288,   546,  -983,  -983,   -19,
     -19,   543,   189,   189,   125,   288,  -983,   566,  -983,  -983,
     441,    97,    97,   246,   246,   442,   566,   566,   107,   566,
     107,   566,   566,   566,   566,   566,   566,   566,   566,   566,
     566,   566,   566,   443,   288,   288,  -983,   288,   288,   107,
     566,  -983,   107,   107,   460,   468,   203,   203,    73,  -983,
     527,   566,   566,  -983,   288,   107,  -983,   299,   299,   299,
     299,   183,   214,   183,   445,   299,   299,  -983,  -983,  -983,
    -983,   567,   609,  -983,  -983,   545,   467,   467,   569,  -983,
     -10,  -983,  -983,   385,   580,  -983,  -983,   189,   586,   581,
     584,   589,   186,   593,  -983,  -983,  -983,   566,   288,   288,
     288,   288,   566,  -983,   288,   566,  -983,  -983,  -983,  -983,
    -983,   588,   195,  -983,  -983,   566,  1124,  1124,  1124,    97,
      97,  1124,   566,  -983,  -983,   566,   107,   566,   566,   566,
     566,   566,  -983,  -983,   566,  -983,   566,   566,   566,    97,
     288,   288,   288,   288,   566,   288,   288,   288,  -983,  -983,
    -983,  -983,  -983,  -983,  -983,  -983,  -983,   503,    97,   107,
     107,  1147,   288,   288,   183,   154,   214,   183,   445,   472,
    -983,  -983,   299,   594,  -983,   299,   595,  -983,   299,   601,
     602,   299,   183,   214,    60,    39,   642,  -983,  -983,  -983,
    -983,   450,  -983,   506,  -983,  -983,  -983,  -983,   189,  -983,
    -983,   189,   288,  -983,   288,   288,   288,   566,   288,   600,
    -983,   566,   288,  1124,  1124,  1124,  1124,   288,   566,  -983,
    -983,   566,   566,  -983,  -983,  -983,  -983,  -983,   566,  -983,
     288,  -983,  -983,   288,   288,   288,   288,   288,   288,   566,
     288,   107,  -983,  -983,   288,   288,  -983,  -983,  -983,  -983,
    -983,  -983,  -983,  -983,   189,  -983,   181,  -983,   189,   107,
    -983,   299,   299,   603,  -983,  -983,   204,  -983,  -983,  -983,
    -983,  -983,   607,   467,  -983,  -983,  -983,   612,   614,  -983,
    -983,  -983,   288,   566,   288,  -983,   566,   288,   288,   288,
    1124,  1124,   288,  -983,  -983,   566,  -983,   288,   288,   288,
     288,  -983,   288,   288,   107,  -983,   288,   288,  -983,   181,
      93,    30,  -983,   436,   181,   598,   299,   299,  -983,   189,
     496,    92,  -983,  -983,  -983,  -983,   288,  -983,   566,  -983,
     288,   288,   288,   288,  -983,  -983,  -983,  -983,   288,  -983,
     288,   288,   107,   288,  -983,  -983,   297,   189,   508,   181,
     297,    60,  -983,  -983,   619,  -983,  -983,   620,  -983,   566,
     288,   288,   288,   288,  -983,  -983,   288,   288,  -983,   288,
     189,    69,   629,  -983,    35,    36,   623,   189,   189,   590,
    -983,  -983,   288,   288,   288,  -983,   273,  -983,   517,   518,
     181,    60,    60,   633,   639,   566,  -983,  -983,   288,   288,
    -983,  -983,    40,   638,   634,  -983,  -983,   605,  -983,   525,
     181,   530,    60,   566,  -983,   646,  -983,   641,   288,   535,
      60,  -983,  -983,   643,    60,   649,  -983
};

/* YYDEFACT[STATE-NUM] -- Default reduction number in state STATE-NUM.
   Performed when YYTABLE does not specify something else to do.  Zero
   means the default is an error.  */
static const yytype_int16 yydefact[] =
{
       8,     7,     0,     9,     0,     1,     6,     0,     8,     3,
       0,   300,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   302,    24,   124,     0,   312,
       0,   298,     0,     0,   162,   163,   164,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   290,     0,
     293,   295,   297,   292,     0,     0,     0,     0,     0,     0,
     306,     8,     5,    20,     0,    11,    12,    10,    36,    31,
      32,    33,    34,    35,    14,    13,    15,    17,    16,    18,
      19,    74,    76,    77,    78,    79,    80,    81,   119,   120,
     121,   123,    82,    83,   104,   101,   102,   103,   100,    99,
      84,    85,    87,    88,    90,    89,    91,    93,    94,    96,
      95,   109,   174,   110,   111,   181,   112,   113,   114,   190,
     115,    98,    97,    86,    75,   122,   207,   208,   209,   210,
     211,   212,   213,   214,   215,   216,   217,   218,    92,   105,
     106,   107,   116,   117,   108,   118,     0,    30,     0,    26,
      27,    57,    37,    29,    49,    49,    28,    55,     0,     0,
       0,   309,   308,   310,   311,     0,     0,     0,     0,     0,
     390,   389,   391,   363,   366,   425,   426,     0,   430,     0,
       0,   322,   334,   324,   359,   361,   323,     0,     0,   388,
       0,   424,   166,   303,     0,     0,   313,     0,     0,   299,
       0,     0,     0,     0,   382,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   280,   281,     0,   291,   325,
     326,   294,   296,     0,     0,   284,   285,     0,   231,   232,
       0,   307,     0,   300,     2,    23,   300,     0,     0,     0,
       0,     0,     0,   306,   306,   306,   306,   306,   306,   306,
     306,   306,   306,   306,   306,   306,   306,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   306,   183,   183,   183,   192,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,    72,    46,    56,     0,    72,   387,     0,
       0,     0,     0,   340,     0,     0,     0,     0,   425,   426,
       0,   392,   394,   396,   398,   400,   403,   408,   409,   413,
     416,   420,   426,   360,   362,   421,   422,   423,   367,   364,
     368,   365,   358,     0,   428,     0,     0,   165,     0,   373,
       0,     0,     0,   435,   436,   357,   304,   379,     0,   314,
     347,     0,     0,     0,     0,     0,   384,   298,     0,     0,
       0,     0,     0,     0,     0,     0,   279,   316,   317,     0,
       0,     0,     0,     0,   315,     0,     0,     0,     0,     0,
       0,     0,     4,    25,     8,    21,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     205,     0,     0,     0,   169,   169,     0,   275,     0,     0,
       0,   184,   176,     0,     0,   193,     0,     0,     0,     0,
     233,   233,   233,   233,   233,   233,   233,   233,   233,   233,
       0,     0,     0,     0,     0,     0,    50,     0,    72,    48,
      45,    53,    54,    51,    52,   385,     0,     0,     0,     0,
     342,   377,     0,     0,   427,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   408,   432,   433,
     434,   369,   431,     0,     0,   355,   305,     0,     0,   332,
       0,   330,   333,   351,   331,   354,     0,     0,     0,     0,
     379,   200,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   349,     0,   270,   151,     0,
     152,   150,     0,     0,   143,     0,     0,     0,   230,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   273,     0,     0,     0,   177,   178,     0,
       0,     0,     0,   274,     0,   234,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   389,     0,   266,   267,
     388,     0,    72,    72,    42,    42,     0,    47,     0,   341,
       0,     0,   343,     0,     0,   395,     0,   397,   399,   401,
     402,   404,   405,   406,   407,   414,   415,   410,   411,   412,
     418,   419,   417,   429,   370,   356,     0,     0,   375,     0,
       0,   301,   353,   142,   327,   329,   328,     0,     0,     0,
       0,     0,     0,   157,     0,     0,     0,   383,     0,     0,
       0,     0,     0,   197,     0,     0,     0,   350,   348,   270,
     270,     0,     0,     0,     0,     0,   186,     0,   140,    22,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   206,     0,     0,     0,
       0,   170,     0,     0,     0,     0,     0,     0,     0,   179,
       0,     0,     0,   187,     0,     0,   235,     0,     0,     0,
       0,   249,     0,   249,     0,     0,     0,   256,   254,   255,
     229,     0,    58,    40,    39,     0,    72,    72,    69,    71,
       0,   386,   137,     0,     0,   376,   380,     0,     0,     0,
       0,     0,     0,     0,   154,   153,   199,     0,     0,     0,
       0,     0,     0,   336,     0,     0,   198,   371,   271,   272,
     276,     0,     0,   339,   185,     0,     0,     0,     0,     0,
       0,     0,     0,   129,   130,     0,     0,     0,     0,     0,
       0,     0,   141,   131,     0,   133,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   278,   277,
     148,   318,   320,   319,   321,   147,   149,   379,     0,     0,
       0,   191,     0,     0,   249,     0,     0,   249,     0,     0,
     250,   251,     0,     0,   252,     0,     0,   238,     0,     0,
       0,     0,   249,     0,     0,     0,    64,    59,    43,    41,
      44,     0,    73,     0,   335,   344,   393,   374,     0,   378,
     352,     0,     0,   156,     0,     0,     0,     0,     0,     0,
     338,     0,     0,     0,     0,     0,     0,     0,     0,   125,
     126,     0,     0,   144,   145,   146,   132,   134,     0,   136,
       0,   203,   204,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   188,   189,     0,     0,   219,   263,   264,   226,
     220,   221,   265,   222,   247,   227,     0,   223,   247,     0,
     224,     0,     0,     0,   258,   257,   260,   259,    63,    60,
      61,    62,     0,    72,    68,    67,    70,     0,     0,   155,
     158,   173,     0,     0,     0,   337,     0,     0,     0,     0,
       0,     0,     0,   138,   127,     0,   135,     0,     0,     0,
       0,   160,     0,     0,     0,   345,     0,     0,   139,     0,
       0,     0,   268,   269,     0,     0,     0,     0,   253,     0,
       0,     0,    38,   372,   381,   172,     0,   196,     0,   283,
       0,     0,     0,     0,   282,   128,   201,   202,     0,   161,
       0,     0,     0,   180,   345,   194,   244,   248,     0,     0,
     244,     0,   225,   228,     0,   261,    66,     0,   171,     0,
       0,     0,     0,     0,   159,   167,     0,     0,   346,   182,
       0,     0,     0,   240,     0,     0,     0,     0,     0,     0,
     289,   288,     0,     0,     0,   345,   245,   246,     0,     0,
       0,     0,     0,     0,     0,     0,   287,   286,     0,   175,
     236,   241,     0,     0,     0,   262,    65,     0,   168,     0,
       0,     0,     0,     0,   242,     0,   237,     0,     0,     0,
       0,   195,   243,     0,     0,     0,   239
};

/* YYPGOTO[NTERM-NUM].  */
static const yytype_int16 yypgoto[] =
{
    -983,  -983,  -983,   470,   -47,     4,   477,  -983,  -983,   169,
       9,  -983,  -983,  -983,  -983,  -983,  -983,  -983,  -983,  -983,
     106,  -983,  -983,  -983,   570,   103,  -983,  -983,  -983,  -983,
    -983,  -983,  -137,  -983,  -293,  -983,  -983,  -983,  -983,  -983,
    -983,  -983,  -983,  -983,  -983,  -983,  -983,  -983,  -983,  -983,
    -983,  -983,  -983,  -983,  -983,  -983,  -983,  -983,  -983,  -983,
    -983,  -983,  -983,  -983,  -983,  -983,   312,  -983,  -983,  -983,
    -983,  -983,  -983,  -983,  -983,  -983,   148,  -983,  -983,  -983,
    -983,  -983,  -983,  -983,  -983,  -983,  -983,  -983,  -983,  -983,
    -983,  -983,  -983,  -983,  -983,  -983,  -983,  -983,  -983,  -983,
    -983,  -983,  -983,   283,  -701,  -109,  -101,  -797,  -291,  -190,
    -696,  -584,  -983,  -962,  -983,  -188,  -681,  -106,  -422,  -938,
    -271,  -983,  -983,  -983,  -983,  -983,  -983,  -983,  -983,   393,
    -983,  -983,  -983,  1083,    28,  -983,   171,   370,  -337,    31,
    -983,   -23,  -537,  -983,  -983,  -983,    54,  -983,  -983,  -983,
     384,  -983,  1268,  -900,  -983,  -982,  -983,  -197,  -983,  -324,
    -983,   406,  -983,    61,   591,   592,  -983,  -352,  -313,   425,
     277,  -174,  -209,  -983,  -189,  -983,  -219,  1793,   305,   529,
     762,  -143,     6,   287,   300,   303,   296,   -43,  -335,  -983,
    -470,  -465,   -62,  -286,  -446,   576
};

/* YYDEFGOTO[NTERM-NUM].  */
static const yytype_int16 yydefgoto[] =
{
       0,     2,     8,    61,     3,     4,    62,    63,    64,   385,
     151,    65,    66,     9,    67,    68,    69,    70,    71,    72,
     746,    73,    74,    75,   293,   297,    76,    77,    78,   856,
     857,   943,   749,   750,   449,    79,    80,    81,    82,    83,
      84,    85,    86,    87,    88,    89,    90,    91,    92,    93,
      94,    95,    96,    97,    98,    99,   100,   101,   654,   102,
     103,   104,   105,   106,   107,   108,   571,   109,   110,   111,
     112,   578,   720,   113,   114,   115,   422,   116,   117,   831,
     118,   119,   426,   120,   121,   122,   123,   124,   566,   125,
     126,   127,   128,   129,   130,   131,   132,   133,   134,   135,
     136,   137,   230,   586,   847,   848,   851,   845,  1042,   979,
     843,   844,   741,   933,   934,   935,   834,   838,   835,   981,
     671,   138,   139,   140,   141,   142,   143,   144,   145,   200,
     146,   194,   497,   232,   179,   197,   348,   372,   366,   820,
     821,   822,   218,   643,   499,   500,   181,   752,   207,   210,
     528,   373,   598,   303,   460,  1013,   349,   367,   368,   823,
     503,   824,   182,   183,   184,   185,   186,   525,   339,   340,
     187,   342,   346,   305,   505,   359,   203,   160,   299,   188,
     189,   937,   311,   312,   313,   314,   315,   316,   317,   318,
     319,   320,   190,   191,   491,   492
};

/* YYTABLE[YYPACT[STATE-NUM]] -- What to do in state STATE-NUM.  If
   positive, shift that token.  If negative, reduce the rule whose
   number is the opposite.  If YYTABLE_NINF, syntax error.  */
static const yytype_int16 yytable[] =
{
     180,   192,   678,   487,   454,   376,   350,   627,   628,   629,
     625,   626,    11,   740,   233,   508,   374,   524,   597,   387,
     388,   389,   390,   310,   502,   153,   982,   355,   156,   495,
     842,   611,  1039,   333,   170,   171,   172,   849,   634,   919,
     938,  1016,   939,   669,   343,   165,  1020,   836,   837,   344,
     862,   211,   863,   461,   852,   853,   932,   471,   472,  1046,
     462,   334,   471,   638,   757,   234,   670,   465,   236,   561,
       5,   465,   466,  1069,   170,   171,   172,   217,   667,   982,
       1,  1044,   473,   474,   982,  1018,     6,   473,   474,   523,
    1059,  1058,  1019,  1026,   341,  1079,   166,  1060,  1061,  1073,
    1074,     7,  1080,   219,   321,   325,   326,   327,   307,    10,
     220,   480,   481,   168,   169,   298,   482,   166,   523,   982,
    1087,   147,  1072,   533,   940,   523,   166,   447,  1093,   307,
     648,   296,  1095,   916,   168,   169,   621,   622,   623,   624,
     612,   849,  1085,   509,    12,   170,   171,   172,   846,   446,
     148,   931,   452,   453,   159,   607,   152,   337,   480,   481,
     982,   923,   485,  1017,   925,   228,   229,   927,   542,   543,
     544,   545,   635,   166,   668,   353,   645,   170,   171,   172,
     982,   328,   329,   783,   374,   307,   364,   639,   666,   371,
     168,   169,   170,   171,   172,   486,   526,  -425,   493,   328,
     329,   526,  -425,   430,   431,   308,   309,   177,   178,   154,
     686,   687,   689,   691,   692,   693,   694,   695,   696,   697,
     698,   699,   700,   701,   702,   155,   308,   309,   177,   178,
     321,   434,   435,   321,   321,   308,   309,   177,   178,   717,
     161,   162,   163,   164,   763,   325,   166,   157,   639,   882,
     883,   884,   846,   880,   887,   438,   439,   639,   307,   165,
     166,   989,   158,   168,   169,   990,   170,   149,   172,   846,
     150,   193,   167,   196,   498,   201,   321,   168,   169,   321,
     173,   174,   175,   322,   177,   178,   469,   470,   170,   171,
     172,   475,   476,   199,   912,   161,   162,   163,   164,   602,
     603,   604,   605,   622,   477,   478,   479,   202,   839,   743,
     744,   343,   204,   488,   489,   490,   344,   330,   331,   613,
     614,   636,   637,   681,   682,   683,   684,   917,   918,   498,
     287,   288,   289,   290,   291,   205,   526,   233,   206,   688,
     690,   475,   476,   170,   171,   172,   958,   959,   960,   961,
     530,   640,   209,   534,   216,   308,   309,   177,   178,   840,
     737,   738,   739,   841,   649,  1040,  1041,   173,   174,   175,
     176,   177,   178,   170,   301,   172,   217,   330,   331,   332,
     321,   321,   321,   321,   170,   596,   172,   350,   540,   215,
     674,   737,   738,   739,   225,   574,   448,   450,   778,   779,
     321,   321,   501,   321,   321,   321,   321,   321,   321,   321,
     321,   321,   321,   321,   321,   321,   321,   321,   630,   631,
     632,   423,   424,  1002,  1003,   573,   619,   620,   221,   839,
     222,   223,   321,   224,   226,   227,   231,   583,   292,   295,
     296,   338,   341,   358,   356,   321,   360,   408,   361,   380,
     409,   407,   410,   859,   860,   411,   335,   412,   742,   980,
     413,   321,   414,   980,   789,   790,   415,   421,   754,   425,
     429,   321,   432,   433,   436,   437,   441,   440,   442,   794,
     443,   796,   444,   445,   447,   650,   651,   455,   369,   652,
     655,   464,   463,   456,   759,   457,   760,   459,   664,   467,
     483,   468,   496,   166,   761,   762,   494,   166,   826,   986,
     987,   515,   507,   518,   677,   307,   538,   523,   521,   307,
     168,   169,   541,   527,   168,   169,   945,   546,   217,   781,
     782,   562,   565,   947,   451,   568,   948,   570,   944,   321,
     704,   705,   575,   577,   526,   579,   580,   582,   584,   321,
     601,   585,   606,   298,   644,   633,   639,   609,   641,   647,
     648,   646,   657,   661,  1022,  1023,   672,   217,   673,   208,
    1056,   680,   383,   685,   703,   321,   321,   321,   706,   864,
     711,   719,   714,   715,   724,   321,   321,   890,   745,   755,
     751,   748,   726,   219,   756,   763,   637,   773,   758,   777,
     220,   780,   775,   161,   162,   163,   164,   786,   791,   809,
     321,   321,   308,   309,   177,   178,   308,   309,   177,   178,
     828,   850,   165,   166,   854,   855,   818,   764,   765,   369,
     858,   767,   768,   769,   819,   167,   861,   772,   865,   867,
     168,   169,   869,   868,   870,   871,   880,   922,   924,   926,
     992,   170,   171,   172,   785,   928,   929,   942,   955,   991,
    1021,   988,  1025,   792,   793,   993,   795,   994,   797,   798,
     799,   800,   801,   802,   803,   804,   805,   806,   807,   808,
    1043,  1047,  1048,   369,  1058,  1062,  1065,   815,   300,  1070,
    1071,  1075,  1076,  1081,   306,   321,  1082,  1084,   829,   830,
    1083,  1089,  1086,  1090,  1096,  1094,   384,  1092,   336,   679,
     382,   747,   941,  1064,   587,   588,   589,   590,   591,   592,
     593,   594,   595,   347,   351,   294,   946,   572,   920,  1045,
     173,   174,   175,   176,   177,   178,   362,   921,   984,   365,
     370,   985,   375,   347,   872,   930,   336,   716,   825,   877,
     514,   539,   879,   616,   504,  1057,   379,   531,   323,   324,
     484,   608,   881,   866,   618,   615,   345,     0,     0,   888,
     617,     0,   889,     0,   891,   892,   893,   894,   895,     0,
       0,   896,     0,   897,   898,   899,     0,     0,     0,     0,
       0,   905,   321,   321,     0,     0,     0,     0,     0,   321,
       0,     0,     0,     0,     0,     0,   321,     0,     0,   321,
       0,     0,     0,     0,   217,   217,   217,     0,     0,   217,
       0,     0,     0,     0,   369,   369,   369,   369,   369,   369,
     369,   369,   369,   369,   369,   369,   369,   369,   369,     0,
     219,   219,   219,     0,     0,   219,  1024,   220,   220,   220,
       0,     0,   220,   369,   953,     0,     0,     0,   956,   217,
       0,     0,   321,     0,     0,   963,   321,     0,   964,   965,
       0,     0,     0,     0,     0,   966,     0,   506,     0,     0,
       0,   510,     0,   512,   513,   219,   974,     0,   516,   517,
       0,     0,   220,     0,     0,     0,     0,     0,     0,     0,
       0,   529,   532,     0,  1063,     0,   535,   536,   537,     0,
     370,   217,   217,   217,   217,     0,     0,     0,     0,     0,
       0,     0,   304,     0,     0,     0,     0,   321,     0,     0,
     996,     0,     0,   998,     0,   370,     0,   219,   219,   219,
     219,     0,  1005,     0,   220,   220,   220,   220,     0,     0,
       0,     0,     0,     0,     0,   632,     0,     0,     0,   321,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   599,
     304,     0,     0,     0,     0,  1029,     0,     0,   321,     0,
       0,     0,     0,     0,     0,   321,   321,     0,   217,   217,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   321,
     321,     0,     0,     0,     0,     0,  1049,     0,     0,     0,
       0,     0,     0,     0,   219,   219,     0,     0,     0,     0,
     321,   220,   220,     0,     0,     0,     0,   642,   321,     0,
       0,     0,   321,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1077,   656,     0,   659,   660,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1088,     0,     0,     0,   304,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   370,   510,   510,   370,
     370,   370,   370,   370,   370,   370,   370,   370,   370,   370,
     370,     0,     0,     0,     0,     0,   708,     0,   710,   161,
     162,   163,   164,     0,     0,   718,     0,     0,     0,     0,
     723,     0,     0,     0,     0,   304,     0,     0,     0,   166,
       0,     0,     0,     0,   304,   304,     0,   304,     0,     0,
       0,   167,     0,   498,     0,     0,   168,   169,     0,   753,
     161,   162,   163,   164,     0,     0,     0,   170,   171,   172,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   165,
     166,   161,   162,   163,   164,     0,     0,     0,     0,     0,
       0,     0,   167,     0,     0,     0,     0,   168,   169,     0,
       0,   166,     0,     0,   161,   162,   163,   164,   170,   171,
     172,     0,     0,   167,     0,     0,     0,     0,   168,   169,
       0,     0,   600,     0,   166,     0,     0,     0,     0,   170,
     171,   172,     0,     0,     0,     0,   167,   347,     0,   347,
     304,   168,   169,     0,     0,     0,   173,   174,   175,   176,
     177,   178,   170,   596,   172,     0,     0,     0,   814,     0,
       0,   816,   817,     0,     0,   506,   827,     0,     0,     0,
       0,     0,     0,     0,   833,     0,   599,   599,   599,   599,
       0,     0,     0,     0,   599,   599,     0,   173,   174,   653,
     176,   177,   178,     0,     0,     0,     0,     0,   600,     0,
       0,   304,   304,     0,   304,     0,     0,     0,   173,   174,
     175,   176,   177,   178,     0,     0,     0,   304,   304,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   173,   174,   175,   176,   177,   178,     0,     0,     0,
       0,     0,     0,     0,     0,   347,   392,   393,   394,   395,
     396,   397,   398,   399,   400,   401,   402,   403,   404,   405,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   420,     0,     0,     0,   910,   911,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   599,     0,     0,   599,     0,     0,   599,     0,     0,
     599,     0,     0,   936,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   304,     0,     0,     0,     0,     0,
     304,   304,     0,     0,   304,     0,     0,   304,   302,     0,
       0,     0,     0,     0,     0,     0,     0,   304,     0,     0,
     976,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   936,     0,
     599,   599,     0,     0,     0,     0,   304,   304,     0,   304,
     304,     0,     0,     0,     0,     0,   363,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   304,     0,     0,   600,
     600,   600,   600,     0,     0,     0,     0,   600,   600,     0,
       0,     0,     0,  1012,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   599,   599,     0,     0,     0,
    1027,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     304,   304,   304,   304,     0,     0,   304,     0,     0,     0,
       0,  1037,     0,     0,     0,     0,     0,     0,     0,     0,
     936,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     458,     0,   304,   304,   304,   304,     0,   304,   304,   304,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     936,   936,     0,   600,   304,   304,     0,     0,     0,     0,
       0,     0,     0,     0,   600,     0,     0,   600,     0,     0,
     600,   936,     0,   600,     0,     0,     0,     0,     0,   936,
       0,   511,     0,   936,     0,     0,     0,     0,     0,     0,
     519,   520,     0,   522,   304,     0,   304,   304,   304,     0,
     304,     0,     0,     0,   304,     0,     0,     0,     0,   304,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   304,     0,     0,   304,   304,   304,   304,   304,
     304,     0,   304,     0,     0,     0,   304,   304,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   983,     0,
       0,     0,     0,   600,   600,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   304,     0,   304,     0,     0,   304,
     304,   304,     0,     0,   304,     0,   610,     0,     0,   304,
     304,   304,   304,     0,   304,   304,     0,     0,   304,   304,
       0,   983,     0,     0,     0,     0,   983,     0,   600,   600,
       0,     0,     0,     0,     0,     0,     0,     0,   304,     0,
       0,     0,   304,   304,   304,   304,     0,     0,     0,     0,
     304,     0,   304,   304,     0,   304,     0,     0,     0,     0,
       0,   983,     0,     0,   658,     0,     0,   662,   663,     0,
     665,     0,   304,   304,   304,   304,     0,     0,   304,   304,
       0,   304,     0,   675,   676,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   304,   304,   304,     0,     0,     0,
       0,   195,   983,   198,     0,     0,     0,     0,     0,     0,
     304,   304,     0,     0,     0,     0,   212,   213,   214,     0,
       0,     0,   983,     0,     0,     0,     0,     0,     0,     0,
     304,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     766,     0,     0,     0,     0,     0,   770,   771,     0,     0,
     774,     0,     0,   776,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   784,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   810,   811,     0,   812,   813,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     352,     0,   832,   354,     0,     0,   357,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   377,   378,     0,     0,
       0,     0,     0,     0,     0,   381,     0,     0,     0,     0,
     386,     0,     0,     0,     0,   391,   873,   874,   875,   876,
       0,     0,   878,     0,     0,     0,     0,     0,     0,     0,
     406,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     416,   417,   418,   419,     0,     0,     0,     0,     0,   427,
     428,     0,     0,     0,     0,     0,     0,     0,   901,   902,
     903,   904,     0,   906,   907,   908,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   913,
     914,   915,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     949,     0,   950,   951,   952,     0,   954,     0,     0,     0,
     957,     0,     0,     0,     0,   962,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   967,     0,
       0,   968,   969,   970,   971,   972,   973,     0,   975,     0,
       0,     0,   977,   978,     0,   547,   548,   549,   550,   551,
     552,   553,   554,   555,   556,   557,   558,   559,   560,     0,
       0,   563,   564,     0,   567,     0,   569,     0,     0,     0,
       0,     0,     0,   576,     0,     0,     0,     0,     0,   581,
     995,     0,   997,     0,     0,   999,  1000,  1001,     0,     0,
    1004,     0,     0,     0,     0,  1006,  1007,  1008,  1009,     0,
    1010,  1011,     0,     0,  1014,  1015,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1028,     0,     0,     0,  1030,  1031,
    1032,  1033,     0,     0,     0,     0,  1034,     0,  1035,  1036,
       0,  1038,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1050,  1051,
    1052,  1053,     0,     0,  1054,  1055,     0,  1038,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1066,  1067,  1068,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1078,  1038,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1091,     0,     0,   707,
       0,   709,     0,     0,   712,   713,     0,     0,     0,     0,
       0,     0,   721,   722,     0,     0,     0,   725,     0,   727,
     728,   729,   730,   731,   732,   733,   734,   735,   736,     0,
       0,     0,    -9,     0,     0,     0,     0,    13,    14,    15,
      16,    17,    18,    19,    20,    21,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,    22,    23,    24,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,    25,
       0,    26,    -9,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   787,   788,    27,     0,     0,     0,
       0,     6,     0,     0,     0,     0,     0,     0,     0,     0,
      28,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,    29,    30,     0,     0,     0,
       0,    31,    32,    33,     0,     0,     0,    34,    35,    36,
       0,     0,    37,    38,    39,    40,    41,     0,     0,     0,
       0,    42,    43,    44,    45,     0,    46,    47,    48,    49,
      50,    51,    52,    53,     0,     0,     0,    54,    55,     0,
       0,    56,    57,    58,     0,     0,     0,     0,   235,     0,
       0,     0,    -8,    -8,    -8,    -8,    -8,    -8,    -8,    -8,
      -8,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   885,   886,     0,    59,    60,    -8,    -8,    -8,
      -8,    -8,    -8,     0,     0,     0,     0,     0,    -8,    -8,
      -8,    -8,   900,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,    -8,     0,    -8,    -8,     0,     0,
       0,   909,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,    -8,     0,     0,     0,     0,     1,     0,     0,     0,
       0,     0,     0,     0,     0,    -8,    -8,    -8,    -8,    -8,
      -8,    -8,    -8,    -8,    -8,    -8,    -8,    -8,    -8,    -8,
      -8,    -8,    -8,    -8,    -8,    -8,    -8,    -8,    -8,    -8,
      -8,    -8,    -8,    -8,    -8,    -8,    -8,    -8,    -8,    -8,
      -8,    -8,    -8,    -8,    -8,    -8,    -8,    -8,    -8,    -8,
      -8,    -8,    -8,    -8,    -8,    -8,    -8,    -8,    -8,    -8,
      -8,    -8,    -8,    -8,    -8,    -8,    -8,    -8,    -8,    -8,
       0,     0,     0,     0,     0,     0,     0,    -8,    13,    14,
      15,    16,    17,    18,    19,    20,    21,     0,     0,     0,
       0,     0,    -8,    -8,    -8,    -8,    -8,    -8,    -8,    -8,
      -8,    -8,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,    22,    23,    24,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
      25,     0,    26,   383,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,    27,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,    28,     0,     0,     0,     0,     0,   237,   238,   239,
     240,   241,   242,     0,     0,     0,    29,    30,   243,     0,
       0,     0,    31,    32,    33,     0,     0,     0,    34,    35,
      36,     0,     0,    37,    38,    39,    40,    41,     0,     0,
       0,     0,    42,    43,    44,    45,     0,    46,    47,    48,
      49,    50,    51,    52,    53,     0,     0,     0,    54,    55,
       0,     0,    56,    57,    58,    13,    14,    15,    16,    17,
      18,    19,    20,    21,     0,     0,   244,   245,   246,   247,
     248,   249,   250,   251,   252,   253,   254,   255,   256,   257,
       0,     0,   258,   259,   260,   261,    59,    60,     0,   262,
     263,   264,    22,    23,    24,   265,   266,     0,     0,     0,
       0,     0,   267,   268,   269,   270,     0,    25,     0,    26,
     271,     0,     0,     0,     0,     0,     0,     0,     0,   272,
     273,   274,     0,     0,   275,   276,     0,     0,     0,   277,
       0,     0,     0,     0,    27,     0,     0,   278,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,    28,     0,
       0,     0,   279,   280,   281,   282,   283,   284,   285,   286,
       0,     0,     0,    29,    30,     0,     0,     0,     0,    31,
      32,    33,     0,     0,     0,    34,    35,    36,     0,     0,
      37,    38,    39,    40,    41,     0,     0,     0,     0,    42,
      43,    44,    45,     0,    46,    47,    48,    49,    50,    51,
      52,    53,     0,     0,     0,    54,    55,     0,     0,    56,
      57,    58,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,    59,    60
};

static const yytype_int16 yycheck[] =
{
      23,    24,   539,   338,   297,   214,   195,   477,   478,   479,
     475,   476,     8,   597,    61,   352,   213,   369,   440,   238,
     239,   240,   241,   166,   348,    16,   926,   201,    19,   342,
     731,    57,  1014,    57,    85,    86,    87,   733,   484,   836,
       1,   979,     3,    62,    45,    56,   984,   728,   729,    50,
      60,    42,    62,    55,   735,   736,   853,    52,    53,  1021,
      62,    85,    52,    53,    64,    61,    85,    71,    64,   406,
       0,    71,    76,  1055,    85,    86,    87,    49,   524,   979,
      89,  1019,    77,    78,   984,    55,    89,    77,    78,    52,
      55,    55,    62,     1,    57,    55,    57,    62,    62,  1061,
    1062,    14,    62,    49,   166,   167,   168,   169,    69,   166,
      49,    65,    66,    74,    75,   166,    70,    57,    52,  1019,
    1082,   166,  1060,    57,    85,    52,    57,    17,  1090,    69,
      57,    21,  1094,   834,    74,    75,   471,   472,   473,   474,
     166,   837,  1080,   352,    61,    85,    86,    87,   732,   292,
      85,   852,   295,   296,    57,   448,    88,   180,    65,    66,
    1060,   842,   336,    70,   845,   183,   184,   848,   387,   388,
     389,   390,   485,    57,   526,   198,   500,    85,    86,    87,
    1080,    47,    48,    58,   381,    69,   209,    62,   523,   212,
      74,    75,    85,    86,    87,   338,   370,    45,   341,    47,
      48,   375,    50,   183,   184,   166,   167,   168,   169,    85,
     547,   548,   549,   550,   551,   552,   553,   554,   555,   556,
     557,   558,   559,   560,   561,    85,   166,   167,   168,   169,
     292,   183,   184,   295,   296,   166,   167,   168,   169,   576,
      37,    38,    39,    40,    58,   307,    57,    85,    62,   786,
     787,   788,   836,    58,   791,   183,   184,    62,    69,    56,
      57,    57,    85,    74,    75,    61,    85,    85,    87,   853,
      88,    75,    69,    51,    71,    91,   338,    74,    75,   341,
     164,   165,   166,   167,   168,   169,    79,    80,    85,    86,
      87,    68,    69,    92,   831,    37,    38,    39,    40,   442,
     443,   444,   445,   638,    81,    82,    83,    61,   730,   602,
     603,    45,    93,    47,    48,    49,    50,    47,    48,   462,
     463,    62,    63,   542,   543,   544,   545,   173,   174,    71,
      22,    23,    24,    25,    26,    93,   510,   384,    57,   548,
     549,    68,    69,    85,    86,    87,   883,   884,   885,   886,
     373,   494,    57,   376,   166,   166,   167,   168,   169,   176,
     177,   178,   179,   180,   507,    68,    69,   164,   165,   166,
     167,   168,   169,    85,    86,    87,   348,    47,    48,    49,
     442,   443,   444,   445,    85,    86,    87,   576,   384,    88,
     533,   177,   178,   179,    85,   418,   293,   294,   669,   670,
     462,   463,   348,   465,   466,   467,   468,   469,   470,   471,
     472,   473,   474,   475,   476,   477,   478,   479,   480,   481,
     482,   273,   274,   960,   961,   416,   469,   470,    97,   851,
      97,    93,   494,    93,    85,    93,    36,   428,    18,    67,
      21,    52,    57,    57,   166,   507,    94,    93,   166,   181,
      93,    61,     4,   746,   747,    93,   179,    61,   601,   924,
      93,   523,     4,   928,   683,   684,     4,    29,   611,    90,
      61,   533,   183,   183,   183,   183,    46,   184,    19,   688,
      19,   690,    19,    19,    17,   508,   509,    58,   211,   512,
     513,    58,    57,    62,   637,    61,   639,    61,   521,    72,
      85,    73,   163,    57,   647,   648,    52,    57,   717,   931,
     932,   166,    57,    62,   537,    69,   182,    52,    62,    69,
      74,    75,   167,    57,    74,    75,   861,   167,   500,   672,
     673,   166,    61,   868,    88,   166,   871,    61,    88,   601,
     563,   564,    85,    27,   718,    93,    93,   166,   166,   611,
      19,   171,    59,   166,   500,    58,    62,   166,    58,    54,
      57,   500,    58,   166,   986,   987,    57,   539,    57,    40,
    1040,   166,    60,   166,    61,   637,   638,   639,   166,   753,
     166,    28,   166,   166,   166,   647,   648,   796,    20,    55,
      58,    85,   171,   539,    58,    58,    63,    58,   166,    53,
     539,    58,    62,    37,    38,    39,    40,   166,   166,   166,
     672,   673,   166,   167,   168,   169,   166,   167,   168,   169,
      93,   176,    56,    57,    57,    16,   166,   650,   651,   352,
      85,   654,   655,   656,   166,    69,    67,   660,    58,    53,
      74,    75,    58,    62,    55,    52,    58,   175,    54,    54,
     943,    85,    86,    87,   677,    54,    54,    15,    58,    52,
      62,    58,   166,   686,   687,    53,   689,    53,   691,   692,
     693,   694,   695,   696,   697,   698,   699,   700,   701,   702,
     172,    62,    62,   406,    55,    62,    96,   710,   159,   172,
     172,    58,    53,    55,   165,   757,    62,   172,   721,   722,
      95,    55,   172,    62,    55,    62,   236,   172,   179,   540,
     233,   605,   855,  1048,   431,   432,   433,   434,   435,   436,
     437,   438,   439,   194,   195,   155,   863,   415,   837,  1020,
     164,   165,   166,   167,   168,   169,   207,   838,   928,   210,
     211,   929,   213,   214,   767,   851,   217,   576,   717,   772,
     357,   381,   775,   466,   348,  1041,   227,   373,   167,   167,
     335,   456,   785,   757,   468,   465,   190,    -1,    -1,   792,
     467,    -1,   795,    -1,   797,   798,   799,   800,   801,    -1,
      -1,   804,    -1,   806,   807,   808,    -1,    -1,    -1,    -1,
      -1,   814,   854,   855,    -1,    -1,    -1,    -1,    -1,   861,
      -1,    -1,    -1,    -1,    -1,    -1,   868,    -1,    -1,   871,
      -1,    -1,    -1,    -1,   786,   787,   788,    -1,    -1,   791,
      -1,    -1,    -1,    -1,   547,   548,   549,   550,   551,   552,
     553,   554,   555,   556,   557,   558,   559,   560,   561,    -1,
     786,   787,   788,    -1,    -1,   791,   989,   786,   787,   788,
      -1,    -1,   791,   576,   877,    -1,    -1,    -1,   881,   831,
      -1,    -1,   924,    -1,    -1,   888,   928,    -1,   891,   892,
      -1,    -1,    -1,    -1,    -1,   898,    -1,   348,    -1,    -1,
      -1,   352,    -1,   354,   355,   831,   909,    -1,   359,   360,
      -1,    -1,   831,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   372,   373,    -1,  1047,    -1,   377,   378,   379,    -1,
     381,   883,   884,   885,   886,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   160,    -1,    -1,    -1,    -1,   989,    -1,    -1,
     953,    -1,    -1,   956,    -1,   406,    -1,   883,   884,   885,
     886,    -1,   965,    -1,   883,   884,   885,   886,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  1017,    -1,    -1,    -1,  1021,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   440,
     208,    -1,    -1,    -1,    -1,   998,    -1,    -1,  1040,    -1,
      -1,    -1,    -1,    -1,    -1,  1047,  1048,    -1,   960,   961,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1061,
    1062,    -1,    -1,    -1,    -1,    -1,  1029,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   960,   961,    -1,    -1,    -1,    -1,
    1082,   960,   961,    -1,    -1,    -1,    -1,   498,  1090,    -1,
      -1,    -1,  1094,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  1065,   514,    -1,   516,   517,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    1083,    -1,    -1,    -1,   302,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   547,   548,   549,   550,
     551,   552,   553,   554,   555,   556,   557,   558,   559,   560,
     561,    -1,    -1,    -1,    -1,    -1,   567,    -1,   569,    37,
      38,    39,    40,    -1,    -1,   576,    -1,    -1,    -1,    -1,
     581,    -1,    -1,    -1,    -1,   353,    -1,    -1,    -1,    57,
      -1,    -1,    -1,    -1,   362,   363,    -1,   365,    -1,    -1,
      -1,    69,    -1,    71,    -1,    -1,    74,    75,    -1,   610,
      37,    38,    39,    40,    -1,    -1,    -1,    85,    86,    87,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    56,
      57,    37,    38,    39,    40,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    69,    -1,    -1,    -1,    -1,    74,    75,    -1,
      -1,    57,    -1,    -1,    37,    38,    39,    40,    85,    86,
      87,    -1,    -1,    69,    -1,    -1,    -1,    -1,    74,    75,
      -1,    -1,   440,    -1,    57,    -1,    -1,    -1,    -1,    85,
      86,    87,    -1,    -1,    -1,    -1,    69,   688,    -1,   690,
     458,    74,    75,    -1,    -1,    -1,   164,   165,   166,   167,
     168,   169,    85,    86,    87,    -1,    -1,    -1,   709,    -1,
      -1,   712,   713,    -1,    -1,   716,   717,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   725,    -1,   727,   728,   729,   730,
      -1,    -1,    -1,    -1,   735,   736,    -1,   164,   165,   166,
     167,   168,   169,    -1,    -1,    -1,    -1,    -1,   516,    -1,
      -1,   519,   520,    -1,   522,    -1,    -1,    -1,   164,   165,
     166,   167,   168,   169,    -1,    -1,    -1,   535,   536,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   164,   165,   166,   167,   168,   169,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   796,   243,   244,   245,   246,
     247,   248,   249,   250,   251,   252,   253,   254,   255,   256,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   271,    -1,    -1,    -1,   829,   830,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   842,    -1,    -1,   845,    -1,    -1,   848,    -1,    -1,
     851,    -1,    -1,   854,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   652,    -1,    -1,    -1,    -1,    -1,
     658,   659,    -1,    -1,   662,    -1,    -1,   665,   160,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   675,    -1,    -1,
     911,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   929,    -1,
     931,   932,    -1,    -1,    -1,    -1,   704,   705,    -1,   707,
     708,    -1,    -1,    -1,    -1,    -1,   208,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   724,    -1,    -1,   727,
     728,   729,   730,    -1,    -1,    -1,    -1,   735,   736,    -1,
      -1,    -1,    -1,   974,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   986,   987,    -1,    -1,    -1,
     991,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     768,   769,   770,   771,    -1,    -1,   774,    -1,    -1,    -1,
      -1,  1012,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    1021,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     302,    -1,   810,   811,   812,   813,    -1,   815,   816,   817,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    1061,  1062,    -1,   831,   832,   833,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   842,    -1,    -1,   845,    -1,    -1,
     848,  1082,    -1,   851,    -1,    -1,    -1,    -1,    -1,  1090,
      -1,   353,    -1,  1094,    -1,    -1,    -1,    -1,    -1,    -1,
     362,   363,    -1,   365,   872,    -1,   874,   875,   876,    -1,
     878,    -1,    -1,    -1,   882,    -1,    -1,    -1,    -1,   887,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   900,    -1,    -1,   903,   904,   905,   906,   907,
     908,    -1,   910,    -1,    -1,    -1,   914,   915,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   926,    -1,
      -1,    -1,    -1,   931,   932,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   952,    -1,   954,    -1,    -1,   957,
     958,   959,    -1,    -1,   962,    -1,   458,    -1,    -1,   967,
     968,   969,   970,    -1,   972,   973,    -1,    -1,   976,   977,
      -1,   979,    -1,    -1,    -1,    -1,   984,    -1,   986,   987,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   996,    -1,
      -1,    -1,  1000,  1001,  1002,  1003,    -1,    -1,    -1,    -1,
    1008,    -1,  1010,  1011,    -1,  1013,    -1,    -1,    -1,    -1,
      -1,  1019,    -1,    -1,   516,    -1,    -1,   519,   520,    -1,
     522,    -1,  1030,  1031,  1032,  1033,    -1,    -1,  1036,  1037,
      -1,  1039,    -1,   535,   536,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  1052,  1053,  1054,    -1,    -1,    -1,
      -1,    28,  1060,    30,    -1,    -1,    -1,    -1,    -1,    -1,
    1068,  1069,    -1,    -1,    -1,    -1,    43,    44,    45,    -1,
      -1,    -1,  1080,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    1088,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     652,    -1,    -1,    -1,    -1,    -1,   658,   659,    -1,    -1,
     662,    -1,    -1,   665,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   675,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   704,   705,    -1,   707,   708,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     197,    -1,   724,   200,    -1,    -1,   203,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   223,   224,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   232,    -1,    -1,    -1,    -1,
     237,    -1,    -1,    -1,    -1,   242,   768,   769,   770,   771,
      -1,    -1,   774,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     257,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     267,   268,   269,   270,    -1,    -1,    -1,    -1,    -1,   276,
     277,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   810,   811,
     812,   813,    -1,   815,   816,   817,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   831,
     832,   833,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     872,    -1,   874,   875,   876,    -1,   878,    -1,    -1,    -1,
     882,    -1,    -1,    -1,    -1,   887,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   900,    -1,
      -1,   903,   904,   905,   906,   907,   908,    -1,   910,    -1,
      -1,    -1,   914,   915,    -1,   392,   393,   394,   395,   396,
     397,   398,   399,   400,   401,   402,   403,   404,   405,    -1,
      -1,   408,   409,    -1,   411,    -1,   413,    -1,    -1,    -1,
      -1,    -1,    -1,   420,    -1,    -1,    -1,    -1,    -1,   426,
     952,    -1,   954,    -1,    -1,   957,   958,   959,    -1,    -1,
     962,    -1,    -1,    -1,    -1,   967,   968,   969,   970,    -1,
     972,   973,    -1,    -1,   976,   977,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   996,    -1,    -1,    -1,  1000,  1001,
    1002,  1003,    -1,    -1,    -1,    -1,  1008,    -1,  1010,  1011,
      -1,  1013,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1030,  1031,
    1032,  1033,    -1,    -1,  1036,  1037,    -1,  1039,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    1052,  1053,  1054,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  1068,  1069,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  1088,    -1,    -1,   566,
      -1,   568,    -1,    -1,   571,   572,    -1,    -1,    -1,    -1,
      -1,    -1,   579,   580,    -1,    -1,    -1,   584,    -1,   586,
     587,   588,   589,   590,   591,   592,   593,   594,   595,    -1,
      -1,    -1,     0,    -1,    -1,    -1,    -1,     5,     6,     7,
       8,     9,    10,    11,    12,    13,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    42,    43,    44,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    57,
      -1,    59,    60,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   681,   682,    84,    -1,    -1,    -1,
      -1,    89,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      98,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   113,   114,    -1,    -1,    -1,
      -1,   119,   120,   121,    -1,    -1,    -1,   125,   126,   127,
      -1,    -1,   130,   131,   132,   133,   134,    -1,    -1,    -1,
      -1,   139,   140,   141,   142,    -1,   144,   145,   146,   147,
     148,   149,   150,   151,    -1,    -1,    -1,   155,   156,    -1,
      -1,   159,   160,   161,    -1,    -1,    -1,    -1,     1,    -1,
      -1,    -1,     5,     6,     7,     8,     9,    10,    11,    12,
      13,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   789,   790,    -1,   193,   194,    30,    31,    32,
      33,    34,    35,    -1,    -1,    -1,    -1,    -1,    41,    42,
      43,    44,   809,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    57,    -1,    59,    60,    -1,    -1,
      -1,   828,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    84,    -1,    -1,    -1,    -1,    89,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    98,    99,   100,   101,   102,
     103,   104,   105,   106,   107,   108,   109,   110,   111,   112,
     113,   114,   115,   116,   117,   118,   119,   120,   121,   122,
     123,   124,   125,   126,   127,   128,   129,   130,   131,   132,
     133,   134,   135,   136,   137,   138,   139,   140,   141,   142,
     143,   144,   145,   146,   147,   148,   149,   150,   151,   152,
     153,   154,   155,   156,   157,   158,   159,   160,   161,   162,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   170,     5,     6,
       7,     8,     9,    10,    11,    12,    13,    -1,    -1,    -1,
      -1,    -1,   185,   186,   187,   188,   189,   190,   191,   192,
     193,   194,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    42,    43,    44,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      57,    -1,    59,    60,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    84,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    98,    -1,    -1,    -1,    -1,    -1,    30,    31,    32,
      33,    34,    35,    -1,    -1,    -1,   113,   114,    41,    -1,
      -1,    -1,   119,   120,   121,    -1,    -1,    -1,   125,   126,
     127,    -1,    -1,   130,   131,   132,   133,   134,    -1,    -1,
      -1,    -1,   139,   140,   141,   142,    -1,   144,   145,   146,
     147,   148,   149,   150,   151,    -1,    -1,    -1,   155,   156,
      -1,    -1,   159,   160,   161,     5,     6,     7,     8,     9,
      10,    11,    12,    13,    -1,    -1,    99,   100,   101,   102,
     103,   104,   105,   106,   107,   108,   109,   110,   111,   112,
      -1,    -1,   115,   116,   117,   118,   193,   194,    -1,   122,
     123,   124,    42,    43,    44,   128,   129,    -1,    -1,    -1,
      -1,    -1,   135,   136,   137,   138,    -1,    57,    -1,    59,
     143,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   152,
     153,   154,    -1,    -1,   157,   158,    -1,    -1,    -1,   162,
      -1,    -1,    -1,    -1,    84,    -1,    -1,   170,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    98,    -1,
      -1,    -1,   185,   186,   187,   188,   189,   190,   191,   192,
      -1,    -1,    -1,   113,   114,    -1,    -1,    -1,    -1,   119,
     120,   121,    -1,    -1,    -1,   125,   126,   127,    -1,    -1,
     130,   131,   132,   133,   134,    -1,    -1,    -1,    -1,   139,
     140,   141,   142,    -1,   144,   145,   146,   147,   148,   149,
     150,   151,    -1,    -1,    -1,   155,   156,    -1,    -1,   159,
     160,   161,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   193,   194
};

/* YYSTOS[STATE-NUM] -- The symbol kind of the accessing symbol of
   state STATE-NUM.  */
static const yytype_int16 yystos[] =
{
       0,    89,   196,   199,   200,     0,    89,    14,   197,   208,
     166,   200,    61,     5,     6,     7,     8,     9,    10,    11,
      12,    13,    42,    43,    44,    57,    59,    84,    98,   113,
     114,   119,   120,   121,   125,   126,   127,   130,   131,   132,
     133,   134,   139,   140,   141,   142,   144,   145,   146,   147,
     148,   149,   150,   151,   155,   156,   159,   160,   161,   193,
     194,   198,   201,   202,   203,   206,   207,   209,   210,   211,
     212,   213,   214,   216,   217,   218,   221,   222,   223,   230,
     231,   232,   233,   234,   235,   236,   237,   238,   239,   240,
     241,   242,   243,   244,   245,   246,   247,   248,   249,   250,
     251,   252,   254,   255,   256,   257,   258,   259,   260,   262,
     263,   264,   265,   268,   269,   270,   272,   273,   275,   276,
     278,   279,   280,   281,   282,   284,   285,   286,   287,   288,
     289,   290,   291,   292,   293,   294,   295,   296,   316,   317,
     318,   319,   320,   321,   322,   323,   325,   166,    85,    85,
      88,   205,    88,   205,    85,    85,   205,    85,    85,    57,
     372,    37,    38,    39,    40,    56,    57,    69,    74,    75,
      85,    86,    87,   164,   165,   166,   167,   168,   169,   329,
     336,   341,   357,   358,   359,   360,   361,   365,   374,   375,
     387,   388,   336,    75,   326,   372,    51,   330,   372,    92,
     324,    91,    61,   371,    93,    93,    57,   343,   374,    57,
     344,   205,   372,   372,   372,    88,   166,   329,   337,   341,
     358,    97,    97,    93,    93,    85,    85,    93,   183,   184,
     297,    36,   328,   199,   200,     1,   200,    30,    31,    32,
      33,    34,    35,    41,    99,   100,   101,   102,   103,   104,
     105,   106,   107,   108,   109,   110,   111,   112,   115,   116,
     117,   118,   122,   123,   124,   128,   129,   135,   136,   137,
     138,   143,   152,   153,   154,   157,   158,   162,   170,   185,
     186,   187,   188,   189,   190,   191,   192,    22,    23,    24,
      25,    26,    18,   219,   219,    67,    21,   220,   166,   373,
     374,    86,   347,   348,   375,   368,   374,    69,   166,   167,
     376,   377,   378,   379,   380,   381,   382,   383,   384,   385,
     386,   387,   167,   359,   360,   387,   387,   387,    47,    48,
      47,    48,    49,    57,    85,   365,   374,   336,    52,   363,
     364,    57,   366,    45,    50,   390,   367,   374,   331,   351,
     369,   374,   372,   336,   372,   366,   166,   372,    57,   370,
      94,   166,   374,   347,   336,   374,   333,   352,   353,   365,
     374,   336,   332,   346,   352,   374,   367,   372,   372,   374,
     181,   372,   201,    60,   198,   204,   372,   371,   371,   371,
     371,   372,   328,   328,   328,   328,   328,   328,   328,   328,
     328,   328,   328,   328,   328,   328,   372,    61,    93,    93,
       4,    93,    61,    93,     4,     4,   372,   372,   372,   372,
     328,    29,   271,   271,   271,    90,   277,   372,   372,    61,
     183,   184,   183,   183,   183,   184,   183,   183,   183,   184,
     184,    46,    19,    19,    19,    19,   376,    17,   220,   229,
     220,    88,   376,   376,   229,    58,    62,    61,   347,    61,
     349,    55,    62,    57,    58,    71,    76,    72,    73,    79,
      80,    52,    53,    77,    78,    68,    69,    81,    82,    83,
      65,    66,    70,    85,   364,   366,   376,   383,    47,    48,
      49,   389,   390,   376,    52,   363,   163,   327,    71,   339,
     340,   341,   354,   355,   356,   369,   374,    57,   333,   367,
     374,   347,   374,   374,   324,   166,   374,   374,    62,   347,
     347,    62,   347,    52,   362,   362,   366,    57,   345,   374,
     336,   345,   374,    57,   336,   374,   374,   374,   182,   332,
     200,   167,   371,   371,   371,   371,   167,   372,   372,   372,
     372,   372,   372,   372,   372,   372,   372,   372,   372,   372,
     372,   333,   166,   372,   372,    61,   283,   372,   166,   372,
      61,   261,   261,   205,   336,    85,   372,    27,   266,    93,
      93,   372,   166,   205,   166,   171,   298,   298,   298,   298,
     298,   298,   298,   298,   298,   298,    86,   313,   347,   374,
     375,    19,   376,   376,   376,   376,    59,   229,   373,   166,
     347,    57,   166,   376,   376,   379,   378,   380,   381,   382,
     382,   383,   383,   383,   383,   386,   386,   385,   385,   385,
     387,   387,   387,    58,   389,   363,    62,    63,    53,    62,
     376,    58,   374,   338,   341,   354,   358,    54,    57,   376,
     336,   336,   336,   166,   253,   336,   374,    58,   347,   374,
     374,   166,   347,   347,   336,   347,   383,   389,   362,    62,
      85,   315,    57,    57,   376,   347,   347,   336,   337,   204,
     166,   371,   371,   371,   371,   166,   333,   333,   367,   333,
     367,   333,   333,   333,   333,   333,   333,   333,   333,   333,
     333,   333,   333,    61,   336,   336,   166,   372,   374,   372,
     374,   166,   372,   372,   166,   166,   331,   333,   374,    28,
     267,   372,   372,   374,   166,   372,   171,   372,   372,   372,
     372,   372,   372,   372,   372,   372,   372,   177,   178,   179,
     306,   307,   376,   229,   229,    20,   215,   215,    85,   227,
     228,    58,   342,   374,   376,    55,    58,    64,   166,   376,
     376,   376,   376,    58,   336,   336,   347,   336,   336,   336,
     347,   347,   336,    58,   347,    62,   347,    53,   315,   315,
      58,   376,   376,    58,   347,   336,   166,   372,   372,   371,
     371,   166,   336,   336,   367,   336,   367,   336,   336,   336,
     336,   336,   336,   336,   336,   336,   336,   336,   336,   166,
     347,   347,   347,   347,   374,   336,   374,   374,   166,   166,
     334,   335,   336,   354,   356,   334,   367,   374,    93,   336,
     336,   274,   347,   374,   311,   313,   311,   311,   312,   313,
     176,   180,   299,   305,   306,   302,   306,   299,   300,   305,
     176,   301,   311,   311,    57,    16,   224,   225,    85,   229,
     229,    67,    60,    62,   366,    58,   377,    53,    62,    58,
      55,    52,   336,   347,   347,   347,   347,   336,   347,   336,
      58,   336,   337,   337,   337,   372,   372,   337,   336,   336,
     367,   336,   336,   336,   336,   336,   336,   336,   336,   336,
     372,   347,   347,   347,   347,   336,   347,   347,   347,   372,
     374,   374,   337,   347,   347,   347,   299,   173,   174,   302,
     300,   301,   175,   311,    54,   311,    54,   311,    54,    54,
     312,   299,   302,   308,   309,   310,   374,   376,     1,     3,
      85,   376,    15,   226,    88,   383,   227,   383,   383,   347,
     347,   347,   347,   336,   347,    58,   336,   347,   337,   337,
     337,   337,   347,   336,   336,   336,   336,   347,   347,   347,
     347,   347,   347,   347,   336,   347,   374,   347,   347,   304,
     386,   314,   348,   375,   304,   310,   313,   313,    58,    57,
      61,    52,   229,    53,    53,   347,   336,   347,   336,   347,
     347,   347,   337,   337,   347,   336,   347,   347,   347,   347,
     347,   347,   374,   350,   347,   347,   314,    70,    55,    62,
     314,    62,   313,   313,   376,   166,     1,   374,   347,   336,
     347,   347,   347,   347,   347,   347,   347,   374,   347,   350,
      68,    69,   303,   172,   314,   303,   308,    62,    62,   336,
     347,   347,   347,   347,   347,   347,   385,   388,    55,    55,
      62,    62,    62,   376,   383,    96,   347,   347,   347,   350,
     172,   172,   314,   308,   308,    58,    53,   336,   347,    55,
      62,    55,    62,    95,   172,   314,   172,   308,   336,    55,
      62,   347,   172,   308,    62,   308,    55
};

/* YYR1[RULE-NUM] -- Symbol kind of the left-hand side of rule RULE-NUM.  */
static const yytype_int16 yyr1[] =
{
       0,   195,   196,   197,   198,   198,   199,   199,   200,   200,
     201,   201,   201,   201,   201,   201,   201,   201,   201,   201,
     201,   202,   202,   202,   203,   204,   205,   205,   206,   207,
     208,   209,   209,   209,   209,   209,   209,   210,   211,   212,
     213,   214,   215,   215,   216,   217,   217,   218,   218,   219,
     219,   220,   221,   222,   222,   222,   222,   223,   224,   224,
     225,   225,   225,   225,   226,   226,   226,   227,   227,   227,
     228,   228,   229,   229,   230,   230,   230,   230,   230,   230,
     230,   230,   230,   230,   230,   230,   230,   230,   230,   230,
     230,   230,   230,   230,   230,   230,   230,   230,   230,   230,
     230,   230,   230,   230,   230,   230,   230,   230,   230,   230,
     230,   230,   230,   230,   230,   230,   230,   230,   230,   230,
     230,   230,   230,   230,   231,   232,   232,   232,   232,   233,
     233,   234,   235,   236,   237,   238,   238,   239,   240,   241,
     242,   243,   244,   245,   246,   247,   248,   249,   249,   249,
     250,   250,   250,   251,   251,   252,   252,   253,   254,   255,
     256,   257,   258,   258,   258,   258,   258,   259,   260,   261,
     261,   262,   263,   263,   264,   265,   266,   266,   267,   267,
     268,   269,   270,   271,   271,   272,   273,   274,   274,   274,
     275,   276,   277,   277,   278,   279,   280,   280,   280,   281,
     282,   282,   282,   282,   282,   283,   283,   284,   284,   284,
     284,   284,   284,   284,   284,   284,   284,   284,   284,   285,
     286,   287,   288,   289,   290,   291,   292,   293,   294,   295,
     296,   297,   297,   298,   298,   298,   299,   300,   300,   301,
     302,   302,   302,   302,   303,   303,   303,   304,   304,   305,
     305,   305,   305,   306,   307,   307,   307,   308,   308,   309,
     310,   310,   310,   311,   311,   312,   313,   313,   314,   314,
     315,   315,   315,   316,   316,   316,   316,   316,   316,   316,
     317,   318,   319,   319,   320,   321,   322,   322,   322,   322,
     323,   323,   323,   323,   323,   323,   323,   323,   324,   324,
     325,   325,   326,   326,   327,   327,   328,   328,   329,   329,
     329,   329,   330,   330,   331,   332,   333,   333,   334,   334,
     335,   335,   336,   336,   336,   337,   337,   338,   338,   338,
     339,   339,   340,   340,   341,   342,   343,   344,   345,   346,
     347,   347,   348,   349,   349,   350,   350,   351,   352,   352,
     353,   354,   354,   355,   356,   357,   357,   358,   358,   358,
     358,   358,   358,   359,   359,   359,   360,   360,   360,   361,
     361,   362,   363,   364,   364,   364,   365,   365,   366,   367,
     368,   369,   370,   370,   371,   372,   372,   373,   374,   374,
     375,   375,   376,   377,   377,   378,   378,   379,   379,   380,
     380,   381,   381,   381,   382,   382,   382,   382,   382,   383,
     384,   384,   384,   384,   385,   385,   385,   386,   386,   386,
     386,   387,   387,   387,   387,   388,   388,   388,   388,   388,
     388,   389,   389,   389,   389,   390,   390
};

/* YYR2[RULE-NUM] -- Number of symbols on the right-hand side of rule RULE-NUM.  */
static const yytype_int8 yyr2[] =
{
       0,     2,     5,     1,     3,     1,     2,     1,     0,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     3,     5,     2,     1,     1,     1,     1,     2,     2,
       4,     1,     1,     1,     1,     1,     1,     2,     9,     6,
       6,     7,     0,     2,     7,     4,     3,     5,     4,     0,
       2,     2,     4,     4,     4,     2,     3,     2,     0,     1,
       2,     2,     2,     2,     0,     6,     3,     3,     3,     1,
       3,     1,     0,     4,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     7,     7,     8,     9,     6,
       6,     6,     7,     6,     7,     8,     7,     6,     8,     8,
       5,     6,     5,     4,     7,     7,     7,     6,     6,     6,
       4,     4,     4,     6,     6,     8,     7,     1,     8,    10,
       8,     9,     1,     1,     1,     3,     2,    10,    13,     0,
       2,    10,     9,     8,     1,    12,     0,     1,     0,     1,
       9,     1,    10,     0,     1,     6,     5,     0,     2,     2,
       1,     6,     0,     1,     9,    16,     9,     5,     6,     6,
       4,     9,     9,     7,     7,     0,     2,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     7,
       7,     7,     7,     7,     7,     9,     7,     7,     9,     5,
       4,     1,     1,     0,     1,     2,     7,     9,     1,    14,
       5,     7,     9,    11,     0,     2,     2,     0,     2,     0,
       1,     1,     1,     4,     1,     1,     1,     1,     1,     1,
       1,     3,     6,     2,     2,     2,     1,     1,     1,     1,
       0,     2,     2,     4,     4,     3,     6,     6,     6,     3,
       2,     2,     9,     9,     2,     2,    12,    12,    11,    11,
       1,     2,     1,     1,     2,     1,     2,     1,     0,     1,
       0,     5,     0,     1,     0,     1,     0,     1,     1,     1,
       1,     1,     0,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     2,     5,     7,     4,     4,
       1,     3,     2,     2,     4,     0,     2,     1,     3,     2,
       3,     1,     4,     2,     1,     3,     4,     2,     2,     1,
       2,     1,     2,     1,     2,     2,     1,     2,     2,     3,
       4,     3,     7,     1,     5,     3,     5,     3,     5,     1,
       4,     7,     0,     3,     2,     3,     5,     1,     1,     1,
       1,     1,     1,     5,     1,     3,     1,     3,     1,     3,
       1,     3,     3,     1,     3,     3,     3,     3,     1,     1,
       3,     3,     3,     1,     3,     3,     1,     3,     3,     3,
       1,     2,     2,     2,     1,     1,     1,     3,     2,     4,
       1,     1,     1,     1,     1,     1,     1
};


enum { YYENOMEM = -2 };

#define yyerrok         (yyerrstatus = 0)
#define yyclearin       (yychar = YYEMPTY)

#define YYACCEPT        goto yyacceptlab
#define YYABORT         goto yyabortlab
#define YYERROR         goto yyerrorlab
#define YYNOMEM         goto yyexhaustedlab


#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)                                    \
  do                                                              \
    if (yychar == YYEMPTY)                                        \
      {                                                           \
        yychar = (Token);                                         \
        yylval = (Value);                                         \
        YYPOPSTACK (yylen);                                       \
        yystate = *yyssp;                                         \
        goto yybackup;                                            \
      }                                                           \
    else                                                          \
      {                                                           \
        yyerror (pBuilder, YY_("syntax error: cannot back up")); \
        YYERROR;                                                  \
      }                                                           \
  while (0)

/* Backward compatibility with an undocumented macro.
   Use YYerror or YYUNDEF. */
#define YYERRCODE YYUNDEF


/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)                        \
do {                                            \
  if (yydebug)                                  \
    YYFPRINTF Args;                             \
} while (0)




# define YY_SYMBOL_PRINT(Title, Kind, Value, Location)                    \
do {                                                                      \
  if (yydebug)                                                            \
    {                                                                     \
      YYFPRINTF (stderr, "%s ", Title);                                   \
      yy_symbol_print (stderr,                                            \
                  Kind, Value, pBuilder); \
      YYFPRINTF (stderr, "\n");                                           \
    }                                                                     \
} while (0)


/*-----------------------------------.
| Print this symbol's value on YYO.  |
`-----------------------------------*/

static void
yy_symbol_value_print (FILE *yyo,
                       yysymbol_kind_t yykind, YYSTYPE const * const yyvaluep, CISA_IR_Builder* pBuilder)
{
  FILE *yyoutput = yyo;
  YY_USE (yyoutput);
  YY_USE (pBuilder);
  if (!yyvaluep)
    return;
  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  YY_USE (yykind);
  YY_IGNORE_MAYBE_UNINITIALIZED_END
}


/*---------------------------.
| Print this symbol on YYO.  |
`---------------------------*/

static void
yy_symbol_print (FILE *yyo,
                 yysymbol_kind_t yykind, YYSTYPE const * const yyvaluep, CISA_IR_Builder* pBuilder)
{
  YYFPRINTF (yyo, "%s %s (",
             yykind < YYNTOKENS ? "token" : "nterm", yysymbol_name (yykind));

  yy_symbol_value_print (yyo, yykind, yyvaluep, pBuilder);
  YYFPRINTF (yyo, ")");
}

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (included).                                                   |
`------------------------------------------------------------------*/

static void
yy_stack_print (yy_state_t *yybottom, yy_state_t *yytop)
{
  YYFPRINTF (stderr, "Stack now");
  for (; yybottom <= yytop; yybottom++)
    {
      int yybot = *yybottom;
      YYFPRINTF (stderr, " %d", yybot);
    }
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)                            \
do {                                                            \
  if (yydebug)                                                  \
    yy_stack_print ((Bottom), (Top));                           \
} while (0)


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

static void
yy_reduce_print (yy_state_t *yyssp, YYSTYPE *yyvsp,
                 int yyrule, CISA_IR_Builder* pBuilder)
{
  int yylno = yyrline[yyrule];
  int yynrhs = yyr2[yyrule];
  int yyi;
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %d):\n",
             yyrule - 1, yylno);
  /* The symbols being reduced.  */
  for (yyi = 0; yyi < yynrhs; yyi++)
    {
      YYFPRINTF (stderr, "   $%d = ", yyi + 1);
      yy_symbol_print (stderr,
                       YY_ACCESSING_SYMBOL (+yyssp[yyi + 1 - yynrhs]),
                       &yyvsp[(yyi + 1) - (yynrhs)], pBuilder);
      YYFPRINTF (stderr, "\n");
    }
}

# define YY_REDUCE_PRINT(Rule)          \
do {                                    \
  if (yydebug)                          \
    yy_reduce_print (yyssp, yyvsp, Rule, pBuilder); \
} while (0)

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args) ((void) 0)
# define YY_SYMBOL_PRINT(Title, Kind, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   YYSTACK_ALLOC_MAXIMUM < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif


/* Context of a parse error.  */
typedef struct
{
  yy_state_t *yyssp;
  yysymbol_kind_t yytoken;
} yypcontext_t;

/* Put in YYARG at most YYARGN of the expected tokens given the
   current YYCTX, and return the number of tokens stored in YYARG.  If
   YYARG is null, return the number of expected tokens (guaranteed to
   be less than YYNTOKENS).  Return YYENOMEM on memory exhaustion.
   Return 0 if there are more than YYARGN expected tokens, yet fill
   YYARG up to YYARGN. */
static int
yypcontext_expected_tokens (const yypcontext_t *yyctx,
                            yysymbol_kind_t yyarg[], int yyargn)
{
  /* Actual size of YYARG. */
  int yycount = 0;
  int yyn = yypact[+*yyctx->yyssp];
  if (!yypact_value_is_default (yyn))
    {
      /* Start YYX at -YYN if negative to avoid negative indexes in
         YYCHECK.  In other words, skip the first -YYN actions for
         this state because they are default actions.  */
      int yyxbegin = yyn < 0 ? -yyn : 0;
      /* Stay within bounds of both yycheck and yytname.  */
      int yychecklim = YYLAST - yyn + 1;
      int yyxend = yychecklim < YYNTOKENS ? yychecklim : YYNTOKENS;
      int yyx;
      for (yyx = yyxbegin; yyx < yyxend; ++yyx)
        if (yycheck[yyx + yyn] == yyx && yyx != YYSYMBOL_YYerror
            && !yytable_value_is_error (yytable[yyx + yyn]))
          {
            if (!yyarg)
              ++yycount;
            else if (yycount == yyargn)
              return 0;
            else
              yyarg[yycount++] = YY_CAST (yysymbol_kind_t, yyx);
          }
    }
  if (yyarg && yycount == 0 && 0 < yyargn)
    yyarg[0] = YYSYMBOL_YYEMPTY;
  return yycount;
}




#ifndef yystrlen
# if defined __GLIBC__ && defined _STRING_H
#  define yystrlen(S) (YY_CAST (YYPTRDIFF_T, strlen (S)))
# else
/* Return the length of YYSTR.  */
static YYPTRDIFF_T
yystrlen (const char *yystr)
{
  YYPTRDIFF_T yylen;
  for (yylen = 0; yystr[yylen]; yylen++)
    continue;
  return yylen;
}
# endif
#endif

#ifndef yystpcpy
# if defined __GLIBC__ && defined _STRING_H && defined _GNU_SOURCE
#  define yystpcpy stpcpy
# else
/* Copy YYSRC to YYDEST, returning the address of the terminating '\0' in
   YYDEST.  */
static char *
yystpcpy (char *yydest, const char *yysrc)
{
  char *yyd = yydest;
  const char *yys = yysrc;

  while ((*yyd++ = *yys++) != '\0')
    continue;

  return yyd - 1;
}
# endif
#endif

#ifndef yytnamerr
/* Copy to YYRES the contents of YYSTR after stripping away unnecessary
   quotes and backslashes, so that it's suitable for yyerror.  The
   heuristic is that double-quoting is unnecessary unless the string
   contains an apostrophe, a comma, or backslash (other than
   backslash-backslash).  YYSTR is taken from yytname.  If YYRES is
   null, do not copy; instead, return the length of what the result
   would have been.  */
static YYPTRDIFF_T
yytnamerr (char *yyres, const char *yystr)
{
  if (*yystr == '"')
    {
      YYPTRDIFF_T yyn = 0;
      char const *yyp = yystr;
      for (;;)
        switch (*++yyp)
          {
          case '\'':
          case ',':
            goto do_not_strip_quotes;

          case '\\':
            if (*++yyp != '\\')
              goto do_not_strip_quotes;
            else
              goto append;

          append:
          default:
            if (yyres)
              yyres[yyn] = *yyp;
            yyn++;
            break;

          case '"':
            if (yyres)
              yyres[yyn] = '\0';
            return yyn;
          }
    do_not_strip_quotes: ;
    }

  if (yyres)
    return yystpcpy (yyres, yystr) - yyres;
  else
    return yystrlen (yystr);
}
#endif


static int
yy_syntax_error_arguments (const yypcontext_t *yyctx,
                           yysymbol_kind_t yyarg[], int yyargn)
{
  /* Actual size of YYARG. */
  int yycount = 0;
  /* There are many possibilities here to consider:
     - If this state is a consistent state with a default action, then
       the only way this function was invoked is if the default action
       is an error action.  In that case, don't check for expected
       tokens because there are none.
     - The only way there can be no lookahead present (in yychar) is if
       this state is a consistent state with a default action.  Thus,
       detecting the absence of a lookahead is sufficient to determine
       that there is no unexpected or expected token to report.  In that
       case, just report a simple "syntax error".
     - Don't assume there isn't a lookahead just because this state is a
       consistent state with a default action.  There might have been a
       previous inconsistent state, consistent state with a non-default
       action, or user semantic action that manipulated yychar.
     - Of course, the expected token list depends on states to have
       correct lookahead information, and it depends on the parser not
       to perform extra reductions after fetching a lookahead from the
       scanner and before detecting a syntax error.  Thus, state merging
       (from LALR or IELR) and default reductions corrupt the expected
       token list.  However, the list is correct for canonical LR with
       one exception: it will still contain any token that will not be
       accepted due to an error action in a later state.
  */
  if (yyctx->yytoken != YYSYMBOL_YYEMPTY)
    {
      int yyn;
      if (yyarg)
        yyarg[yycount] = yyctx->yytoken;
      ++yycount;
      yyn = yypcontext_expected_tokens (yyctx,
                                        yyarg ? yyarg + 1 : yyarg, yyargn - 1);
      if (yyn == YYENOMEM)
        return YYENOMEM;
      else
        yycount += yyn;
    }
  return yycount;
}

/* Copy into *YYMSG, which is of size *YYMSG_ALLOC, an error message
   about the unexpected token YYTOKEN for the state stack whose top is
   YYSSP.

   Return 0 if *YYMSG was successfully written.  Return -1 if *YYMSG is
   not large enough to hold the message.  In that case, also set
   *YYMSG_ALLOC to the required number of bytes.  Return YYENOMEM if the
   required number of bytes is too large to store.  */
static int
yysyntax_error (YYPTRDIFF_T *yymsg_alloc, char **yymsg,
                const yypcontext_t *yyctx)
{
  enum { YYARGS_MAX = 5 };
  /* Internationalized format string. */
  const char *yyformat = YY_NULLPTR;
  /* Arguments of yyformat: reported tokens (one for the "unexpected",
     one per "expected"). */
  yysymbol_kind_t yyarg[YYARGS_MAX];
  /* Cumulated lengths of YYARG.  */
  YYPTRDIFF_T yysize = 0;

  /* Actual size of YYARG. */
  int yycount = yy_syntax_error_arguments (yyctx, yyarg, YYARGS_MAX);
  if (yycount == YYENOMEM)
    return YYENOMEM;

  switch (yycount)
    {
#define YYCASE_(N, S)                       \
      case N:                               \
        yyformat = S;                       \
        break
    default: /* Avoid compiler warnings. */
      YYCASE_(0, YY_("syntax error"));
      YYCASE_(1, YY_("syntax error, unexpected %s"));
      YYCASE_(2, YY_("syntax error, unexpected %s, expecting %s"));
      YYCASE_(3, YY_("syntax error, unexpected %s, expecting %s or %s"));
      YYCASE_(4, YY_("syntax error, unexpected %s, expecting %s or %s or %s"));
      YYCASE_(5, YY_("syntax error, unexpected %s, expecting %s or %s or %s or %s"));
#undef YYCASE_
    }

  /* Compute error message size.  Don't count the "%s"s, but reserve
     room for the terminator.  */
  yysize = yystrlen (yyformat) - 2 * yycount + 1;
  {
    int yyi;
    for (yyi = 0; yyi < yycount; ++yyi)
      {
        YYPTRDIFF_T yysize1
          = yysize + yytnamerr (YY_NULLPTR, yytname[yyarg[yyi]]);
        if (yysize <= yysize1 && yysize1 <= YYSTACK_ALLOC_MAXIMUM)
          yysize = yysize1;
        else
          return YYENOMEM;
      }
  }

  if (*yymsg_alloc < yysize)
    {
      *yymsg_alloc = 2 * yysize;
      if (! (yysize <= *yymsg_alloc
             && *yymsg_alloc <= YYSTACK_ALLOC_MAXIMUM))
        *yymsg_alloc = YYSTACK_ALLOC_MAXIMUM;
      return -1;
    }

  /* Avoid sprintf, as that infringes on the user's name space.
     Don't have undefined behavior even if the translation
     produced a string with the wrong number of "%s"s.  */
  {
    char *yyp = *yymsg;
    int yyi = 0;
    while ((*yyp = *yyformat) != '\0')
      if (*yyp == '%' && yyformat[1] == 's' && yyi < yycount)
        {
          yyp += yytnamerr (yyp, yytname[yyarg[yyi++]]);
          yyformat += 2;
        }
      else
        {
          ++yyp;
          ++yyformat;
        }
  }
  return 0;
}


/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

static void
yydestruct (const char *yymsg,
            yysymbol_kind_t yykind, YYSTYPE *yyvaluep, CISA_IR_Builder* pBuilder)
{
  YY_USE (yyvaluep);
  YY_USE (pBuilder);
  if (!yymsg)
    yymsg = "Deleting";
  YY_SYMBOL_PRINT (yymsg, yykind, yyvaluep, yylocationp);

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  YY_USE (yykind);
  YY_IGNORE_MAYBE_UNINITIALIZED_END
}


/* Lookahead token kind.  */
int yychar;

/* The semantic value of the lookahead symbol.  */
YYSTYPE yylval;
/* Number of syntax errors so far.  */
int yynerrs;




/*----------.
| yyparse.  |
`----------*/

int
yyparse (CISA_IR_Builder* pBuilder)
{
    yy_state_fast_t yystate = 0;
    /* Number of tokens to shift before error messages enabled.  */
    int yyerrstatus = 0;

    /* Refer to the stacks through separate pointers, to allow yyoverflow
       to reallocate them elsewhere.  */

    /* Their size.  */
    YYPTRDIFF_T yystacksize = YYINITDEPTH;

    /* The state stack: array, bottom, top.  */
    yy_state_t yyssa[YYINITDEPTH];
    yy_state_t *yyss = yyssa;
    yy_state_t *yyssp = yyss;

    /* The semantic value stack: array, bottom, top.  */
    YYSTYPE yyvsa[YYINITDEPTH];
    YYSTYPE *yyvs = yyvsa;
    YYSTYPE *yyvsp = yyvs;

  int yyn;
  /* The return value of yyparse.  */
  int yyresult;
  /* Lookahead symbol kind.  */
  yysymbol_kind_t yytoken = YYSYMBOL_YYEMPTY;
  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;

  /* Buffer for error messages, and its allocated size.  */
  char yymsgbuf[128];
  char *yymsg = yymsgbuf;
  YYPTRDIFF_T yymsg_alloc = sizeof yymsgbuf;

#define YYPOPSTACK(N)   (yyvsp -= (N), yyssp -= (N))

  /* The number of symbols on the RHS of the reduced rule.
     Keep to zero when no symbol should be popped.  */
  int yylen = 0;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yychar = YYEMPTY; /* Cause a token to be read.  */

  goto yysetstate;


/*------------------------------------------------------------.
| yynewstate -- push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed.  So pushing a state here evens the stacks.  */
  yyssp++;


/*--------------------------------------------------------------------.
| yysetstate -- set current state (the top of the stack) to yystate.  |
`--------------------------------------------------------------------*/
yysetstate:
  YYDPRINTF ((stderr, "Entering state %d\n", yystate));
  YY_ASSERT (0 <= yystate && yystate < YYNSTATES);
  YY_IGNORE_USELESS_CAST_BEGIN
  *yyssp = YY_CAST (yy_state_t, yystate);
  YY_IGNORE_USELESS_CAST_END
  YY_STACK_PRINT (yyss, yyssp);

  if (yyss + yystacksize - 1 <= yyssp)
#if !defined yyoverflow && !defined YYSTACK_RELOCATE
    YYNOMEM;
#else
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYPTRDIFF_T yysize = yyssp - yyss + 1;

# if defined yyoverflow
      {
        /* Give user a chance to reallocate the stack.  Use copies of
           these so that the &'s don't force the real ones into
           memory.  */
        yy_state_t *yyss1 = yyss;
        YYSTYPE *yyvs1 = yyvs;

        /* Each stack pointer address is followed by the size of the
           data in use in that stack, in bytes.  This used to be a
           conditional around just the two extra args, but that might
           be undefined if yyoverflow is a macro.  */
        yyoverflow (YY_("memory exhausted"),
                    &yyss1, yysize * YYSIZEOF (*yyssp),
                    &yyvs1, yysize * YYSIZEOF (*yyvsp),
                    &yystacksize);
        yyss = yyss1;
        yyvs = yyvs1;
      }
# else /* defined YYSTACK_RELOCATE */
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
        YYNOMEM;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
        yystacksize = YYMAXDEPTH;

      {
        yy_state_t *yyss1 = yyss;
        union yyalloc *yyptr =
          YY_CAST (union yyalloc *,
                   YYSTACK_ALLOC (YY_CAST (YYSIZE_T, YYSTACK_BYTES (yystacksize))));
        if (! yyptr)
          YYNOMEM;
        YYSTACK_RELOCATE (yyss_alloc, yyss);
        YYSTACK_RELOCATE (yyvs_alloc, yyvs);
#  undef YYSTACK_RELOCATE
        if (yyss1 != yyssa)
          YYSTACK_FREE (yyss1);
      }
# endif

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;

      YY_IGNORE_USELESS_CAST_BEGIN
      YYDPRINTF ((stderr, "Stack size increased to %ld\n",
                  YY_CAST (long, yystacksize)));
      YY_IGNORE_USELESS_CAST_END

      if (yyss + yystacksize - 1 <= yyssp)
        YYABORT;
    }
#endif /* !defined yyoverflow && !defined YYSTACK_RELOCATE */


  if (yystate == YYFINAL)
    YYACCEPT;

  goto yybackup;


/*-----------.
| yybackup.  |
`-----------*/
yybackup:
  /* Do appropriate processing given the current state.  Read a
     lookahead token if we need one and don't already have one.  */

  /* First try to decide what to do without reference to lookahead token.  */
  yyn = yypact[yystate];
  if (yypact_value_is_default (yyn))
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* YYCHAR is either empty, or end-of-input, or a valid lookahead.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token\n"));
      yychar = yylex (pBuilder);
    }

  if (yychar <= YYEOF)
    {
      yychar = YYEOF;
      yytoken = YYSYMBOL_YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else if (yychar == YYerror)
    {
      /* The scanner already issued an error message, process directly
         to error recovery.  But do not keep the error token as
         lookahead, it is too special and may lead us to an endless
         loop in error recovery. */
      yychar = YYUNDEF;
      yytoken = YYSYMBOL_YYerror;
      goto yyerrlab1;
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YY_SYMBOL_PRINT ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yytable_value_is_error (yyn))
        goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  /* Shift the lookahead token.  */
  YY_SYMBOL_PRINT ("Shifting", yytoken, &yylval, &yylloc);
  yystate = yyn;
  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END

  /* Discard the shifted token.  */
  yychar = YYEMPTY;
  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     '$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];


  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
  case 2: /* Listing: NewlinesOpt ListingHeader NewlinesOpt Statements NewlinesOpt  */
#line 623 "CISA.y"
                                                                      {
        TRACE("** Listing Complete\n");
        pBuilder->CISA_post_file_parse();
    }
#line 3019 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.12037.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 23: /* Scope: ScopeStart error  */
#line 653 "CISA.y"
                       {
        PARSE_ERROR_AT((int)(yyvsp[-1].intval), "unclosed scope");
    }
#line 3027 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.12037.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 24: /* ScopeStart: LBRACE  */
#line 657 "CISA.y"
           {
        pBuilder->CISA_push_decl_scope();
        (yyval.intval) = CISAlineno;
    }
#line 3036 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.12037.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 25: /* ScopeEnd: RBRACE  */
#line 661 "CISA.y"
                 {pBuilder->CISA_pop_decl_scope();}
#line 3042 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.12037.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 28: /* DirectiveKernel: DIRECTIVE_KERNEL IdentOrStringLit  */
#line 672 "CISA.y"
    {
        VISAKernel *cisa_kernel = NULL;
        pBuilder->AddKernel(cisa_kernel, (yyvsp[0].string));
    }
#line 3051 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.12037.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 29: /* DirectiveGlobalFunction: DIRECTIVE_GLOBAL_FUNC IdentOrStringLit  */
#line 680 "CISA.y"
  {
      VISAFunction *cisa_kernel = NULL;
      pBuilder->AddFunction(cisa_kernel, (yyvsp[0].string));
  }
#line 3060 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.12037.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 30: /* DirectiveVersion: DIRECTIVE_VERSION DEC_LIT DOT DEC_LIT  */
#line 688 "CISA.y"
   {
       pBuilder->CISA_IR_setVersion((unsigned char)(yyvsp[-2].intval), (unsigned char)(yyvsp[0].intval));
   }
#line 3068 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.12037.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 37: /* DeclFunction: DIRECTIVE_FUNCDECL STRING_LIT  */
#line 702 "CISA.y"
    {
        // do nothing as it's informational only
    }
#line 3076 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.12037.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 38: /* DeclVariable: DIRECTIVE_DECL IDENT V_TYPE_EQ_G DECL_DATA_TYPE NUM_ELTS_EQ IntExp AlignAttrOpt AliasAttrOpt GenAttrOpt  */
#line 709 "CISA.y"
    {
       ABORT_ON_FAIL(pBuilder->CISA_general_variable_decl(
           (yyvsp[-7].string), (unsigned int)(yyvsp[-3].intval), (yyvsp[-5].type), (yyvsp[-2].align), (yyvsp[-1].alias).aliasname, (yyvsp[-1].alias).offset, AttrOptVar, CISAlineno));
       AttrOptVar.clear();
    }
#line 3086 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.12037.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 39: /* DeclAddress: DIRECTIVE_DECL IDENT V_TYPE_EQ_A NUM_ELTS_EQ IntExp GenAttrOpt  */
#line 717 "CISA.y"
   {
       ABORT_ON_FAIL(
           pBuilder->CISA_addr_variable_decl((yyvsp[-4].string), (unsigned int)(yyvsp[-1].intval), ISA_TYPE_UW, AttrOptVar, CISAlineno));
       AttrOptVar.clear();
   }
#line 3096 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.12037.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 40: /* DeclPredicate: DIRECTIVE_DECL IDENT V_TYPE_EQ_P NUM_ELTS_EQ IntExp GenAttrOpt  */
#line 725 "CISA.y"
   {
       ABORT_ON_FAIL(pBuilder->CISA_predicate_variable_decl((yyvsp[-4].string), (unsigned int)(yyvsp[-1].intval), AttrOptVar, CISAlineno));
       AttrOptVar.clear();
   }
#line 3105 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.12037.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 41: /* DeclSampler: DIRECTIVE_DECL IDENT V_TYPE_EQ_S NUM_ELTS_EQ IntExp VNameEqOpt GenAttrOpt  */
#line 732 "CISA.y"
   {
       ABORT_ON_FAIL(pBuilder->CISA_sampler_variable_decl((yyvsp[-5].string), (int)(yyvsp[-2].intval), (yyvsp[-1].string), CISAlineno));
   }
#line 3113 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.12037.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 42: /* VNameEqOpt: %empty  */
#line 735 "CISA.y"
                    {(yyval.string) = "";}
#line 3119 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.12037.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 43: /* VNameEqOpt: V_NAME_EQ IDENT  */
#line 735 "CISA.y"
                                                 {(yyval.string) = (yyvsp[0].string);}
#line 3125 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.12037.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 44: /* DeclSurface: DIRECTIVE_DECL IDENT V_TYPE_EQ_T NUM_ELTS_EQ IntExp VNameEqOpt GenAttrOpt  */
#line 739 "CISA.y"
   {
       ABORT_ON_FAIL(pBuilder->CISA_surface_variable_decl((yyvsp[-5].string), (int)(yyvsp[-2].intval), (yyvsp[-1].string), AttrOptVar, CISAlineno));
       AttrOptVar.clear();
   }
#line 3134 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.12037.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 45: /* DirectiveInput: DIRECTIVE_INPUT IDENT InputOffset InputSize  */
#line 747 "CISA.y"
    {
        ABORT_ON_FAIL(pBuilder->CISA_input_directive((yyvsp[-2].string), (short)(yyvsp[-1].intval), (unsigned short)(yyvsp[0].intval), CISAlineno));
    }
#line 3142 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.12037.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 46: /* DirectiveInput: DIRECTIVE_INPUT IDENT InputOffset  */
#line 752 "CISA.y"
    {
        int64_t size = 0;
        ABORT_ON_FAIL(pBuilder->CISA_eval_sizeof_decl(CISAlineno, (yyvsp[-1].string), size));
        MUST_HOLD(size < 0x10000, "declaration size is too large");
        ABORT_ON_FAIL(pBuilder->CISA_input_directive((yyvsp[-1].string), (short)(yyvsp[0].intval), (unsigned short)size, CISAlineno));
    }
#line 3153 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.12037.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 47: /* DirectiveImplicitInput: DIRECTIVE_IMPLICIT IDENT InputOffset InputSize GenAttrOpt  */
#line 764 "CISA.y"
    {
        ABORT_ON_FAIL(pBuilder->CISA_implicit_input_directive(
            (yyvsp[-4].string), (yyvsp[-3].string), (short)(yyvsp[-2].intval), (unsigned short)(yyvsp[-1].intval), CISAlineno));
    }
#line 3162 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.12037.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 48: /* DirectiveImplicitInput: DIRECTIVE_IMPLICIT IDENT InputOffset GenAttrOpt  */
#line 771 "CISA.y"
    {
        int64_t size = 0;
        ABORT_ON_FAIL(pBuilder->CISA_eval_sizeof_decl(CISAlineno, (yyvsp[-2].string), size));
        MUST_HOLD(size < 0x10000, "declaration size is too large");
        ABORT_ON_FAIL(pBuilder->CISA_input_directive((yyvsp[-2].string), (short)(yyvsp[-1].intval), (unsigned short)size, CISAlineno));
    }
#line 3173 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.12037.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 49: /* InputOffset: %empty  */
#line 778 "CISA.y"
                    {(yyval.intval) = 0;}
#line 3179 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.12037.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 50: /* InputOffset: OFFSET_EQ IntExp  */
#line 778 "CISA.y"
                                                 {(yyval.intval) = (yyvsp[0].intval);}
#line 3185 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.12037.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 51: /* InputSize: SIZE_EQ IntExp  */
#line 779 "CISA.y"
                          {(yyval.intval) = (yyvsp[0].intval);}
#line 3191 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.12037.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 52: /* DirectiveParameter: DIRECTIVE_PARAMETER IDENT InputSize GenAttrOpt  */
#line 786 "CISA.y"
                                                   {
        ABORT_ON_FAIL(pBuilder->CISA_input_directive((yyvsp[-2].string), 0, (unsigned short)(yyvsp[-1].intval), CISAlineno));
    }
#line 3199 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.12037.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 53: /* DirectiveAttr: DIRECTIVE_KERNEL_ATTR IDENT EQUALS STRING_LIT  */
#line 792 "CISA.y"
                                                  {
        ABORT_ON_FAIL(pBuilder->CISA_attr_directive((yyvsp[-2].string), (yyvsp[0].string), CISAlineno));
    }
#line 3207 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.12037.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 54: /* DirectiveAttr: DIRECTIVE_KERNEL_ATTR IDENT EQUALS IntExp  */
#line 796 "CISA.y"
                                              {
        ABORT_ON_FAIL(pBuilder->CISA_attr_directiveNum((yyvsp[-2].string), (uint32_t)(yyvsp[0].intval), CISAlineno));
    }
#line 3215 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.12037.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 55: /* DirectiveAttr: DIRECTIVE_KERNEL_ATTR IDENT  */
#line 800 "CISA.y"
                                {
        ABORT_ON_FAIL(pBuilder->CISA_attr_directive((yyvsp[0].string), nullptr, CISAlineno));
    }
#line 3223 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.12037.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 56: /* DirectiveAttr: DIRECTIVE_KERNEL_ATTR IDENT EQUALS  */
#line 804 "CISA.y"
                                       {
        ABORT_ON_FAIL(pBuilder->CISA_attr_directive((yyvsp[-1].string), nullptr, CISAlineno));
    }
#line 3231 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.12037.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 57: /* DirectiveFunc: DIRECTIVE_FUNC IdentOrStringLit  */
#line 810 "CISA.y"
    {
        ABORT_ON_FAIL(pBuilder->CISA_function_directive((yyvsp[0].string), CISAlineno));
    }
#line 3239 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.12037.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 58: /* AlignAttrOpt: %empty  */
#line 815 "CISA.y"
                     {(yyval.align) = ALIGN_BYTE;}
#line 3245 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.12037.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 60: /* Align: ALIGN_EQ ALIGN_KEYWORD  */
#line 817 "CISA.y"
                           { // 2GRF, 32word, ...
        (yyval.align) = (yyvsp[0].align);
    }
#line 3253 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.12037.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 61: /* Align: ALIGN_EQ IDENT  */
#line 821 "CISA.y"
                   { // e.g. byte, word, dword, qword, GRF, GRFx2
       if (!ParseAlign(pBuilder, (yyvsp[0].string), (yyval.align))) {
           PARSE_ERROR((yyvsp[0].string), ": invalid align value");
       }
    }
#line 3263 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.12037.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 62: /* Align: ALIGN_EQ IntExp  */
#line 827 "CISA.y"
                    {
        // e.g. %sizeof(GRF) or %sizeof(DECL)
        (yyval.align) = AlignBytesToVisaAlignment((int)(yyvsp[0].intval));
        if ((yyval.align) == ALIGN_UNDEF) {
            PARSE_ERROR("invalid align size (must be 1, 2, 4, 8, ..., 128)");
        }
    }
#line 3275 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.12037.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 63: /* Align: ALIGN_EQ error  */
#line 835 "CISA.y"
                   {
        PARSE_ERROR("syntax error in align attribute");
    }
#line 3283 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.12037.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 64: /* AliasAttrOpt: %empty  */
#line 842 "CISA.y"
    {
       (yyval.alias).aliasname = NULL;
       (yyval.alias).offset = 0;
    }
#line 3292 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.12037.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 65: /* AliasAttrOpt: ALIAS_EQ LANGLE Var COMMA IntExpNRA RANGLE  */
#line 847 "CISA.y"
    {
       (yyval.alias).aliasname = (yyvsp[-3].string);
       (yyval.alias).offset = (int)(yyvsp[-1].intval);
    }
#line 3301 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.12037.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 66: /* AliasAttrOpt: ALIAS_EQ LANGLE error  */
#line 852 "CISA.y"
    {
       PARSE_ERROR("syntax error in alias attribute");
    }
#line 3309 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.12037.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 67: /* OneAttr: IDENT EQUALS IntExpNRA  */
#line 858 "CISA.y"
    {
      (yyval.pattr_gen) = pBuilder->CISA_Create_Attr((yyvsp[-2].string), (yyvsp[0].intval), nullptr);
    }
#line 3317 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.12037.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 68: /* OneAttr: IDENT EQUALS STRING_LIT  */
#line 862 "CISA.y"
    {
      (yyval.pattr_gen) = pBuilder->CISA_Create_Attr((yyvsp[-2].string), 0, (yyvsp[0].string));
    }
#line 3325 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.12037.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 69: /* OneAttr: IDENT  */
#line 866 "CISA.y"
    {
      (yyval.pattr_gen) = pBuilder->CISA_Create_Attr((yyvsp[0].string), 0, nullptr);
    }
#line 3333 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.12037.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 70: /* AttrOpt: AttrOpt COMMA OneAttr  */
#line 872 "CISA.y"
    {
      AttrOptVar.push_back((yyvsp[0].pattr_gen));
    }
#line 3341 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.12037.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 71: /* AttrOpt: OneAttr  */
#line 877 "CISA.y"
    {
      AttrOptVar.push_back((yyvsp[0].pattr_gen));
    }
#line 3349 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.12037.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 72: /* GenAttrOpt: %empty  */
#line 883 "CISA.y"
    {
        (yyval.intval) = 0;
    }
#line 3357 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.12037.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 73: /* GenAttrOpt: ATTR_EQ LBRACE AttrOpt RBRACE  */
#line 887 "CISA.y"
    {
        (yyval.intval) = 1;
    }
#line 3365 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.12037.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 124: /* Label: LABEL  */
#line 948 "CISA.y"
             {pBuilder->CISA_create_label((yyvsp[0].string), CISAlineno);}
#line 3371 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.12037.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 125: /* LogicInstruction: Predicate BINARY_LOGIC_OP SatModOpt ExecSize VecDstOperand_G_I VecSrcOperand_G_I_IMM VecSrcOperand_G_I_IMM  */
#line 953 "CISA.y"
    {
        pBuilder->CISA_create_logic_instruction((yyvsp[-6].pred_reg), (yyvsp[-5].opcode), (yyvsp[-4].sat), (yyvsp[-3].emask_exec_size).emask, (yyvsp[-3].emask_exec_size).exec_size,
            (yyvsp[-2].genOperand).cisa_gen_opnd, (yyvsp[-1].genOperand).cisa_gen_opnd, (yyvsp[0].genOperand).cisa_gen_opnd, NULL, NULL, CISAlineno);
    }
#line 3380 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.12037.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 126: /* LogicInstruction: Predicate BINARY_LOGIC_OP SatModOpt ExecSize PredVar PredVar PredVar  */
#line 959 "CISA.y"
    {
        pBuilder->CISA_create_logic_instruction((yyvsp[-5].opcode), (yyvsp[-3].emask_exec_size).emask, (yyvsp[-3].emask_exec_size).exec_size, (yyvsp[-2].vISADecl), (yyvsp[-1].vISADecl), (yyvsp[0].vISADecl), CISAlineno);
    }
#line 3388 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.12037.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 127: /* LogicInstruction: Predicate TERNARY_LOGIC_OP SatModOpt ExecSize VecDstOperand_G_I VecSrcOperand_G_I_IMM VecSrcOperand_G_I_IMM VecSrcOperand_G_I_IMM  */
#line 964 "CISA.y"
    {
        pBuilder->CISA_create_logic_instruction((yyvsp[-7].pred_reg), (yyvsp[-6].opcode), (yyvsp[-5].sat), (yyvsp[-4].emask_exec_size).emask, (yyvsp[-4].emask_exec_size).exec_size,
            (yyvsp[-3].genOperand).cisa_gen_opnd, (yyvsp[-2].genOperand).cisa_gen_opnd, (yyvsp[-1].genOperand).cisa_gen_opnd, (yyvsp[0].genOperand).cisa_gen_opnd, NULL, CISAlineno);
    }
#line 3397 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.12037.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 128: /* LogicInstruction: Predicate QUATERNARY_LOGIC_OP SatModOpt ExecSize VecDstOperand_G_I VecSrcOperand_G_I_IMM VecSrcOperand_G_I_IMM VecSrcOperand_G_I_IMM VecSrcOperand_G_I_IMM  */
#line 970 "CISA.y"
    {
        pBuilder->CISA_create_logic_instruction((yyvsp[-8].pred_reg), (yyvsp[-7].opcode), (yyvsp[-6].sat), (yyvsp[-5].emask_exec_size).emask, (yyvsp[-5].emask_exec_size).exec_size,
            (yyvsp[-4].genOperand).cisa_gen_opnd, (yyvsp[-3].genOperand).cisa_gen_opnd, (yyvsp[-2].genOperand).cisa_gen_opnd, (yyvsp[-1].genOperand).cisa_gen_opnd, (yyvsp[0].genOperand).cisa_gen_opnd, CISAlineno);
    }
#line 3406 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.12037.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 129: /* UnaryLogicInstruction: Predicate UNARY_LOGIC_OP SatModOpt ExecSize VecDstOperand_G_I VecSrcOperand_G_I_IMM  */
#line 978 "CISA.y"
    {
        pBuilder->CISA_create_logic_instruction((yyvsp[-5].pred_reg), (yyvsp[-4].opcode), (yyvsp[-3].sat), (yyvsp[-2].emask_exec_size).emask, (yyvsp[-2].emask_exec_size).exec_size,
            (yyvsp[-1].genOperand).cisa_gen_opnd, (yyvsp[0].genOperand).cisa_gen_opnd, NULL, NULL, NULL, CISAlineno);
    }
#line 3415 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.12037.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 130: /* UnaryLogicInstruction: Predicate UNARY_LOGIC_OP SatModOpt ExecSize PredVar PredVar  */
#line 984 "CISA.y"
    {
        pBuilder->CISA_create_logic_instruction((yyvsp[-4].opcode), (yyvsp[-2].emask_exec_size).emask, (yyvsp[-2].emask_exec_size).exec_size,
            (yyvsp[-1].vISADecl), (yyvsp[0].vISADecl), NULL, CISAlineno);
    }
#line 3424 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.12037.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 131: /* MathInstruction_2OPND: Predicate MATH2_OP SatModOpt ExecSize VecDstOperand_G_I VecSrcOperand_G_I_IMM  */
#line 991 "CISA.y"
    {
        pBuilder->CISA_create_math_instruction((yyvsp[-5].pred_reg), (yyvsp[-4].opcode), (yyvsp[-3].sat), (yyvsp[-2].emask_exec_size).emask, (yyvsp[-2].emask_exec_size).exec_size,
            (yyvsp[-1].genOperand).cisa_gen_opnd, (yyvsp[0].genOperand).cisa_gen_opnd, NULL, CISAlineno);
    }
#line 3433 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.12037.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 132: /* MathInstruction_3OPND: Predicate MATH3_OP SatModOpt ExecSize VecDstOperand_G_I VecSrcOperand_G_I_IMM VecSrcOperand_G_I_IMM  */
#line 998 "CISA.y"
    {
        pBuilder->CISA_create_math_instruction((yyvsp[-6].pred_reg), (yyvsp[-5].opcode), (yyvsp[-4].sat), (yyvsp[-3].emask_exec_size).emask, (yyvsp[-3].emask_exec_size).exec_size,
            (yyvsp[-2].genOperand).cisa_gen_opnd, (yyvsp[-1].genOperand).cisa_gen_opnd, (yyvsp[0].genOperand).cisa_gen_opnd, CISAlineno);
    }
#line 3442 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.12037.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 133: /* ArithInstruction_2OPND: Predicate ARITH2_OP SatModOpt ExecSize VecDstOperand_G_I VecSrcOperand_G_I_IMM  */
#line 1005 "CISA.y"
    {
        pBuilder->CISA_create_arith_instruction((yyvsp[-5].pred_reg), (yyvsp[-4].opcode), (yyvsp[-3].sat), (yyvsp[-2].emask_exec_size).emask, (yyvsp[-2].emask_exec_size).exec_size,
            (yyvsp[-1].genOperand).cisa_gen_opnd, (yyvsp[0].genOperand).cisa_gen_opnd, NULL, NULL, CISAlineno);
    }
#line 3451 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.12037.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 134: /* ArithInstruction_3OPND: Predicate ARITH3_OP SatModOpt ExecSize VecDstOperand_G_I VecSrcOperand_G_I_IMM VecSrcOperand_G_I_IMM  */
#line 1012 "CISA.y"
    {
        MUST_HOLD(!(((yyvsp[-5].opcode) == ISA_LINE) && ((yyvsp[-1].genOperand).type == OPERAND_IMMEDIATE || (yyvsp[-1].genOperand).type == OPERAND_INDIRECT)),
            "wrong type of src0 operand");
        pBuilder->CISA_create_arith_instruction(
            (yyvsp[-6].pred_reg), (yyvsp[-5].opcode), (yyvsp[-4].sat), (yyvsp[-3].emask_exec_size).emask, (yyvsp[-3].emask_exec_size).exec_size,
            (yyvsp[-2].genOperand).cisa_gen_opnd, (yyvsp[-1].genOperand).cisa_gen_opnd, (yyvsp[0].genOperand).cisa_gen_opnd, NULL, CISAlineno);
    }
#line 3463 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.12037.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 135: /* ArithInstruction_4OPND: Predicate ARITH4_OP SatModOpt ExecSize VecDstOperand_G_I VecSrcOperand_G_I_IMM VecSrcOperand_G_I_IMM VecSrcOperand_G_I_IMM  */
#line 1024 "CISA.y"
     {
         pBuilder->CISA_create_arith_instruction((yyvsp[-7].pred_reg), (yyvsp[-6].opcode), (yyvsp[-5].sat), (yyvsp[-4].emask_exec_size).emask, (yyvsp[-4].emask_exec_size).exec_size,
            (yyvsp[-3].genOperand).cisa_gen_opnd, (yyvsp[-2].genOperand).cisa_gen_opnd, (yyvsp[-1].genOperand).cisa_gen_opnd, (yyvsp[0].genOperand).cisa_gen_opnd, CISAlineno);
     }
#line 3472 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.12037.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 136: /* ArithInstruction_4OPND: Predicate ARITH4_OP2 ExecSize VecDstOperand_G_I VecDstOperand_G_I VecSrcOperand_G_I_IMM VecSrcOperand_G_I_IMM  */
#line 1031 "CISA.y"
     {
        pBuilder->CISA_create_arith_instruction2((yyvsp[-6].pred_reg), (yyvsp[-5].opcode), (yyvsp[-4].emask_exec_size).emask, (yyvsp[-4].emask_exec_size).exec_size,
            (yyvsp[-3].genOperand).cisa_gen_opnd, (yyvsp[-2].genOperand).cisa_gen_opnd, (yyvsp[-1].genOperand).cisa_gen_opnd, (yyvsp[0].genOperand).cisa_gen_opnd, CISAlineno);
     }
#line 3481 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.12037.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 137: /* DpasInstruction: DPAS_OP ExecSize RawOperand RawOperand RawOperand VecSrcOpndSimple  */
#line 1040 "CISA.y"
    {
        pBuilder->CISA_create_dpas_instruction(
            (yyvsp[-5].dpas_info).opcode, (yyvsp[-4].emask_exec_size).emask, (yyvsp[-4].emask_exec_size).exec_size,
            (yyvsp[-3].RawVar), (yyvsp[-2].RawVar), (yyvsp[-1].RawVar), (yyvsp[0].genOperand).cisa_gen_opnd,
            (yyvsp[-5].dpas_info).src2Precision, (yyvsp[-5].dpas_info).src1Precision, (yyvsp[-5].dpas_info).depth, (yyvsp[-5].dpas_info).count, CISAlineno);
    }
#line 3492 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.12037.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 138: /* BfnInstruction: Predicate BFN_OP SatModOpt ExecSize VecDstOperand_G_I VecSrcOperand_G_I_IMM VecSrcOperand_G_I_IMM VecSrcOperand_G_I_IMM  */
#line 1050 "CISA.y"
    {
        pBuilder->CISA_create_bfn_instruction((yyvsp[-7].pred_reg), (yyvsp[-6].bfn_info).func_ctrl , (yyvsp[-5].sat), (yyvsp[-4].emask_exec_size).emask, (yyvsp[-4].emask_exec_size).exec_size,
            (yyvsp[-3].genOperand).cisa_gen_opnd, (yyvsp[-2].genOperand).cisa_gen_opnd, (yyvsp[-1].genOperand).cisa_gen_opnd, (yyvsp[0].genOperand).cisa_gen_opnd, CISAlineno);
    }
#line 3501 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.12037.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 139: /* QwScatterInstruction: Predicate QW_SCATTER_OP DOT DEC_LIT ExecSize Var RawOperand RawOperand  */
#line 1056 "CISA.y"
    {
        ABORT_ON_FAIL(pBuilder->CISA_create_qword_scatter_instruction(
            (yyvsp[-6].opcode), (yyvsp[-7].pred_reg), (yyvsp[-3].emask_exec_size).emask, (yyvsp[-3].emask_exec_size).exec_size, (uint32_t)(yyvsp[-4].intval), (yyvsp[-2].string), (yyvsp[-1].RawVar), (yyvsp[0].RawVar), CISAlineno));
    }
#line 3510 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.12037.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 140: /* FCvtInstruction: FCVT_OP SatModOpt ExecSize VecDstOperand_G VecSrcOperand_G_IMM  */
#line 1063 "CISA.y"
    {
        pBuilder->CISA_create_fcvt_instruction((yyvsp[-3].sat), (yyvsp[-2].emask_exec_size).emask, (yyvsp[-2].emask_exec_size).exec_size, (yyvsp[-1].genOperand).cisa_gen_opnd, (yyvsp[0].genOperand).cisa_gen_opnd, CISAlineno);
    }
#line 3518 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.12037.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 141: /* AntiTrigInstruction: Predicate ANTI_TRIG_OP SatModOpt ExecSize VecDstOperand_G_I VecSrcOperand_G_I_IMM  */
#line 1069 "CISA.y"
    {
        pBuilder->CISA_create_invtri_inst((yyvsp[-5].pred_reg), (yyvsp[-4].opcode), (yyvsp[-3].sat), (yyvsp[-2].emask_exec_size).emask, (yyvsp[-2].emask_exec_size).exec_size,
            (yyvsp[-1].genOperand).cisa_gen_opnd, (yyvsp[0].genOperand).cisa_gen_opnd, CISAlineno);
    }
#line 3527 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.12037.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 142: /* AddrAddInstruction: ADDR_ADD_OP ExecSize VecDstOperand_A VecSrcOperand_G_A_AO VecSrcOperand_G_IMM_AO  */
#line 1078 "CISA.y"
    {
        // a grammatically problematic instruction
        //   addr_add (M1_NM, 1) A0(0)<1> &V127 - 0x10...
        //                                        ^^^^ next operand or V127 offset
        pBuilder->CISA_create_address_instruction((yyvsp[-4].opcode), (yyvsp[-3].emask_exec_size).emask, (yyvsp[-3].emask_exec_size).exec_size,
            (yyvsp[-2].genOperand).cisa_gen_opnd, (yyvsp[-1].genOperand).cisa_gen_opnd, (yyvsp[0].genOperand).cisa_gen_opnd, CISAlineno);
    }
#line 3539 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.12037.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 143: /* SetpInstruction: SETP_OP ExecSize PredVar VecSrcOperand_G_I_IMM  */
#line 1088 "CISA.y"
    {
        pBuilder->CISA_create_setp_instruction(
            (yyvsp[-3].opcode), (yyvsp[-2].emask_exec_size).emask, (yyvsp[-2].emask_exec_size).exec_size, (yyvsp[-1].vISADecl), (yyvsp[0].genOperand).cisa_gen_opnd, CISAlineno);
    }
#line 3548 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.12037.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 144: /* SelInstruction: Predicate SEL_OP SatModOpt ExecSize VecDstOperand_G_I VecSrcOperand_G_I_IMM VecSrcOperand_G_I_IMM  */
#line 1095 "CISA.y"
    {
        pBuilder->CISA_create_sel_instruction((yyvsp[-5].opcode), (yyvsp[-4].sat), (yyvsp[-6].pred_reg), (yyvsp[-3].emask_exec_size).emask, (yyvsp[-3].emask_exec_size).exec_size,
            (yyvsp[-2].genOperand).cisa_gen_opnd, (yyvsp[-1].genOperand).cisa_gen_opnd, (yyvsp[0].genOperand).cisa_gen_opnd, CISAlineno);
    }
#line 3557 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.12037.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 145: /* MinInstruction: Predicate MIN_OP SatModOpt ExecSize VecDstOperand_G_I VecSrcOperand_G_I_IMM VecSrcOperand_G_I_IMM  */
#line 1102 "CISA.y"
    {
        pBuilder->CISA_create_fminmax_instruction(0, ISA_FMINMAX, (yyvsp[-4].sat), (yyvsp[-6].pred_reg), (yyvsp[-3].emask_exec_size).emask, (yyvsp[-3].emask_exec_size).exec_size,
            (yyvsp[-2].genOperand).cisa_gen_opnd, (yyvsp[-1].genOperand).cisa_gen_opnd, (yyvsp[0].genOperand).cisa_gen_opnd, CISAlineno);
    }
#line 3566 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.12037.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 146: /* MaxInstruction: Predicate MAX_OP SatModOpt ExecSize VecDstOperand_G_I VecSrcOperand_G_I_IMM VecSrcOperand_G_I_IMM  */
#line 1110 "CISA.y"
    {
        pBuilder->CISA_create_fminmax_instruction(
            1, ISA_FMINMAX, (yyvsp[-4].sat), (yyvsp[-6].pred_reg), (yyvsp[-3].emask_exec_size).emask, (yyvsp[-3].emask_exec_size).exec_size,
            (yyvsp[-2].genOperand).cisa_gen_opnd, (yyvsp[-1].genOperand).cisa_gen_opnd, (yyvsp[0].genOperand).cisa_gen_opnd, CISAlineno);
    }
#line 3576 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.12037.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 147: /* MovInstruction: Predicate MOV_OP SatModOpt ExecSize VecDstOperand_G_I VecSrcOperand_G_I_IMM_A_AO  */
#line 1119 "CISA.y"
    {
        ABORT_ON_FAIL(pBuilder->CISA_create_mov_instruction(
            (yyvsp[-5].pred_reg), (yyvsp[-4].opcode), (yyvsp[-2].emask_exec_size).emask, (yyvsp[-2].emask_exec_size).exec_size, (yyvsp[-3].sat),
            (yyvsp[-1].genOperand).cisa_gen_opnd, (yyvsp[0].genOperand).cisa_gen_opnd, CISAlineno));
    }
#line 3586 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.12037.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 148: /* MovInstruction: Predicate MOV_OP SatModOpt ExecSize VecDstOperand_A VecSrcOperand_G_I_IMM_A_AO  */
#line 1126 "CISA.y"
    {
        pBuilder->CISA_create_mov_instruction(
            (yyvsp[-5].pred_reg), (yyvsp[-4].opcode), (yyvsp[-2].emask_exec_size).emask, (yyvsp[-2].emask_exec_size).exec_size, (yyvsp[-3].sat),
            (yyvsp[-1].genOperand).cisa_gen_opnd, (yyvsp[0].genOperand).cisa_gen_opnd, CISAlineno);
    }
#line 3596 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.12037.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 149: /* MovInstruction: Predicate MOV_OP SatModOpt ExecSize VecDstOperand_G_I PredVar  */
#line 1133 "CISA.y"
    {
        ABORT_ON_FAIL(pBuilder->CISA_create_mov_instruction((yyvsp[-1].genOperand).cisa_gen_opnd, (yyvsp[0].vISADecl), CISAlineno));
    }
#line 3604 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.12037.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 150: /* MovsInstruction: MOVS_OP ExecSize DstStateOperand SrcStateOperand  */
#line 1139 "CISA.y"
    {
        pBuilder->CISA_create_movs_instruction((yyvsp[-2].emask_exec_size).emask, ISA_MOVS, (yyvsp[-2].emask_exec_size).exec_size,
            (yyvsp[-1].StateVar).cisa_gen_opnd, (yyvsp[0].StateVar).cisa_gen_opnd, CISAlineno);
    }
#line 3613 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.12037.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 151: /* MovsInstruction: MOVS_OP ExecSize VecDstOperand_G SrcStateOperand  */
#line 1145 "CISA.y"
    {
        pBuilder->CISA_create_movs_instruction((yyvsp[-2].emask_exec_size).emask, ISA_MOVS, (yyvsp[-2].emask_exec_size).exec_size,
            (yyvsp[-1].genOperand).cisa_gen_opnd, (yyvsp[0].StateVar).cisa_gen_opnd, CISAlineno);
    }
#line 3622 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.12037.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 152: /* MovsInstruction: MOVS_OP ExecSize DstStateOperand VecSrcOperand_G_I_IMM  */
#line 1151 "CISA.y"
    {
        pBuilder->CISA_create_movs_instruction((yyvsp[-2].emask_exec_size).emask, ISA_MOVS, (yyvsp[-2].emask_exec_size).exec_size,
            (yyvsp[-1].StateVar).cisa_gen_opnd, (yyvsp[0].genOperand).cisa_gen_opnd, CISAlineno);
    }
#line 3631 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.12037.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 153: /* CmpInstruction: CMP_OP ConditionalModifier ExecSize PredVar VecSrcOperand_G_I_IMM VecSrcOperand_G_I_IMM  */
#line 1169 "CISA.y"
    {
        pBuilder->CISA_create_cmp_instruction((yyvsp[-4].cond_mod), (yyvsp[-3].emask_exec_size).emask, (yyvsp[-3].emask_exec_size).exec_size,
            (yyvsp[-2].vISADecl), (yyvsp[-1].genOperand).cisa_gen_opnd, (yyvsp[0].genOperand).cisa_gen_opnd, CISAlineno);
    }
#line 3640 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.12037.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 154: /* CmpInstruction: CMP_OP ConditionalModifier ExecSize VecDstOperand_G_I VecSrcOperand_G_I_IMM VecSrcOperand_G_I_IMM  */
#line 1176 "CISA.y"
    {
        // NOTE: predication not permitted.  Apparently the vISA API doesn't allow for predicated compares
        pBuilder->CISA_create_cmp_instruction(
            (yyvsp[-4].cond_mod), ISA_CMP, (yyvsp[-3].emask_exec_size).emask, (yyvsp[-3].emask_exec_size).exec_size,
            (yyvsp[-2].genOperand).cisa_gen_opnd, (yyvsp[-1].genOperand).cisa_gen_opnd, (yyvsp[0].genOperand).cisa_gen_opnd, CISAlineno);
    }
#line 3651 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.12037.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 155: /* MediaInstruction: MEDIA_OP MEDIA_MODE TwoDimOffset Var MediaInstructionPlaneID VecSrcOperand_G_I_IMM VecSrcOperand_G_I_IMM RawOperand  */
#line 1186 "CISA.y"
    {
        ABORT_ON_FAIL(pBuilder->CISA_create_media_instruction(
            (yyvsp[-7].opcode), (yyvsp[-6].media_mode), (yyvsp[-5].offset).row, (yyvsp[-5].offset).elem, (int)(yyvsp[-3].intval), (yyvsp[-4].string),
            (yyvsp[-2].genOperand).cisa_gen_opnd, (yyvsp[-1].genOperand).cisa_gen_opnd, (yyvsp[0].RawVar), CISAlineno));
    }
#line 3661 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.12037.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 156: /* MediaInstruction: MEDIA_OP MEDIA_MODE TwoDimOffset Var VecSrcOperand_G_I_IMM VecSrcOperand_G_I_IMM RawOperand  */
#line 1194 "CISA.y"
    {
        ABORT_ON_FAIL(pBuilder->CISA_create_media_instruction(
            (yyvsp[-6].opcode), (yyvsp[-5].media_mode), (yyvsp[-4].offset).row, (yyvsp[-4].offset).elem, (int)0, (yyvsp[-3].string),
            (yyvsp[-2].genOperand).cisa_gen_opnd, (yyvsp[-1].genOperand).cisa_gen_opnd, (yyvsp[0].RawVar), CISAlineno));
    }
#line 3671 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.12037.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 157: /* MediaInstructionPlaneID: DEC_LIT  */
#line 1200 "CISA.y"
                                 {
        MUST_HOLD((yyvsp[0].intval) <= 0xF, "PlaneID must less than 0xF");
        (yyval.intval) = (yyvsp[0].intval);
    }
#line 3680 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.12037.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 158: /* ScatterInstruction: SCATTER_OP ElemNum ExecSize OwordModifier Var VecSrcOperand_G_I_IMM RawOperand RawOperand  */
#line 1208 "CISA.y"
    {
        ABORT_ON_FAIL(pBuilder->CISA_create_scatter_instruction(
            (yyvsp[-7].opcode), (int)(yyvsp[-6].intval), (yyvsp[-5].emask_exec_size).emask, (yyvsp[-5].emask_exec_size).exec_size, (yyvsp[-4].oword_mod), (yyvsp[-3].string),
            (yyvsp[-2].genOperand).cisa_gen_opnd, (yyvsp[-1].RawVar), (yyvsp[0].RawVar), CISAlineno));
    }
#line 3690 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.12037.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 159: /* ScatterTypedInstruction: Predicate SCATTER_TYPED_OP SAMPLER_CHANNEL ExecSize Var RawOperand RawOperand RawOperand RawOperand RawOperand  */
#line 1217 "CISA.y"
    {
        ABORT_ON_FAIL(pBuilder->CISA_create_scatter4_typed_instruction(
            (yyvsp[-8].opcode), (yyvsp[-9].pred_reg), ChannelMask::createFromAPI((yyvsp[-7].s_channel)), (yyvsp[-6].emask_exec_size).emask, (yyvsp[-6].emask_exec_size).exec_size, (yyvsp[-5].string),
            (yyvsp[-4].RawVar), (yyvsp[-3].RawVar), (yyvsp[-2].RawVar), (yyvsp[-1].RawVar), (yyvsp[0].RawVar), CISAlineno));
    }
#line 3700 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.12037.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 160: /* Scatter4ScaledInstruction: Predicate SCATTER4_SCALED_OP SAMPLER_CHANNEL ExecSize Var VecSrcOperand_G_I_IMM RawOperand RawOperand  */
#line 1226 "CISA.y"
    {
        ABORT_ON_FAIL(pBuilder->CISA_create_scatter4_scaled_instruction(
            (yyvsp[-6].opcode), (yyvsp[-7].pred_reg), (yyvsp[-4].emask_exec_size).emask, (yyvsp[-4].emask_exec_size).exec_size, ChannelMask::createFromAPI((yyvsp[-5].s_channel)), (yyvsp[-3].string),
            (yyvsp[-2].genOperand).cisa_gen_opnd, (yyvsp[-1].RawVar), (yyvsp[0].RawVar), CISAlineno));
    }
#line 3710 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.12037.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 161: /* ScatterScaledInstruction: Predicate SCATTER_SCALED_OP DOT DEC_LIT ExecSize Var VecSrcOperand_G_I_IMM RawOperand RawOperand  */
#line 1235 "CISA.y"
    {
        ABORT_ON_FAIL(pBuilder->CISA_create_scatter_scaled_instruction(
            (yyvsp[-7].opcode), (yyvsp[-8].pred_reg), (yyvsp[-4].emask_exec_size).emask, (yyvsp[-4].emask_exec_size).exec_size, (uint32_t) (yyvsp[-5].intval), (yyvsp[-3].string),
            (yyvsp[-2].genOperand).cisa_gen_opnd, (yyvsp[-1].RawVar), (yyvsp[0].RawVar), CISAlineno));
    }
#line 3720 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.12037.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 162: /* SynchronizationInstruction: BARRIER_OP  */
#line 1242 "CISA.y"
               {
        pBuilder->CISA_create_sync_instruction((yyvsp[0].opcode), CISAlineno);
    }
#line 3728 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.12037.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 163: /* SynchronizationInstruction: SBARRIER_SIGNAL  */
#line 1245 "CISA.y"
                      {
        pBuilder->CISA_create_sbarrier_instruction(true, CISAlineno);
    }
#line 3736 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.12037.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 164: /* SynchronizationInstruction: SBARRIER_WAIT  */
#line 1248 "CISA.y"
                    {
        pBuilder->CISA_create_sbarrier_instruction(false, CISAlineno);
    }
#line 3744 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.12037.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 165: /* SynchronizationInstruction: NBARRIER_SIGNAL VecSrcOperand_G_I_IMM VecSrcOperand_G_I_IMM  */
#line 1251 "CISA.y"
                                                                  {
        pBuilder->CISA_create_nbarrier(false, (yyvsp[-1].genOperand).cisa_gen_opnd, (yyvsp[0].genOperand).cisa_gen_opnd, CISAlineno);
    }
#line 3752 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.12037.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 166: /* SynchronizationInstruction: NBARRIER_WAIT VecSrcOperand_G_I_IMM  */
#line 1254 "CISA.y"
                                          {
        pBuilder->CISA_create_nbarrier(true, (yyvsp[0].genOperand).cisa_gen_opnd, NULL, CISAlineno);
    }
#line 3760 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.12037.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 167: /* DwordAtomicInstruction: Predicate DWORD_ATOMIC_OP ATOMIC_SUB_OP Atomic16Opt ExecSize Var RawOperand RawOperand RawOperand RawOperand  */
#line 1260 "CISA.y"
    {
        ABORT_ON_FAIL(pBuilder->CISA_create_dword_atomic_instruction(
            (yyvsp[-9].pred_reg), (yyvsp[-7].atomic_op), (yyvsp[-6].flag), (yyvsp[-5].emask_exec_size).emask, (yyvsp[-5].emask_exec_size).exec_size, (yyvsp[-4].string), (yyvsp[-3].RawVar), (yyvsp[-2].RawVar), (yyvsp[-1].RawVar), (yyvsp[0].RawVar), CISAlineno));
    }
#line 3769 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.12037.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 168: /* TypedAtomicInstruction: Predicate TYPED_ATOMIC_OP ATOMIC_SUB_OP Atomic16Opt ExecSize Var RawOperand RawOperand RawOperand RawOperand RawOperand RawOperand RawOperand  */
#line 1267 "CISA.y"
    {
        ABORT_ON_FAIL(pBuilder->CISA_create_typed_atomic_instruction(
            (yyvsp[-12].pred_reg), (yyvsp[-10].atomic_op), (yyvsp[-9].flag), (yyvsp[-8].emask_exec_size).emask, (yyvsp[-8].emask_exec_size).exec_size, (yyvsp[-7].string),
            (yyvsp[-6].RawVar), (yyvsp[-5].RawVar), (yyvsp[-4].RawVar), (yyvsp[-3].RawVar), (yyvsp[-2].RawVar), (yyvsp[-1].RawVar), (yyvsp[0].RawVar), CISAlineno));
    }
#line 3779 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.12037.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 169: /* Atomic16Opt: %empty  */
#line 1274 "CISA.y"
             {(yyval.flag) = false;}
#line 3785 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.12037.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 170: /* Atomic16Opt: DOT DEC_LIT  */
#line 1275 "CISA.y"
                  { // .16
        MUST_HOLD(((yyvsp[0].intval) == 16), "only supports 16");
        (yyval.flag) = true;
    }
#line 3794 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.12037.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 171: /* SampleUnormInstruction: SAMPLE_UNORM_OP SAMPLER_CHANNEL CHANNEL_OUTPUT Var Var VecSrcOperand_G_I_IMM VecSrcOperand_G_I_IMM VecSrcOperand_G_I_IMM VecSrcOperand_G_I_IMM RawOperand  */
#line 1282 "CISA.y"
    {
        ABORT_ON_FAIL(pBuilder->CISA_create_sampleunorm_instruction(
            (yyvsp[-9].opcode), ChannelMask::createFromAPI((yyvsp[-8].s_channel)), (yyvsp[-7].s_channel_output), (yyvsp[-6].string), (yyvsp[-5].string),
            (yyvsp[-4].genOperand).cisa_gen_opnd, (yyvsp[-3].genOperand).cisa_gen_opnd, (yyvsp[-2].genOperand).cisa_gen_opnd, (yyvsp[-1].genOperand).cisa_gen_opnd, (yyvsp[0].RawVar), CISAlineno));
    }
#line 3804 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.12037.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 172: /* SampleInstruction: SAMPLE_OP SAMPLER_CHANNEL SIMDMode Var Var RawOperand RawOperand RawOperand RawOperand  */
#line 1291 "CISA.y"
    {
        ABORT_ON_FAIL(pBuilder->CISA_create_sample_instruction(
            (yyvsp[-8].opcode), ChannelMask::createFromAPI((yyvsp[-7].s_channel)), (int)(yyvsp[-6].intval), (yyvsp[-5].string), (yyvsp[-4].string),
            (yyvsp[-3].RawVar), (yyvsp[-2].RawVar), (yyvsp[-1].RawVar), (yyvsp[0].RawVar), CISAlineno));
    }
#line 3814 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.12037.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 173: /* SampleInstruction: SAMPLE_OP SAMPLER_CHANNEL SIMDMode Var RawOperand RawOperand RawOperand RawOperand  */
#line 1299 "CISA.y"
   {
       ABORT_ON_FAIL(pBuilder->CISA_create_sample_instruction(
           (yyvsp[-7].opcode), ChannelMask::createFromAPI((yyvsp[-6].s_channel)), (int)(yyvsp[-5].intval), "", (yyvsp[-4].string),
           (yyvsp[-3].RawVar), (yyvsp[-2].RawVar), (yyvsp[-1].RawVar), (yyvsp[0].RawVar), CISAlineno));
   }
#line 3824 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.12037.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 175: /* Sample3DInstruction: Predicate SAMPLE_3D_OP PixelNullMaskEnableOpt CPSEnableOpt NonUniformSamplerEnableOpt SAMPLER_CHANNEL ExecSize VecSrcOperand_G_I_IMM Var Var RawOperand RawOperandArray  */
#line 1311 "CISA.y"
   {
       const bool success = pBuilder->create3DSampleInstruction(
           (yyvsp[-11].pred_reg), (yyvsp[-10].sample3DOp), (yyvsp[-9].pixel_null_mask), (yyvsp[-8].cps), (yyvsp[-7].non_uniform_sampler), ChannelMask::createFromAPI((yyvsp[-6].s_channel)),
           (yyvsp[-5].emask_exec_size).emask, (yyvsp[-5].emask_exec_size).exec_size, (yyvsp[-4].genOperand).cisa_gen_opnd, (yyvsp[-3].string), (yyvsp[-2].string),
           (yyvsp[-1].RawVar), (unsigned int)(yyvsp[0].intval), rawOperandArray, CISAlineno);

    ABORT_ON_FAIL(success);
   }
#line 3837 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.12037.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 176: /* CPSEnableOpt: %empty  */
#line 1323 "CISA.y"
                     {(yyval.cps) = false;}
#line 3843 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.12037.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 177: /* CPSEnableOpt: CPS  */
#line 1323 "CISA.y"
                                          {(yyval.cps) = true;}
#line 3849 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.12037.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 178: /* NonUniformSamplerEnableOpt: %empty  */
#line 1325 "CISA.y"
                                   {(yyval.non_uniform_sampler) = false;}
#line 3855 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.12037.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 179: /* NonUniformSamplerEnableOpt: NON_UNIFORM_SAMPLER  */
#line 1325 "CISA.y"
                                                                       {(yyval.non_uniform_sampler) = true;}
#line 3861 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.12037.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 180: /* Load3dInstruction: Predicate LOAD_3D_OP PixelNullMaskEnableOpt SAMPLER_CHANNEL ExecSize VecSrcOperand_G_I_IMM Var RawOperand RawOperandArray  */
#line 1331 "CISA.y"
   {
       const bool success = pBuilder->create3DLoadInstruction(
           (yyvsp[-8].pred_reg), (yyvsp[-7].sample3DOp), (yyvsp[-6].pixel_null_mask), ChannelMask::createFromAPI((yyvsp[-5].s_channel)),
           (yyvsp[-4].emask_exec_size).emask, (yyvsp[-4].emask_exec_size).exec_size, (yyvsp[-3].genOperand).cisa_gen_opnd, (yyvsp[-2].string),
           (yyvsp[-1].RawVar), (unsigned int)(yyvsp[0].intval), rawOperandArray, CISAlineno);

    ABORT_ON_FAIL(success);
   }
#line 3874 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.12037.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 182: /* Gather43DInstruction: Predicate SAMPLE4_3D_OP PixelNullMaskEnableOpt SAMPLER_CHANNEL ExecSize VecSrcOperand_G_I_IMM Var Var RawOperand RawOperandArray  */
#line 1346 "CISA.y"
   {
       const bool success = pBuilder->createSample4Instruction(
          (yyvsp[-9].pred_reg), (yyvsp[-8].sample3DOp), (yyvsp[-7].pixel_null_mask), ChannelMask::createFromAPI((yyvsp[-6].s_channel)), (yyvsp[-5].emask_exec_size).emask, (yyvsp[-5].emask_exec_size).exec_size,
          (yyvsp[-4].genOperand).cisa_gen_opnd, (yyvsp[-3].string), (yyvsp[-2].string),
          (yyvsp[-1].RawVar), (unsigned int)(yyvsp[0].intval), rawOperandArray, CISAlineno);

    ABORT_ON_FAIL(success);
   }
#line 3887 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.12037.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 183: /* PixelNullMaskEnableOpt: %empty  */
#line 1356 "CISA.y"
                               {(yyval.pixel_null_mask) = false;}
#line 3893 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.12037.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 184: /* PixelNullMaskEnableOpt: PIXEL_NULL_MASK  */
#line 1356 "CISA.y"
                                                               {(yyval.pixel_null_mask) = true;}
#line 3899 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.12037.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 185: /* ResInfo3dInstruction: RESINFO_OP_3D SAMPLER_CHANNEL ExecSize Var RawOperand RawOperand  */
#line 1360 "CISA.y"
   {
        ABORT_ON_FAIL(pBuilder->CISA_create_info_3d_instruction(
            VISA_3D_RESINFO, (yyvsp[-3].emask_exec_size).emask, (yyvsp[-3].emask_exec_size).exec_size,
            ChannelMask::createFromAPI((yyvsp[-4].s_channel)), (yyvsp[-2].string), (yyvsp[-1].RawVar), (yyvsp[0].RawVar), CISAlineno));
   }
#line 3909 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.12037.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 186: /* SampleInfo3dInstruction: SAMPLEINFO_OP_3D SAMPLER_CHANNEL ExecSize Var RawOperand  */
#line 1368 "CISA.y"
   {
        ABORT_ON_FAIL(pBuilder->CISA_create_info_3d_instruction(
            VISA_3D_SAMPLEINFO, (yyvsp[-2].emask_exec_size).emask, (yyvsp[-2].emask_exec_size).exec_size,
            ChannelMask::createFromAPI((yyvsp[-3].s_channel)), (yyvsp[-1].string), NULL, (yyvsp[0].RawVar), CISAlineno));
   }
#line 3919 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.12037.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 187: /* RTWriteOperands: %empty  */
#line 1376 "CISA.y"
    {
    }
#line 3926 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.12037.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 188: /* RTWriteOperands: RTWriteOperands VecSrcOperand_G_IMM  */
#line 1379 "CISA.y"
    {
        RTRWOperandsVec.push_back((yyvsp[0].genOperand).cisa_gen_opnd);
    }
#line 3934 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.12037.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 189: /* RTWriteOperands: RTWriteOperands RawOperand  */
#line 1383 "CISA.y"
    {
        RTRWOperandsVec.push_back((yyvsp[0].RawVar));
    }
#line 3942 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.12037.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 191: /* RTWInstruction: Predicate RTWRITE_OP_3D RTWriteModeOpt ExecSize Var RTWriteOperands  */
#line 1392 "CISA.y"
   {
       bool result = pBuilder->CISA_create_rtwrite_3d_instruction(
           (yyvsp[-5].pred_reg), (yyvsp[-3].string), (yyvsp[-2].emask_exec_size).emask, (unsigned int)(yyvsp[-2].emask_exec_size).exec_size, (yyvsp[-1].string),
           RTRWOperandsVec, CISAlineno);
       RTRWOperandsVec.clear();
       if (!result)
           YYABORT; // already reported
   }
#line 3955 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.12037.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 192: /* RTWriteModeOpt: %empty  */
#line 1402 "CISA.y"
                       {(yyval.string) = 0;}
#line 3961 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.12037.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 194: /* URBWriteInstruction: Predicate URBWRITE_OP_3D ExecSize DEC_LIT DEC_LIT RawOperand RawOperand RawOperand RawOperand  */
#line 1407 "CISA.y"
    {
        pBuilder->CISA_create_urb_write_3d_instruction(
            (yyvsp[-8].pred_reg), (yyvsp[-6].emask_exec_size).emask, (unsigned int)(yyvsp[-6].emask_exec_size).exec_size, (unsigned int)(yyvsp[-5].intval), (unsigned int)(yyvsp[-4].intval),
            (yyvsp[-3].RawVar), (yyvsp[-2].RawVar), (yyvsp[-1].RawVar), (yyvsp[0].RawVar), CISAlineno);
    }
#line 3971 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.12037.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 195: /* AVSInstruction: AVS_OP SAMPLER_CHANNEL Var Var VecSrcOperand_G_I_IMM VecSrcOperand_G_I_IMM VecSrcOperand_G_I_IMM VecSrcOperand_G_I_IMM VecSrcOperand_G_I_IMM VecSrcOperand_G_I_IMM VecSrcOperand_G_I_IMM CNTRL VecSrcOperand_G_I_IMM EXECMODE VecSrcOperand_G_I_IMM RawOperand  */
#line 1415 "CISA.y"
    {
        pBuilder->CISA_create_avs_instruction(
            ChannelMask::createFromAPI((yyvsp[-14].s_channel)), (yyvsp[-13].string), (yyvsp[-12].string),
            (yyvsp[-11].genOperand).cisa_gen_opnd, (yyvsp[-10].genOperand).cisa_gen_opnd, (yyvsp[-9].genOperand).cisa_gen_opnd, (yyvsp[-8].genOperand).cisa_gen_opnd,
            (yyvsp[-7].genOperand).cisa_gen_opnd, (yyvsp[-6].genOperand).cisa_gen_opnd, (yyvsp[-5].genOperand).cisa_gen_opnd, (yyvsp[-4].cntrl), (yyvsp[-3].genOperand).cisa_gen_opnd,
            (yyvsp[-2].execMode), (yyvsp[-1].genOperand).cisa_gen_opnd, (yyvsp[0].RawVar), CISAlineno);
    }
#line 3983 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.12037.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 196: /* VMEInstruction: VME_IME_OP VMEOpndIME Var RawOperand RawOperand RawOperand RawOperand RawOperand RawOperand  */
#line 1427 "CISA.y"
   {
       //     1 - OP
       //     2 - StreamMode, SearchCtrl
       //     3 - Surface
       //     4 - UNIInput
       //     5 - IMEInput
       //     6 - ref0
       //     7 - ref1
       //     8 - CostCenter
       //     9 - Output
        ABORT_ON_FAIL(pBuilder->CISA_create_vme_ime_instruction(
            (yyvsp[-8].opcode), (yyvsp[-7].vmeOpndIvb).streamMode, (yyvsp[-7].vmeOpndIvb).searchCtrl, (yyvsp[-5].RawVar), (yyvsp[-4].RawVar), (yyvsp[-6].string), (yyvsp[-3].RawVar), (yyvsp[-2].RawVar), (yyvsp[-1].RawVar), (yyvsp[0].RawVar), CISAlineno));
   }
#line 4001 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.12037.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 197: /* VMEInstruction: VME_SIC_OP Var RawOperand RawOperand RawOperand  */
#line 1443 "CISA.y"
   {
        ABORT_ON_FAIL(pBuilder->CISA_create_vme_sic_instruction((yyvsp[-4].opcode), (yyvsp[-2].RawVar), (yyvsp[-1].RawVar), (yyvsp[-3].string), (yyvsp[0].RawVar), CISAlineno));
   }
#line 4009 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.12037.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 198: /* VMEInstruction: VME_FBR_OP VMEOpndFBR Var RawOperand RawOperand RawOperand  */
#line 1449 "CISA.y"
   {
        //    1 - OP
        //    2 - FBRMdMode, FBRSubMbShape, FBRSubPredMode
        //    3 - surface
        //    4 - UNIInput
        //    5 - FBRInput
        //    6 - output
        ABORT_ON_FAIL(pBuilder->CISA_create_vme_fbr_instruction((yyvsp[-5].opcode), (yyvsp[-2].RawVar), (yyvsp[-1].RawVar), (yyvsp[-3].string),
            (yyvsp[-4].vmeOpndFbr).cisa_fbrMbMode_opnd, (yyvsp[-4].vmeOpndFbr).cisa_fbrSubMbShape_opnd, (yyvsp[-4].vmeOpndFbr).cisa_fbrSubPredMode_opnd, (yyvsp[0].RawVar), CISAlineno));
    }
#line 4024 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.12037.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 199: /* OwordInstruction: OWORD_OP OwordModifier ExecSize Var VecSrcOperand_G_I_IMM RawOperand  */
#line 1462 "CISA.y"
    {
        ABORT_ON_FAIL(
            pBuilder->CISA_create_oword_instruction((yyvsp[-5].opcode), (yyvsp[-4].oword_mod), (yyvsp[-3].emask_exec_size).exec_size, (yyvsp[-2].string), (yyvsp[-1].genOperand).cisa_gen_opnd, (yyvsp[0].RawVar), CISAlineno));
    }
#line 4033 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.12037.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 200: /* SvmInstruction: SVM_OP ExecSize VecSrcOperand_G_I_IMM RawOperand  */
#line 1470 "CISA.y"
    {
        bool aligned = false;
        pBuilder->CISA_create_svm_block_instruction((SVMSubOpcode)(yyvsp[-3].opcode), (yyvsp[-2].emask_exec_size).exec_size, aligned,
            (yyvsp[-1].genOperand).cisa_gen_opnd, (yyvsp[0].RawVar), CISAlineno);
    }
#line 4043 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.12037.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 201: /* SvmInstruction: Predicate SVM_SCATTER_OP DOT DEC_LIT DOT DEC_LIT ExecSize RawOperand RawOperand  */
#line 1477 "CISA.y"
    {
        pBuilder->CISA_create_svm_scatter_instruction((yyvsp[-8].pred_reg), (SVMSubOpcode)(yyvsp[-7].opcode), (yyvsp[-2].emask_exec_size).emask, (yyvsp[-2].emask_exec_size).exec_size,
            (unsigned int)(yyvsp[-5].intval), (unsigned int)(yyvsp[-3].intval), (yyvsp[-1].RawVar), (yyvsp[0].RawVar), CISAlineno);
    }
#line 4052 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.12037.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 202: /* SvmInstruction: Predicate SVM_ATOMIC_OP ATOMIC_SUB_OP AtomicBitwidthOpt ExecSize RawOperand RawOperand RawOperand RawOperand  */
#line 1483 "CISA.y"
    {
        pBuilder->CISA_create_svm_atomic_instruction((yyvsp[-8].pred_reg), (yyvsp[-4].emask_exec_size).emask, (yyvsp[-4].emask_exec_size).exec_size, (yyvsp[-6].atomic_op), (unsigned short)(yyvsp[-5].intval),
            (yyvsp[-3].RawVar), (yyvsp[-1].RawVar), (yyvsp[0].RawVar), (yyvsp[-2].RawVar), CISAlineno);
    }
#line 4061 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.12037.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 203: /* SvmInstruction: Predicate SVM_GATHER4SCALED_OP SAMPLER_CHANNEL ExecSize VecSrcOperand_G_I_IMM RawOperand RawOperand  */
#line 1489 "CISA.y"
    {
        pBuilder->CISA_create_svm_gather4_scaled((yyvsp[-6].pred_reg), (yyvsp[-3].emask_exec_size).emask, (yyvsp[-3].emask_exec_size).exec_size, ChannelMask::createFromAPI((yyvsp[-4].s_channel)),
            (yyvsp[-2].genOperand).cisa_gen_opnd, (yyvsp[-1].RawVar), (yyvsp[0].RawVar), CISAlineno);
    }
#line 4070 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.12037.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 204: /* SvmInstruction: Predicate SVM_SCATTER4SCALED_OP SAMPLER_CHANNEL ExecSize VecSrcOperand_G_I_IMM RawOperand RawOperand  */
#line 1495 "CISA.y"
    {
        pBuilder->CISA_create_svm_scatter4_scaled((yyvsp[-6].pred_reg), (yyvsp[-3].emask_exec_size).emask, (yyvsp[-3].emask_exec_size).exec_size, ChannelMask::createFromAPI((yyvsp[-4].s_channel)),
            (yyvsp[-2].genOperand).cisa_gen_opnd, (yyvsp[-1].RawVar), (yyvsp[0].RawVar), CISAlineno);
    }
#line 4079 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.12037.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 205: /* AtomicBitwidthOpt: %empty  */
#line 1501 "CISA.y"
             {(yyval.intval) = 32;}
#line 4085 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.12037.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 206: /* AtomicBitwidthOpt: DOT DEC_LIT  */
#line 1502 "CISA.y"
                  {
        MUST_HOLD((yyvsp[0].intval) == 16 || (yyvsp[0].intval) == 32 || (yyvsp[0].intval) == 64, "only supports 16 or 64");
        (yyval.intval) = (yyvsp[0].intval);
    }
#line 4094 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.12037.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 219: /* LscUntypedLoad: Predicate LSC_LOAD_MNEMONIC LSC_SFID_UNTYPED_TOKEN LscCacheOpts ExecSize LscDataOperand LscUntypedAddrOperand  */
#line 1552 "CISA.y"
    {
        (yyvsp[-2].emask_exec_size).exec_size =
            lscCheckExecSize(pBuilder, (yyvsp[-4].lsc_sfid), (yyvsp[-5].lsc_subOpcode), (yyvsp[-1].lsc_data_operand).shape.order, (yyvsp[-2].emask_exec_size).exec_size);
        pBuilder->CISA_create_lsc_untyped_inst(
            (yyvsp[-6].pred_reg),  // predicate
            (yyvsp[-5].lsc_subOpcode),  // subop
            (yyvsp[-4].lsc_sfid),  // sfid
            (yyvsp[-3].lsc_caching_opts),  // caching settings
            Get_VISA_Exec_Size_From_Raw_Size((yyvsp[-2].emask_exec_size).exec_size),
            (yyvsp[-2].emask_exec_size).emask,
            (yyvsp[0].lsc_addr_operand).addr,     // address
            (yyvsp[-1].lsc_data_operand).shape,    // data
            (yyvsp[0].lsc_addr_operand).surface,  // surface
            (yyvsp[-1].lsc_data_operand).reg,      // dst
            (yyvsp[0].lsc_addr_operand).regs[0],  // src0
            nullptr,     // src1
            nullptr,     // src2
            CISAlineno);
    }
#line 4118 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.12037.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 220: /* LscUntypedStridedLoad: Predicate LSC_LOAD_STRIDED_MNEMONIC LSC_SFID_UNTYPED_TOKEN LscCacheOpts ExecSize LscDataOperand LscUntypedStridedAddrOperand  */
#line 1583 "CISA.y"
    {
        (yyvsp[-2].emask_exec_size).exec_size =
            lscCheckExecSize(pBuilder, (yyvsp[-4].lsc_sfid), (yyvsp[-5].lsc_subOpcode), (yyvsp[-1].lsc_data_operand).shape.order, (yyvsp[-2].emask_exec_size).exec_size);
        pBuilder->CISA_create_lsc_untyped_strided_inst(
            (yyvsp[-6].pred_reg),  // predicate
            (yyvsp[-5].lsc_subOpcode),  // subop
            (yyvsp[-4].lsc_sfid),  // sfid
            (yyvsp[-3].lsc_caching_opts),  // caching settings
            Get_VISA_Exec_Size_From_Raw_Size((yyvsp[-2].emask_exec_size).exec_size),
            (yyvsp[-2].emask_exec_size).emask,
            (yyvsp[0].lsc_addr_operand).addr,     // address
            (yyvsp[-1].lsc_data_operand).shape,    // data
            (yyvsp[0].lsc_addr_operand).surface,  // surface
            (yyvsp[-1].lsc_data_operand).reg,      // dst
            (yyvsp[0].lsc_addr_operand).regs[0],  // src0 base
            (yyvsp[0].lsc_addr_operand).regs[1],  // src0 stride
            nullptr,     // src1
            CISAlineno);
    }
#line 4142 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.12037.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 221: /* LscUntypedBlock2dLoad: Predicate LSC_LOAD_BLOCK2D_MNEMONIC LSC_SFID_UNTYPED_TOKEN LscCacheOpts ExecSize LscDataOperand2D LscUntypedBlock2dAddrOperand  */
#line 1612 "CISA.y"
    {
        (yyvsp[-2].emask_exec_size).exec_size =
            lscCheckExecSize(pBuilder, (yyvsp[-4].lsc_sfid), (yyvsp[-5].lsc_subOpcode), (yyvsp[-1].lsc_data_operand2d).shape2D.order, (yyvsp[-2].emask_exec_size).exec_size);
        pBuilder->CISA_create_lsc_untyped_block2d_inst(
            (yyvsp[-6].pred_reg),  // predicate
            (yyvsp[-5].lsc_subOpcode),  // subop
            (yyvsp[-4].lsc_sfid),  // sfid
            (yyvsp[-3].lsc_caching_opts),  // caching settings
            Get_VISA_Exec_Size_From_Raw_Size((yyvsp[-2].emask_exec_size).exec_size),
            (yyvsp[-2].emask_exec_size).emask,
            (yyvsp[-1].lsc_data_operand2d).shape2D,  // data shape
            (yyvsp[-1].lsc_data_operand2d).reg,      // dst
            (yyvsp[0].lsc_addr_operand).regs,     // src0 surface info / addrs
            nullptr,     // src1
            CISAlineno);
    }
#line 4163 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.12037.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 222: /* LscUntypedStore: Predicate LSC_STORE_MNEMONIC LSC_SFID_UNTYPED_TOKEN LscCacheOpts ExecSize LscUntypedAddrOperand LscDataOperand  */
#line 1637 "CISA.y"
    {
        (yyvsp[-2].emask_exec_size).exec_size =
            lscCheckExecSize(pBuilder, (yyvsp[-4].lsc_sfid), (yyvsp[-5].lsc_subOpcode), (yyvsp[0].lsc_data_operand).shape.order, (yyvsp[-2].emask_exec_size).exec_size);
        pBuilder->CISA_create_lsc_untyped_inst(
            (yyvsp[-6].pred_reg),  // predicate
            (yyvsp[-5].lsc_subOpcode),  // subop
            (yyvsp[-4].lsc_sfid),  // SFID
            (yyvsp[-3].lsc_caching_opts),  // caching settings
            Get_VISA_Exec_Size_From_Raw_Size((yyvsp[-2].emask_exec_size).exec_size),
            (yyvsp[-2].emask_exec_size).emask,
            (yyvsp[-1].lsc_addr_operand).addr,     // address
            (yyvsp[0].lsc_data_operand).shape,    // data
            (yyvsp[-1].lsc_addr_operand).surface,  // surface
            nullptr,     // dst
            (yyvsp[-1].lsc_addr_operand).regs[0],  // src0
            (yyvsp[0].lsc_data_operand).reg,      // src1
            nullptr,     // src2
            CISAlineno);
    }
#line 4187 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.12037.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 223: /* LscUntypedStridedStore: Predicate LSC_STORE_STRIDED_MNEMONIC LSC_SFID_UNTYPED_TOKEN LscCacheOpts ExecSize LscUntypedStridedAddrOperand LscDataOperand  */
#line 1661 "CISA.y"
    {
        (yyvsp[-2].emask_exec_size).exec_size =
            lscCheckExecSize(pBuilder, (yyvsp[-4].lsc_sfid), (yyvsp[-5].lsc_subOpcode), (yyvsp[0].lsc_data_operand).shape.order, (yyvsp[-2].emask_exec_size).exec_size);
        pBuilder->CISA_create_lsc_untyped_strided_inst(
            (yyvsp[-6].pred_reg),  // predicate
            (yyvsp[-5].lsc_subOpcode),  // subop
            (yyvsp[-4].lsc_sfid),  // SFID
            (yyvsp[-3].lsc_caching_opts),  // caching settings
            Get_VISA_Exec_Size_From_Raw_Size((yyvsp[-2].emask_exec_size).exec_size),
            (yyvsp[-2].emask_exec_size).emask,
            (yyvsp[-1].lsc_addr_operand).addr,     // address
            (yyvsp[0].lsc_data_operand).shape,    // data
            (yyvsp[-1].lsc_addr_operand).surface,  // surface
            nullptr,     // dst
            (yyvsp[-1].lsc_addr_operand).regs[0],  // src0 base
            (yyvsp[-1].lsc_addr_operand).regs[1],  // src0 stride
            (yyvsp[0].lsc_data_operand).reg,      // src1
            CISAlineno);
    }
#line 4211 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.12037.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 224: /* LscUntypedBlock2dStore: Predicate LSC_STORE_BLOCK2D_MNEMONIC LSC_SFID_UNTYPED_TOKEN LscCacheOpts ExecSize LscUntypedBlock2dAddrOperand LscDataOperand2D  */
#line 1688 "CISA.y"
    {
        (yyvsp[-2].emask_exec_size).exec_size =
            lscCheckExecSize(pBuilder, (yyvsp[-4].lsc_sfid), (yyvsp[-5].lsc_subOpcode), (yyvsp[0].lsc_data_operand2d).shape2D.order, (yyvsp[-2].emask_exec_size).exec_size);
        pBuilder->CISA_create_lsc_untyped_block2d_inst(
            (yyvsp[-6].pred_reg),  // predicate
            (yyvsp[-5].lsc_subOpcode),  // subop
            (yyvsp[-4].lsc_sfid),  // sfid
            (yyvsp[-3].lsc_caching_opts),  // caching settings
            Get_VISA_Exec_Size_From_Raw_Size((yyvsp[-2].emask_exec_size).exec_size),
            (yyvsp[-2].emask_exec_size).emask,
            (yyvsp[0].lsc_data_operand2d).shape2D,  // data2d
            nullptr,     // dst
            (yyvsp[-1].lsc_addr_operand).regs,     // src0 addrs
            (yyvsp[0].lsc_data_operand2d).reg,      // src1
            CISAlineno);
    }
#line 4232 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.12037.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 225: /* LscUntypedAtomic: Predicate LSC_ATOMIC_MNEMONIC LSC_SFID_UNTYPED_TOKEN LscCacheOpts ExecSize LscDataOperand LscUntypedAddrOperand LscPayloadReg LscPayloadReg  */
#line 1714 "CISA.y"
    {
        (yyvsp[-4].emask_exec_size).exec_size =
            lscCheckExecSize(pBuilder, (yyvsp[-6].lsc_sfid), (yyvsp[-7].lsc_subOpcode), (yyvsp[-3].lsc_data_operand).shape.order, (yyvsp[-4].emask_exec_size).exec_size);
        pBuilder->CISA_create_lsc_untyped_inst(
            (yyvsp[-8].pred_reg),  // predicate
            (yyvsp[-7].lsc_subOpcode),                // op
            (yyvsp[-6].lsc_sfid),                // sfid
            (yyvsp[-5].lsc_caching_opts),                // caching settings
            Get_VISA_Exec_Size_From_Raw_Size((yyvsp[-4].emask_exec_size).exec_size),
            (yyvsp[-4].emask_exec_size).emask,
            (yyvsp[-2].lsc_addr_operand).addr,     // address info
            (yyvsp[-3].lsc_data_operand).shape,    // data type
            (yyvsp[-2].lsc_addr_operand).surface,  // surface
            (yyvsp[-3].lsc_data_operand).reg,      // dst data
            (yyvsp[-2].lsc_addr_operand).regs[0],  // src0 addr
            (yyvsp[-1].RawVar),          // src1 data
            (yyvsp[0].RawVar),          // src2 data (for icas/fcas)
            CISAlineno);
    }
#line 4256 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.12037.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 226: /* LscTypedLoad: Predicate LSC_LOAD_MNEMONIC LSC_SFID_TYPED_TOKEN LscCacheOpts ExecSize LscDataOperand LscTypedAddrOperand  */
#line 1748 "CISA.y"
    {
        if ((yyvsp[-5].lsc_subOpcode) != LSC_LOAD_QUAD) {
            PARSE_ERROR("unsupported load operation for .tgm");
        }
        (yyvsp[-2].emask_exec_size).exec_size =
            lscCheckExecSize(pBuilder, (yyvsp[-4].lsc_sfid), (yyvsp[-5].lsc_subOpcode), (yyvsp[-1].lsc_data_operand).shape.order, (yyvsp[-2].emask_exec_size).exec_size);
        pBuilder->CISA_create_lsc_typed_inst(
            (yyvsp[-6].pred_reg),  // predicate
            (yyvsp[-5].lsc_subOpcode),  // subop
            (yyvsp[-4].lsc_sfid),  // sfid
            (yyvsp[-3].lsc_caching_opts),  // caching settings
            Get_VISA_Exec_Size_From_Raw_Size((yyvsp[-2].emask_exec_size).exec_size),
            (yyvsp[-2].emask_exec_size).emask,
            (yyvsp[0].lsc_addr_operand).addr.type,  // address model
            (yyvsp[0].lsc_addr_operand).addr.size,  // address size
            (yyvsp[-1].lsc_data_operand).shape,    // data type
            (yyvsp[0].lsc_addr_operand).surface,  // surface
            (yyvsp[-1].lsc_data_operand).reg,      // dst data
            (yyvsp[0].lsc_addr_operand).regs[0],  // src0_u
            (yyvsp[0].lsc_addr_operand).regs[1],  // src0_v
            (yyvsp[0].lsc_addr_operand).regs[2],  // src0_r
            (yyvsp[0].lsc_addr_operand).regs[3],  // src0_lod
            nullptr,     // src1 data
            nullptr,     // src2 data
            CISAlineno);
    }
#line 4287 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.12037.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 227: /* LscTypedStore: Predicate LSC_STORE_MNEMONIC LSC_SFID_TYPED_TOKEN LscCacheOpts ExecSize LscTypedAddrOperand LscDataOperand  */
#line 1788 "CISA.y"
    {
        if ((yyvsp[-5].lsc_subOpcode) != LSC_STORE_QUAD) {
            PARSE_ERROR("unsupported store operation for .tgm");
        }
        (yyvsp[-2].emask_exec_size).exec_size =
            lscCheckExecSize(pBuilder, (yyvsp[-4].lsc_sfid), (yyvsp[-5].lsc_subOpcode), (yyvsp[0].lsc_data_operand).shape.order, (yyvsp[-2].emask_exec_size).exec_size);
        pBuilder->CISA_create_lsc_typed_inst(
            (yyvsp[-6].pred_reg),  // predicate
            (yyvsp[-5].lsc_subOpcode),  // subop
            (yyvsp[-4].lsc_sfid),  // sfid
            (yyvsp[-3].lsc_caching_opts),  // caching settings
            Get_VISA_Exec_Size_From_Raw_Size((yyvsp[-2].emask_exec_size).exec_size),
            (yyvsp[-2].emask_exec_size).emask,
            (yyvsp[-1].lsc_addr_operand).addr.type,  // address model
            (yyvsp[-1].lsc_addr_operand).addr.size,  // address size
            (yyvsp[0].lsc_data_operand).shape,    // data type
            (yyvsp[-1].lsc_addr_operand).surface,  // surface
            nullptr,     // dst
            (yyvsp[-1].lsc_addr_operand).regs[0],  // src0_u
            (yyvsp[-1].lsc_addr_operand).regs[1],  // src0_v
            (yyvsp[-1].lsc_addr_operand).regs[2],  // src0_r
            (yyvsp[-1].lsc_addr_operand).regs[3],  // src0_lod
            (yyvsp[0].lsc_data_operand).reg,      // src1 data
            nullptr,     // src2 data
            CISAlineno);
    }
#line 4318 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.12037.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 228: /* LscTypedAtomic: Predicate LSC_ATOMIC_MNEMONIC LSC_SFID_TYPED_TOKEN LscCacheOpts ExecSize LscDataOperand LscTypedAddrOperand LscPayloadReg LscPayloadReg  */
#line 1828 "CISA.y"
    {
        (yyvsp[-4].emask_exec_size).exec_size =
            lscCheckExecSize(pBuilder, (yyvsp[-6].lsc_sfid), (yyvsp[-7].lsc_subOpcode), (yyvsp[-3].lsc_data_operand).shape.order, (yyvsp[-4].emask_exec_size).exec_size);
        pBuilder->CISA_create_lsc_typed_inst(
            (yyvsp[-8].pred_reg),  // predicate
            (yyvsp[-7].lsc_subOpcode),  // subop
            (yyvsp[-6].lsc_sfid),  // sfid
            (yyvsp[-5].lsc_caching_opts),  // caching settings
            Get_VISA_Exec_Size_From_Raw_Size((yyvsp[-4].emask_exec_size).exec_size),
            (yyvsp[-4].emask_exec_size).emask,
            (yyvsp[-2].lsc_addr_operand).addr.type, // address model
            (yyvsp[-2].lsc_addr_operand).addr.size,  // address size
            (yyvsp[-3].lsc_data_operand).shape,    // data type
            (yyvsp[-2].lsc_addr_operand).surface,  // surface
            (yyvsp[-3].lsc_data_operand).reg,      // dst data
            (yyvsp[-2].lsc_addr_operand).regs[0],  // src0 addrs u
            (yyvsp[-2].lsc_addr_operand).regs[1],  // src0 addrs v
            (yyvsp[-2].lsc_addr_operand).regs[2],  // src0 addrs r
            (yyvsp[-2].lsc_addr_operand).regs[3],  // src0 addrs lod
            (yyvsp[-1].RawVar),          // src1 data
            (yyvsp[0].RawVar),          // src2 data
            CISAlineno);
    }
#line 4346 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.12037.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 229: /* LscTypedReadStateInfo: Predicate LSC_READ_STATE_INFO_MNEMONIC LSC_SFID_TYPED_TOKEN LscPayloadReg LscRegAddrModel  */
#line 1859 "CISA.y"
   {
        LSC_CACHE_OPTS caching{LSC_CACHING_DEFAULT,LSC_CACHING_DEFAULT};
        LSC_DATA_SHAPE dataShape{LSC_DATA_SIZE_32b,LSC_DATA_ORDER_NONTRANSPOSE};
        dataShape.elems = LSC_DATA_ELEMS_1;
        pBuilder->CISA_create_lsc_typed_inst(
            (yyvsp[-4].pred_reg),              // predicate
            (yyvsp[-3].lsc_subOpcode),              // subop
            (yyvsp[-2].lsc_sfid),              // sfid
            caching,         // caching settings
            EXEC_SIZE_1,
            vISA_EMASK_M1_NM,
            (yyvsp[0].lsc_addr_model).type,           // address model
            LSC_ADDR_SIZE_32b, // address size
            dataShape,         // data type
            (yyvsp[0].lsc_addr_model).surface,        // surface
            (yyvsp[-1].RawVar),                // dst data
            nullptr,           // src0 addrs u
            nullptr,           // src0 addrs v
            nullptr,           // src0 addrs r
            nullptr,           // src0 addrs lod
            nullptr,           // src1 data
            nullptr,           // src2 data
            CISAlineno);
   }
#line 4375 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.12037.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 230: /* LscFence: LSC_FENCE_MNEMONIC LscSfid LSC_FENCE_OP_TYPE LSC_FENCE_SCOPE  */
#line 1892 "CISA.y"
    {
        pBuilder->CISA_create_lsc_fence((yyvsp[-2].lsc_sfid), (yyvsp[-1].lsc_fence_op), (yyvsp[0].lsc_scope), CISAlineno);
    }
#line 4383 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.12037.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 233: /* LscCacheOpts: %empty  */
#line 1899 "CISA.y"
                                    {(yyval.lsc_caching_opts) = {LSC_CACHING_DEFAULT,LSC_CACHING_DEFAULT};}
#line 4389 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.12037.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 234: /* LscCacheOpts: LSC_CACHING_OPT  */
#line 1900 "CISA.y"
                                    {(yyval.lsc_caching_opts) = {(yyvsp[0].lsc_caching_opt),LSC_CACHING_DEFAULT};}
#line 4395 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.12037.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 235: /* LscCacheOpts: LSC_CACHING_OPT LSC_CACHING_OPT  */
#line 1901 "CISA.y"
                                    {(yyval.lsc_caching_opts) = {(yyvsp[-1].lsc_caching_opt),(yyvsp[0].lsc_caching_opt)};}
#line 4401 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.12037.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 236: /* LscUntypedAddrOperand: LscAddrModelOpt LBRACK LscAddrImmScaleOpt LscPayloadNonNullReg LscAddrImmOffsetOpt RBRACK LSC_ADDR_SIZE_TK  */
#line 1908 "CISA.y"
    {
        (yyval.lsc_addr_operand) = {(yyvsp[-6].lsc_addr_model).surface,{(yyvsp[-3].RawVar)},{(yyvsp[-6].lsc_addr_model).type,(int)(yyvsp[-4].intval),(int)(yyvsp[-2].intval),(yyvsp[0].lsc_addr_size)}};
    }
#line 4409 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.12037.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 237: /* LscUntypedStridedAddrOperand: LscAddrModelOpt LBRACK LscAddrImmScaleOpt LscPayloadNonNullReg LscAddrImmOffsetOpt COMMA LscVectorOpRegOrImm RBRACK LSC_ADDR_SIZE_TK  */
#line 1917 "CISA.y"
    {
        (yyval.lsc_addr_operand) = {(yyvsp[-8].lsc_addr_model).surface,{(yyvsp[-5].RawVar),(yyvsp[-2].lsc_addr_surface_ident)},{(yyvsp[-8].lsc_addr_model).type,(int)(yyvsp[-6].intval),(int)(yyvsp[-4].intval),(yyvsp[0].lsc_addr_size)}};
    }
#line 4417 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.12037.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 238: /* LscUntypedStridedAddrOperand: LscUntypedAddrOperand  */
#line 1920 "CISA.y"
                            {
        (yyval.lsc_addr_operand) = (yyvsp[0].lsc_addr_operand);
        (yyval.lsc_addr_operand).regs[1] = nullptr;
    }
#line 4426 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.12037.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 239: /* LscUntypedBlock2dAddrOperand: LSC_AM_FLAT LBRACK LscVectorOpReg COMMA LscVectorOpRegOrImm COMMA LscVectorOpRegOrImm COMMA LscVectorOpRegOrImm COMMA LscVectorOpRegOrImm COMMA LscVectorOpRegOrImm RBRACK  */
#line 1943 "CISA.y"
    {
        (yyval.lsc_addr_operand) = {nullptr,{(yyvsp[-11].lsc_addr_surface_ident),(yyvsp[-9].lsc_addr_surface_ident),(yyvsp[-7].lsc_addr_surface_ident),(yyvsp[-5].lsc_addr_surface_ident),(yyvsp[-3].lsc_addr_surface_ident),(yyvsp[-1].lsc_addr_surface_ident)},{LSC_ADDR_TYPE_FLAT,1,0,LSC_ADDR_SIZE_64b}};
    }
#line 4434 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.12037.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 240: /* LscTypedAddrOperand: LscRegAddrModel LBRACK LscPayloadNonNullReg RBRACK LSC_ADDR_SIZE_TK  */
#line 1956 "CISA.y"
    {
        (yyval.lsc_addr_operand) = {(yyvsp[-4].lsc_addr_model).surface,{(yyvsp[-2].RawVar)},{(yyvsp[-4].lsc_addr_model).type,1,0,(yyvsp[0].lsc_addr_size)}};
    }
#line 4442 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.12037.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 241: /* LscTypedAddrOperand: LscRegAddrModel LBRACK LscPayloadNonNullReg COMMA LscPayloadNonNullReg RBRACK LSC_ADDR_SIZE_TK  */
#line 1967 "CISA.y"
    {
        (yyval.lsc_addr_operand) = {(yyvsp[-6].lsc_addr_model).surface,{(yyvsp[-4].RawVar),(yyvsp[-2].RawVar)},{(yyvsp[-6].lsc_addr_model).type,1,0,(yyvsp[0].lsc_addr_size)}};
    }
#line 4450 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.12037.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 242: /* LscTypedAddrOperand: LscRegAddrModel LBRACK LscPayloadNonNullReg COMMA LscPayloadNonNullReg COMMA LscPayloadNonNullReg RBRACK LSC_ADDR_SIZE_TK  */
#line 1978 "CISA.y"
    {
        (yyval.lsc_addr_operand) = {(yyvsp[-8].lsc_addr_model).surface,{(yyvsp[-6].RawVar),(yyvsp[-4].RawVar),(yyvsp[-2].RawVar)},{(yyvsp[-8].lsc_addr_model).type,1,0,(yyvsp[0].lsc_addr_size)}};
    }
#line 4458 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.12037.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 243: /* LscTypedAddrOperand: LscRegAddrModel LBRACK LscPayloadNonNullReg COMMA LscPayloadNonNullReg COMMA LscPayloadNonNullReg COMMA LscPayloadNonNullReg RBRACK LSC_ADDR_SIZE_TK  */
#line 1989 "CISA.y"
    {
        (yyval.lsc_addr_operand) = {(yyvsp[-10].lsc_addr_model).surface,{(yyvsp[-8].RawVar),(yyvsp[-6].RawVar),(yyvsp[-4].RawVar),(yyvsp[-2].RawVar)},{(yyvsp[-10].lsc_addr_model).type,1,0,(yyvsp[0].lsc_addr_size)}};
    }
#line 4466 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.12037.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 244: /* LscAddrImmOffsetOpt: %empty  */
#line 1997 "CISA.y"
                     {(yyval.intval) =   0;}
#line 4472 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.12037.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 245: /* LscAddrImmOffsetOpt: PLUS IntExpAdd  */
#line 1998 "CISA.y"
                     {(yyval.intval) =  (yyvsp[0].intval);}
#line 4478 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.12037.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 246: /* LscAddrImmOffsetOpt: MINUS IntExpPrim  */
#line 1999 "CISA.y"
                     {(yyval.intval) = -(yyvsp[0].intval);}
#line 4484 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.12037.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 247: /* LscAddrImmScaleOpt: %empty  */
#line 2006 "CISA.y"
                      {(yyval.intval) = 1;}
#line 4490 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.12037.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 248: /* LscAddrImmScaleOpt: IntExpMul TIMES  */
#line 2007 "CISA.y"
                      {(yyval.intval) = (yyvsp[-1].intval);}
#line 4496 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.12037.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 249: /* LscAddrModelOpt: %empty  */
#line 2010 "CISA.y"
                 {(yyval.lsc_addr_model) = {LSC_ADDR_TYPE_FLAT,nullptr};}
#line 4502 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.12037.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 250: /* LscAddrModelOpt: LSC_AM_FLAT  */
#line 2011 "CISA.y"
                 {(yyval.lsc_addr_model) = {LSC_ADDR_TYPE_FLAT,nullptr};}
#line 4508 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.12037.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 251: /* LscAddrModelOpt: LSC_AM_ARG  */
#line 2012 "CISA.y"
                 {(yyval.lsc_addr_model) = {LSC_ADDR_TYPE_ARG,nullptr};}
#line 4514 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.12037.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 253: /* LscRegAddrModel: LscRegAddrModelKind LPAREN LscVectorOpRegOrImm RPAREN  */
#line 2017 "CISA.y"
                                                             {
        (yyval.lsc_addr_model) = {(yyvsp[-3].lsc_addr_type),(yyvsp[-1].lsc_addr_surface_ident)};
    }
#line 4522 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.12037.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 254: /* LscRegAddrModelKind: LSC_AM_BSS  */
#line 2022 "CISA.y"
               {(yyval.lsc_addr_type) = LSC_ADDR_TYPE_BSS;}
#line 4528 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.12037.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 255: /* LscRegAddrModelKind: LSC_AM_SS  */
#line 2023 "CISA.y"
               {(yyval.lsc_addr_type) = LSC_ADDR_TYPE_SS;}
#line 4534 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.12037.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 256: /* LscRegAddrModelKind: LSC_AM_BTI  */
#line 2024 "CISA.y"
               {(yyval.lsc_addr_type) = LSC_ADDR_TYPE_BTI;}
#line 4540 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.12037.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 259: /* LscVectorOpImm: IntExp  */
#line 2029 "CISA.y"
           {
        (yyval.lsc_addr_surface_ident) = pBuilder->CISA_create_immed((yyvsp[0].intval),ISA_TYPE_UD, CISAlineno);
    }
#line 4548 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.12037.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 260: /* LscVectorOpReg: Var  */
#line 2034 "CISA.y"
        {
        ABORT_ON_FAIL((yyval.lsc_addr_surface_ident) = pBuilder->CISA_create_gen_src_operand(
            (yyvsp[0].string),
            0, 1, 0, // region
            0, 0, // row and col offset
            MODIFIER_NONE, CISAlineno));
    }
#line 4560 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.12037.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 261: /* LscVectorOpReg: Var DOT DEC_LIT  */
#line 2042 "CISA.y"
                    {
        ABORT_ON_FAIL((yyval.lsc_addr_surface_ident) = pBuilder->CISA_create_gen_src_operand(
            (yyvsp[-2].string),
            0, 1, 0, // region
            0, (unsigned char)(yyvsp[0].intval), // row and col offset
            MODIFIER_NONE, CISAlineno));
    }
#line 4572 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.12037.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 262: /* LscVectorOpReg: Var LPAREN IntExp COMMA IntExp RPAREN  */
#line 2050 "CISA.y"
                                          {
        MUST_HOLD((yyvsp[-3].intval) <= 255 || (yyvsp[-3].intval) >= 0, "row is out of bounds");
        MUST_HOLD((yyvsp[-1].intval) <= 255 || (yyvsp[-1].intval) >= 0, "col is out of bounds");
        (yyval.lsc_addr_surface_ident) = pBuilder->CISA_create_gen_src_operand(
            (yyvsp[-5].string),
            0, 1, 0,
            (unsigned char)(yyvsp[-3].intval), (unsigned char)(yyvsp[-1].intval), // row and col offset
            MODIFIER_NONE, CISAlineno);
        if ((yyval.lsc_addr_surface_ident) == nullptr) {
            PARSE_ERROR("cannot find surface variable");
        }
    }
#line 4589 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.12037.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 263: /* LscDataOperand: LscPayloadReg LSC_DATA_SHAPE_TK  */
#line 2064 "CISA.y"
                                     {
        (yyval.lsc_data_operand) = {(yyvsp[-1].RawVar),(yyvsp[0].lsc_data_shape)};
    }
#line 4597 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.12037.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 264: /* LscDataOperand: LscPayloadReg LSC_DATA_SHAPE_TK_CHMASK  */
#line 2068 "CISA.y"
                                            {
        (yyval.lsc_data_operand) = {(yyvsp[-1].RawVar),(yyvsp[0].lsc_data_shape)};
    }
#line 4605 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.12037.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 265: /* LscDataOperand2D: LscPayloadReg LSC_DATA_SHAPE_TK_BLOCK2D  */
#line 2074 "CISA.y"
                                            {
        (yyval.lsc_data_operand2d) = {(yyvsp[-1].RawVar),(yyvsp[0].lsc_data_shape2d)};
    }
#line 4613 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.12037.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 267: /* LscPayloadReg: Var  */
#line 2082 "CISA.y"
        {
        ABORT_ON_FAIL((yyval.RawVar) = pBuilder->CISA_create_RAW_operand((yyvsp[0].string), 0, CISAlineno));
    }
#line 4621 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.12037.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 269: /* LscPayloadNonNullReg: VarNonNull  */
#line 2089 "CISA.y"
               {
        ABORT_ON_FAIL((yyval.RawVar) = pBuilder->CISA_create_RAW_operand((yyvsp[0].string), 0, CISAlineno));
    }
#line 4629 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.12037.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 270: /* SwitchLabels: %empty  */
#line 2095 "CISA.y"
    {
    }
#line 4636 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.12037.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 271: /* SwitchLabels: COMMA SwitchLabels  */
#line 2098 "CISA.y"
    {
    }
#line 4643 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.12037.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 272: /* SwitchLabels: IDENT SwitchLabels  */
#line 2101 "CISA.y"
    {
        // parse rule means we see last label first
        switchLabels.push_front((yyvsp[-1].string));
    }
#line 4652 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.12037.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 273: /* BranchInstruction: Predicate BRANCH_OP ExecSize IdentOrStringLit  */
#line 2108 "CISA.y"
    {
        pBuilder->CISA_create_branch_instruction((yyvsp[-3].pred_reg), (yyvsp[-2].opcode), (yyvsp[-1].emask_exec_size).emask, (yyvsp[-1].emask_exec_size).exec_size, (yyvsp[0].string), false, CISAlineno);
    }
#line 4660 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.12037.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 274: /* BranchInstruction: Predicate CALL_OP ExecSize IdentOrStringLit  */
#line 2112 "CISA.y"
    {
        pBuilder->CISA_create_branch_instruction((yyvsp[-3].pred_reg), (yyvsp[-2].cisa_call).opcode, (yyvsp[-1].emask_exec_size).emask, (yyvsp[-1].emask_exec_size).exec_size, (yyvsp[0].string), (yyvsp[-2].cisa_call).is_fccall, CISAlineno);
    }
#line 4668 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.12037.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 275: /* BranchInstruction: Predicate RET_OP ExecSize  */
#line 2116 "CISA.y"
    {
        pBuilder->CISA_Create_Ret((yyvsp[-2].pred_reg), (yyvsp[-1].opcode), (yyvsp[0].emask_exec_size).emask, (yyvsp[0].emask_exec_size).exec_size, CISAlineno);
    }
#line 4676 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.12037.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 276: /* BranchInstruction: SWITCHJMP_OP ExecSize VecSrcOperand_G_I_IMM LPAREN SwitchLabels RPAREN  */
#line 2120 "CISA.y"
    {
        pBuilder->CISA_create_switch_instruction((yyvsp[-5].opcode), (yyvsp[-4].emask_exec_size).exec_size, (yyvsp[-3].genOperand).cisa_gen_opnd, switchLabels, CISAlineno);
        switchLabels.clear();
    }
#line 4685 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.12037.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 277: /* BranchInstruction: Predicate FCALL ExecSize IDENT DEC_LIT DEC_LIT  */
#line 2126 "CISA.y"
    {
        pBuilder->CISA_create_fcall_instruction((yyvsp[-5].pred_reg), (yyvsp[-4].opcode), (yyvsp[-3].emask_exec_size).emask, (yyvsp[-3].emask_exec_size).exec_size, (yyvsp[-2].string), (unsigned)(yyvsp[-1].intval), (unsigned)(yyvsp[0].intval), CISAlineno);
    }
#line 4693 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.12037.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 278: /* BranchInstruction: Predicate IFCALL ExecSize VecSrcOperand_G_I_IMM DEC_LIT DEC_LIT  */
#line 2131 "CISA.y"
    {
        pBuilder->CISA_create_ifcall_instruction(
        (yyvsp[-5].pred_reg), (yyvsp[-3].emask_exec_size).emask, (yyvsp[-3].emask_exec_size).exec_size,
        (yyvsp[-2].genOperand).cisa_gen_opnd, (unsigned)(yyvsp[-1].intval), (unsigned)(yyvsp[0].intval), CISAlineno);
    }
#line 4703 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.12037.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 279: /* BranchInstruction: FADDR IdentOrStringLit VecDstOperand_G_I  */
#line 2138 "CISA.y"
    {
        pBuilder->CISA_create_faddr_instruction((yyvsp[-1].string), (yyvsp[0].genOperand).cisa_gen_opnd, CISAlineno);
    }
#line 4711 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.12037.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 280: /* FILE: FILE_OP STRING_LIT  */
#line 2143 "CISA.y"
    {
        pBuilder->CISA_create_FILE_instruction((yyvsp[-1].opcode), (yyvsp[0].string), CISAlineno);
    }
#line 4719 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.12037.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 281: /* LOC: LOC_OP DEC_LIT  */
#line 2148 "CISA.y"
    {
        pBuilder->CISA_create_LOC_instruction((yyvsp[-1].opcode), (unsigned)(yyvsp[0].intval), CISAlineno);
    }
#line 4727 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.12037.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 282: /* RawSendInstruction: Predicate RAW_SEND_STRING ExecSize HEX_LIT DEC_LIT DEC_LIT VecSrcOperand_G_IMM RawOperand RawOperand  */
#line 2154 "CISA.y"
    {
        pBuilder->CISA_create_raw_send_instruction(ISA_RAW_SEND, false, (yyvsp[-6].emask_exec_size).emask, (yyvsp[-6].emask_exec_size).exec_size, (yyvsp[-8].pred_reg),
            (unsigned)(yyvsp[-5].intval), (unsigned char)(yyvsp[-4].intval), (unsigned char)(yyvsp[-3].intval), (yyvsp[-2].genOperand).cisa_gen_opnd, (yyvsp[-1].RawVar), (yyvsp[0].RawVar), CISAlineno);
    }
#line 4736 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.12037.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 283: /* RawSendInstruction: Predicate RAW_SENDC_STRING ExecSize HEX_LIT DEC_LIT DEC_LIT VecSrcOperand_G_IMM RawOperand RawOperand  */
#line 2161 "CISA.y"
    {
        pBuilder->CISA_create_raw_send_instruction(ISA_RAW_SEND, true, (yyvsp[-6].emask_exec_size).emask, (yyvsp[-6].emask_exec_size).exec_size, (yyvsp[-8].pred_reg),
            (unsigned)(yyvsp[-5].intval), (unsigned char)(yyvsp[-4].intval), (unsigned char)(yyvsp[-3].intval), (yyvsp[-2].genOperand).cisa_gen_opnd, (yyvsp[-1].RawVar), (yyvsp[0].RawVar), CISAlineno);
    }
#line 4745 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.12037.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 284: /* LifetimeStartInst: LIFETIME_START_OP IDENT  */
#line 2168 "CISA.y"
    {
        ABORT_ON_FAIL(pBuilder->CISA_create_lifetime_inst((unsigned char)0, (yyvsp[0].string), CISAlineno));
    }
#line 4753 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.12037.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 285: /* LifetimeEndInst: LIFETIME_END_OP IDENT  */
#line 2174 "CISA.y"
    {
        ABORT_ON_FAIL(pBuilder->CISA_create_lifetime_inst((unsigned char)1, (yyvsp[0].string), CISAlineno));
    }
#line 4761 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.12037.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 286: /* RawSendsInstruction: Predicate RAW_SENDS_STRING ElemNum ElemNum ElemNum ElemNum ExecSize VecSrcOperand_G_IMM VecSrcOperand_G_IMM RawOperand RawOperand RawOperand  */
#line 2180 "CISA.y"
    {
        pBuilder->CISA_create_raw_sends_instruction(
            ISA_RAW_SENDS, false, false, (yyvsp[-5].emask_exec_size).emask, (yyvsp[-5].emask_exec_size).exec_size, (yyvsp[-11].pred_reg), (yyvsp[-4].genOperand).cisa_gen_opnd,
            (unsigned char)(yyvsp[-9].intval), (unsigned char)(yyvsp[-8].intval), (unsigned char)(yyvsp[-7].intval), (unsigned char)(yyvsp[-6].intval),
            (yyvsp[-3].genOperand).cisa_gen_opnd, (yyvsp[-2].RawVar), (yyvsp[-1].RawVar), (yyvsp[0].RawVar), CISAlineno);
    }
#line 4772 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.12037.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 287: /* RawSendsInstruction: Predicate RAW_SENDS_EOT_STRING ElemNum ElemNum ElemNum ElemNum ExecSize VecSrcOperand_G_IMM VecSrcOperand_G_IMM RawOperand RawOperand RawOperand  */
#line 2188 "CISA.y"
    {
        pBuilder->CISA_create_raw_sends_instruction(
            ISA_RAW_SENDS, false, true, (yyvsp[-5].emask_exec_size).emask, (yyvsp[-5].emask_exec_size).exec_size, (yyvsp[-11].pred_reg), (yyvsp[-4].genOperand).cisa_gen_opnd,
            (unsigned char)(yyvsp[-9].intval), (unsigned char)(yyvsp[-8].intval), (unsigned char)(yyvsp[-7].intval), (unsigned char)(yyvsp[-6].intval),
            (yyvsp[-3].genOperand).cisa_gen_opnd, (yyvsp[-2].RawVar), (yyvsp[-1].RawVar), (yyvsp[0].RawVar), CISAlineno);
    }
#line 4783 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.12037.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 288: /* RawSendsInstruction: Predicate RAW_SENDSC_STRING ElemNum ElemNum ElemNum ExecSize VecSrcOperand_G_IMM VecSrcOperand_G_IMM RawOperand RawOperand RawOperand  */
#line 2196 "CISA.y"
    {
        pBuilder->CISA_create_raw_sends_instruction(
            ISA_RAW_SENDS, true, false, (yyvsp[-5].emask_exec_size).emask, (yyvsp[-5].emask_exec_size).exec_size, (yyvsp[-10].pred_reg), (yyvsp[-4].genOperand).cisa_gen_opnd,
            0, (unsigned char)(yyvsp[-8].intval), (unsigned char)(yyvsp[-7].intval), (unsigned char)(yyvsp[-6].intval),
            (yyvsp[-3].genOperand).cisa_gen_opnd, (yyvsp[-2].RawVar), (yyvsp[-1].RawVar), (yyvsp[0].RawVar), CISAlineno);
    }
#line 4794 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.12037.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 289: /* RawSendsInstruction: Predicate RAW_SENDSC_EOT_STRING ElemNum ElemNum ElemNum ExecSize VecSrcOperand_G_IMM VecSrcOperand_G_IMM RawOperand RawOperand RawOperand  */
#line 2204 "CISA.y"
    {
        pBuilder->CISA_create_raw_sends_instruction(
            ISA_RAW_SENDS, true, true, (yyvsp[-5].emask_exec_size).emask, (yyvsp[-5].emask_exec_size).exec_size, (yyvsp[-10].pred_reg), (yyvsp[-4].genOperand).cisa_gen_opnd,
            0, (unsigned char)(yyvsp[-8].intval), (unsigned char)(yyvsp[-7].intval), (unsigned char)(yyvsp[-6].intval),
            (yyvsp[-3].genOperand).cisa_gen_opnd, (yyvsp[-2].RawVar), (yyvsp[-1].RawVar), (yyvsp[0].RawVar), CISAlineno);
    }
#line 4805 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.12037.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 290: /* NullaryInstruction: CACHE_FLUSH_OP  */
#line 2213 "CISA.y"
    {
        pBuilder->CISA_create_NO_OPND_instruction((yyvsp[0].opcode), CISAlineno);
    }
#line 4813 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.12037.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 291: /* NullaryInstruction: WAIT_OP VecSrcOperand_G_IMM  */
#line 2218 "CISA.y"
    {
        pBuilder->CISA_create_wait_instruction((yyvsp[0].genOperand).cisa_gen_opnd, CISAlineno);
    }
#line 4821 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.12037.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 292: /* NullaryInstruction: YIELD_OP  */
#line 2223 "CISA.y"
    {
        pBuilder->CISA_create_yield_instruction((yyvsp[0].opcode), CISAlineno);
    }
#line 4829 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.12037.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 293: /* NullaryInstruction: FENCE_GLOBAL_OP  */
#line 2228 "CISA.y"
    {
        pBuilder->CISA_create_fence_instruction((yyvsp[0].opcode), 0x0, CISAlineno);
    }
#line 4837 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.12037.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 294: /* NullaryInstruction: FENCE_GLOBAL_OP FENCE_OPTIONS  */
#line 2233 "CISA.y"
    {
        pBuilder->CISA_create_fence_instruction((yyvsp[-1].opcode), (yyvsp[0].fence_options), CISAlineno);
    }
#line 4845 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.12037.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 295: /* NullaryInstruction: FENCE_LOCAL_OP  */
#line 2238 "CISA.y"
    {
        pBuilder->CISA_create_fence_instruction((yyvsp[0].opcode), 0x20, CISAlineno);
    }
#line 4853 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.12037.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 296: /* NullaryInstruction: FENCE_LOCAL_OP FENCE_OPTIONS  */
#line 2243 "CISA.y"
    {
        pBuilder->CISA_create_fence_instruction((yyvsp[-1].opcode), (yyvsp[0].fence_options) | 0x20, CISAlineno);
    }
#line 4861 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.12037.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 297: /* NullaryInstruction: FENCE_SW_OP  */
#line 2248 "CISA.y"
    {
        pBuilder->CISA_create_fence_instruction((yyvsp[0].opcode), 0x80, CISAlineno);
    }
#line 4869 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.12037.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 298: /* OwordModifier: %empty  */
#line 2252 "CISA.y"
                      {(yyval.oword_mod) = false;}
#line 4875 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.12037.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 300: /* Predicate: %empty  */
#line 2259 "CISA.y"
    {
        (yyval.pred_reg) = NULL;
    }
#line 4883 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.12037.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 301: /* Predicate: LPAREN PredSign PredVar PredCtrlOpt RPAREN  */
#line 2264 "CISA.y"
    {
        (yyval.pred_reg) = pBuilder->CISA_create_predicate_operand((yyvsp[-2].vISADecl), (yyvsp[-3].pred_sign), (yyvsp[-1].pred_ctrl), CISAlineno);
    }
#line 4891 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.12037.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 302: /* PredSign: %empty  */
#line 2268 "CISA.y"
                 {(yyval.pred_sign) = PredState_NO_INVERSE;}
#line 4897 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.12037.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 303: /* PredSign: BANG  */
#line 2268 "CISA.y"
                                                     {(yyval.pred_sign) = PredState_INVERSE;}
#line 4903 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.12037.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 304: /* PredCtrlOpt: %empty  */
#line 2270 "CISA.y"
                    {(yyval.pred_ctrl) = PRED_CTRL_NON;}
#line 4909 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.12037.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 306: /* SatModOpt: %empty  */
#line 2273 "CISA.y"
                  {(yyval.sat) = false;}
#line 4915 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.12037.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 307: /* SatModOpt: SAT  */
#line 2273 "CISA.y"
                                      {(yyval.sat) = true;}
#line 4921 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.12037.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 308: /* SrcModifier: SRCMOD_NEG  */
#line 2276 "CISA.y"
                    {(yyval.src_mod).mod = MODIFIER_NEG;}
#line 4927 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.12037.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 309: /* SrcModifier: SRCMOD_ABS  */
#line 2277 "CISA.y"
                    {(yyval.src_mod).mod = MODIFIER_ABS;}
#line 4933 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.12037.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 310: /* SrcModifier: SRCMOD_NEGABS  */
#line 2278 "CISA.y"
                    {(yyval.src_mod).mod = MODIFIER_NEG_ABS;}
#line 4939 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.12037.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 311: /* SrcModifier: SRCMOD_NOT  */
#line 2279 "CISA.y"
                    {(yyval.src_mod).mod = MODIFIER_NOT;}
#line 4945 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.12037.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 312: /* ConditionalModifier: %empty  */
#line 2281 "CISA.y"
                            {(yyval.cond_mod) = ISA_CMP_UNDEF;}
#line 4951 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.12037.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 314: /* VecDstOperand_A: DstAddrOperand  */
#line 2286 "CISA.y"
                                   {(yyval.genOperand) = (yyvsp[0].genOperand); (yyval.genOperand).type = OPERAND_ADDRESS;}
#line 4957 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.12037.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 315: /* VecDstOperand_G: DstGeneralOperand  */
#line 2287 "CISA.y"
                                   {(yyval.genOperand) = (yyvsp[0].genOperand); (yyval.genOperand).type = OPERAND_GENERAL;}
#line 4963 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.12037.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 316: /* VecDstOperand_G_I: DstGeneralOperand  */
#line 2289 "CISA.y"
                           {(yyval.genOperand) = (yyvsp[0].genOperand); (yyval.genOperand).type = OPERAND_GENERAL;}
#line 4969 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.12037.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 317: /* VecDstOperand_G_I: DstIndirectOperand  */
#line 2290 "CISA.y"
                           {(yyval.genOperand) = (yyvsp[0].genOperand); (yyval.genOperand).type = OPERAND_INDIRECT;}
#line 4975 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.12037.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 319: /* VecSrcOperand_G_I_IMM_A_AO: SrcAddrOfOperand  */
#line 2295 "CISA.y"
                           {(yyval.genOperand) = (yyvsp[0].genOperand); (yyval.genOperand).type = OPERAND_ADDRESSOF;}
#line 4981 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.12037.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 321: /* VecSrcOperand_G_I_IMM_A: SrcAddrOperand  */
#line 2299 "CISA.y"
                           {(yyval.genOperand) = (yyvsp[0].genOperand); (yyval.genOperand).type = OPERAND_ADDRESS;}
#line 4987 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.12037.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 323: /* VecSrcOperand_G_I_IMM: SrcIndirectOperand  */
#line 2303 "CISA.y"
                           {(yyval.genOperand) = (yyvsp[0].genOperand); (yyval.genOperand).type = OPERAND_INDIRECT;}
#line 4993 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.12037.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 324: /* VecSrcOperand_G_I_IMM: SrcImmOperand  */
#line 2304 "CISA.y"
                           {(yyval.genOperand) = (yyvsp[0].genOperand); (yyval.genOperand).type = OPERAND_IMMEDIATE;}
#line 4999 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.12037.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 326: /* VecSrcOperand_G_IMM: SrcImmOperand  */
#line 2308 "CISA.y"
                          {(yyval.genOperand) = (yyvsp[0].genOperand); (yyval.genOperand).type = OPERAND_IMMEDIATE;}
#line 5005 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.12037.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 328: /* VecSrcOperand_G_IMM_AO: SrcImmOperand  */
#line 2312 "CISA.y"
                          {(yyval.genOperand) = (yyvsp[0].genOperand); (yyval.genOperand).type = OPERAND_IMMEDIATE;}
#line 5011 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.12037.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 329: /* VecSrcOperand_G_IMM_AO: SrcAddrOfOperand  */
#line 2313 "CISA.y"
                          {(yyval.genOperand) = (yyvsp[0].genOperand); (yyval.genOperand).type = OPERAND_ADDRESSOF;}
#line 5017 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.12037.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 331: /* VecSrcOperand_G_A: SrcAddrOperand  */
#line 2317 "CISA.y"
                          {(yyval.genOperand) = (yyvsp[0].genOperand); (yyval.genOperand).type = OPERAND_ADDRESS;}
#line 5023 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.12037.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 333: /* VecSrcOperand_G_A_AO: SrcAddrOfOperand  */
#line 2321 "CISA.y"
                          {(yyval.genOperand) = (yyvsp[0].genOperand); (yyval.genOperand).type = OPERAND_ADDRESS;}
#line 5029 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.12037.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 334: /* VecSrcOperand_G: SrcGeneralOperand  */
#line 2323 "CISA.y"
                                   {(yyval.genOperand) = (yyvsp[0].genOperand); (yyval.genOperand).type = OPERAND_GENERAL;}
#line 5035 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.12037.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 335: /* VecSrcOpndSimple: Var TwoDimOffset  */
#line 2326 "CISA.y"
    {
        // simple vector operand with no modifier that has an
        // implicit src region = <1,1,0>
        (yyval.genOperand).type = OPERAND_GENERAL;
        ABORT_ON_FAIL((yyval.genOperand).cisa_gen_opnd = pBuilder->CISA_create_gen_src_operand(
            (yyvsp[-1].string), 1, 1, 0, (yyvsp[0].offset).row, (yyvsp[0].offset).elem, MODIFIER_NONE, CISAlineno));
    }
#line 5047 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.12037.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 336: /* VMEOpndIME: LPAREN DEC_LIT COMMA DEC_LIT RPAREN  */
#line 2336 "CISA.y"
    {
        (yyval.vmeOpndIvb).streamMode = (unsigned char)(yyvsp[-3].intval);
        (yyval.vmeOpndIvb).searchCtrl = (unsigned char)(yyvsp[-1].intval);
    }
#line 5056 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.12037.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 337: /* VMEOpndFBR: LPAREN VecSrcOperand_G_I_IMM COMMA VecSrcOperand_G_I_IMM COMMA VecSrcOperand_G_I_IMM RPAREN  */
#line 2343 "CISA.y"
    {
        (yyval.vmeOpndFbr).cisa_fbrMbMode_opnd = (yyvsp[-5].genOperand).cisa_gen_opnd;
        (yyval.vmeOpndFbr).cisa_fbrSubMbShape_opnd = (yyvsp[-3].genOperand).cisa_gen_opnd;
        (yyval.vmeOpndFbr).cisa_fbrSubPredMode_opnd = (yyvsp[-1].genOperand).cisa_gen_opnd;
    }
#line 5066 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.12037.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 338: /* SrcStateOperand: Var LPAREN IntExp RPAREN  */
#line 2351 "CISA.y"
    {
        MUST_HOLD((yyvsp[-1].intval) < 0x100, "offset out of bounds");
        (yyval.StateVar).offset = (unsigned char)(yyvsp[-1].intval);
        ABORT_ON_FAIL((yyval.StateVar).cisa_gen_opnd = pBuilder->CISA_create_state_operand((yyvsp[-3].string), (unsigned char)(yyvsp[-1].intval), CISAlineno, false));
    }
#line 5076 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.12037.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 339: /* DstStateOperand: Var LPAREN IntExp RPAREN  */
#line 2359 "CISA.y"
    {
        MUST_HOLD((yyvsp[-1].intval) < 0x100, "offset out of bounds");
        (yyval.StateVar).offset = (unsigned char)(yyvsp[-1].intval);
        ABORT_ON_FAIL((yyval.StateVar).cisa_gen_opnd = pBuilder->CISA_create_state_operand((yyvsp[-3].string), (unsigned char)(yyvsp[-1].intval), CISAlineno, true));
    }
#line 5086 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.12037.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 341: /* RawOperand: BUILTIN_NULL DOT DEC_LIT  */
#line 2390 "CISA.y"
    {
        MUST_HOLD((yyvsp[0].intval) == 0, "%null must have 0 as offset");
        (yyval.RawVar) = pBuilder->CISA_create_RAW_NULL_operand(CISAlineno); // can't fail
    }
#line 5095 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.12037.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 342: /* RawOperandNonNull: VarNonNull RawOperandOffsetSuffix  */
#line 2397 "CISA.y"
    {
        ABORT_ON_FAIL((yyval.RawVar) = pBuilder->CISA_create_RAW_operand((yyvsp[-1].string), (unsigned short)(yyvsp[0].intval), CISAlineno));
    }
#line 5103 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.12037.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 343: /* RawOperandOffsetSuffix: DOT DEC_LIT  */
#line 2408 "CISA.y"
                {
        MUST_HOLD((yyvsp[0].intval) <= 0x10000, "offset out of bounds");
        (yyval.intval) = (yyvsp[0].intval);
    }
#line 5112 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.12037.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 344: /* RawOperandOffsetSuffix: DOT LPAREN IntExp RPAREN  */
#line 2413 "CISA.y"
                             {
        MUST_HOLD((yyvsp[-1].intval) <= 0x10000, "offset out of bounds");
        (yyval.intval) = (yyvsp[-1].intval);
    }
#line 5121 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.12037.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 345: /* RawOperandArray: %empty  */
#line 2421 "CISA.y"
    {
        (yyval.intval) = 0;
    }
#line 5129 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.12037.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 346: /* RawOperandArray: RawOperandArray RawOperand  */
#line 2426 "CISA.y"
    {
        rawOperandArray[(yyvsp[-1].intval)++] = (VISA_RawOpnd*)(yyvsp[0].RawVar);
        (yyval.intval) = (yyvsp[-1].intval);
    }
#line 5138 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.12037.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 347: /* DstAddrOperand: AddrVarAccessWithWidth  */
#line 2434 "CISA.y"
    {
        ABORT_ON_FAIL((yyval.genOperand).cisa_gen_opnd =
          pBuilder->CISA_set_address_operand(
            (yyvsp[0].regAccess).cisa_decl, (yyvsp[0].regAccess).elem, (yyvsp[0].regAccess).row, true, CISAlineno));
    }
#line 5148 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.12037.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 348: /* DstGeneralOperand: Var TwoDimOffset DstRegion  */
#line 2442 "CISA.y"
    {
        ABORT_ON_FAIL((yyval.genOperand).cisa_gen_opnd = pBuilder->CISA_dst_general_operand(
            (yyvsp[-2].string), (yyvsp[-1].offset).row, (yyvsp[-1].offset).elem, (unsigned short)(yyvsp[0].intval), CISAlineno));
    }
#line 5157 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.12037.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 349: /* DstGeneralOperand: Var DstRegion  */
#line 2447 "CISA.y"
                  {
        ABORT_ON_FAIL((yyval.genOperand).cisa_gen_opnd = pBuilder->CISA_dst_general_operand(
            (yyvsp[-1].string), 0, 0, (unsigned short)(yyvsp[0].intval), CISAlineno));
    }
#line 5166 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.12037.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 350: /* DstIndirectOperand: IndirectVarAccess DstRegion DataType  */
#line 2453 "CISA.y"
    {
        ABORT_ON_FAIL((yyval.genOperand).cisa_gen_opnd = pBuilder->CISA_create_indirect_dst(
            (yyvsp[-2].regAccess).cisa_decl, MODIFIER_NONE, (yyvsp[-2].regAccess).row, (yyvsp[-2].regAccess).elem, (yyvsp[-2].regAccess).immOff, (unsigned short)(yyvsp[-1].intval), (yyvsp[0].type), CISAlineno));
    }
#line 5175 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.12037.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 351: /* SrcAddrOfOperand: AddrOfVar  */
#line 2474 "CISA.y"
              {
         (yyval.genOperand).cisa_gen_opnd = pBuilder->CISA_set_address_expression((yyvsp[0].regAccess).cisa_decl, 0, CISAlineno);
    }
#line 5183 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.12037.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 352: /* SrcAddrOfOperand: AddrOfVar LBRACK IntExp RBRACK  */
#line 2478 "CISA.y"
                                   {
         MUST_HOLD((short)(yyvsp[-1].intval) == (yyvsp[-1].intval), "variable address offset is too large");
         (yyval.genOperand).cisa_gen_opnd = pBuilder->CISA_set_address_expression((yyvsp[-3].regAccess).cisa_decl, (short)(yyvsp[-1].intval), CISAlineno);
    }
#line 5192 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.12037.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 353: /* AddrOfVar: AMP Var  */
#line 2484 "CISA.y"
            {
        // Both GENERAL_VAR and SURFACE_VAR are addressable
        (yyval.regAccess).cisa_decl = pBuilder->CISA_find_decl((yyvsp[0].string));
        if ((yyval.regAccess).cisa_decl == nullptr)
            PARSE_ERROR("unbound variable");
        (yyval.regAccess).row = 0;
        (yyval.regAccess).elem = 0;
    }
#line 5205 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.12037.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 354: /* SrcAddrOperand: AddrVarAccessWithWidth  */
#line 2495 "CISA.y"
    {
        ABORT_ON_FAIL((yyval.genOperand).cisa_gen_opnd =
            pBuilder->CISA_set_address_operand(
                (yyvsp[0].regAccess).cisa_decl, (yyvsp[0].regAccess).elem, (yyvsp[0].regAccess).row, false, CISAlineno));
    }
#line 5215 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.12037.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 355: /* SrcGeneralOperand: Var TwoDimOffset SrcRegionDirect  */
#line 2503 "CISA.y"
    {
        ABORT_ON_FAIL((yyval.genOperand).cisa_gen_opnd =
            pBuilder->CISA_create_gen_src_operand(
                (yyvsp[-2].string), (yyvsp[0].cisa_region).v_stride, (yyvsp[0].cisa_region).width, (yyvsp[0].cisa_region).h_stride, (yyvsp[-1].offset).row, (yyvsp[-1].offset).elem, MODIFIER_NONE, CISAlineno));
    }
#line 5225 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.12037.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 356: /* SrcGeneralOperand: SrcModifier Var TwoDimOffset SrcRegionDirect  */
#line 2510 "CISA.y"
    {
        ABORT_ON_FAIL((yyval.genOperand).cisa_gen_opnd =
            pBuilder->CISA_create_gen_src_operand(
                (yyvsp[-2].string), (yyvsp[0].cisa_region).v_stride, (yyvsp[0].cisa_region).width, (yyvsp[0].cisa_region).h_stride, (yyvsp[-1].offset).row, (yyvsp[-1].offset).elem, (yyvsp[-3].src_mod).mod, CISAlineno));
    }
#line 5235 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.12037.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 357: /* SrcImmOperand: IntExpUnr DataTypeIntOrVector  */
#line 2520 "CISA.y"
    {
        (yyval.genOperand).cisa_gen_opnd = pBuilder->CISA_create_immed((yyvsp[-1].intval), (yyvsp[0].type), CISAlineno);
    }
#line 5243 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.12037.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 358: /* SrcImmOperand: HEX_LIT HFTYPE  */
#line 2525 "CISA.y"
                     {
        MUST_HOLD((yyvsp[-1].intval) < 0x10000, "literal too large for half float");
        (yyval.genOperand).cisa_gen_opnd = pBuilder->CISA_create_immed(
            (unsigned short)(yyvsp[-1].intval), ISA_TYPE_HF, CISAlineno);
    }
#line 5253 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.12037.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 359: /* SrcImmOperand: FloatLit  */
#line 2533 "CISA.y"
    {
        (yyval.genOperand).cisa_gen_opnd = pBuilder->CISA_create_float_immed((yyvsp[0].fltval), ISA_TYPE_F, CISAlineno);
    }
#line 5261 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.12037.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 360: /* SrcImmOperand: MINUS FloatLit  */
#line 2536 "CISA.y"
                     {
        (yyval.genOperand).cisa_gen_opnd = pBuilder->CISA_create_float_immed(-(yyvsp[0].fltval), ISA_TYPE_F, CISAlineno);
    }
#line 5269 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.12037.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 361: /* SrcImmOperand: DoubleFloatLit  */
#line 2542 "CISA.y"
    {
        (yyval.genOperand).cisa_gen_opnd = pBuilder->CISA_create_float_immed((yyvsp[0].fltval), ISA_TYPE_DF, CISAlineno);
    }
#line 5277 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.12037.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 362: /* SrcImmOperand: MINUS DoubleFloatLit  */
#line 2546 "CISA.y"
    {
        (yyval.genOperand).cisa_gen_opnd = pBuilder->CISA_create_float_immed(-(yyvsp[0].fltval), ISA_TYPE_DF, CISAlineno);
    }
#line 5285 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.12037.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 364: /* FloatLit: DEC_LIT FTYPE  */
#line 2553 "CISA.y"
   {
        // "1:f" means 1.4e-45
        int number = (int)(yyvsp[-1].intval);
        float *fp = (float *)&number;
        (yyval.fltval) = *fp;
   }
#line 5296 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.12037.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 365: /* FloatLit: HEX_LIT FTYPE  */
#line 2560 "CISA.y"
   {
        int number = (int)(yyvsp[-1].intval);
        float *fp = (float *)&number;
        (yyval.fltval) = *fp;
   }
#line 5306 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.12037.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 367: /* DoubleFloatLit: DEC_LIT DFTYPE  */
#line 2568 "CISA.y"
                    {
        // "1:df" means 5e-324
        int64_t number = (yyvsp[-1].intval);
        double *fp = (double *)&number;
        (yyval.fltval) = *fp;
   }
#line 5317 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.12037.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 368: /* DoubleFloatLit: HEX_LIT DFTYPE  */
#line 2574 "CISA.y"
                    {
        // to support 0x7ff0000000000000:df
        int64_t number = (yyvsp[-1].intval);
        double *fp = (double *)&number;
        (yyval.fltval) = *fp;
   }
#line 5328 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.12037.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 369: /* SrcIndirectOperand: IndirectVarAccess SrcRegionIndirect DataType  */
#line 2585 "CISA.y"
    {
        ABORT_ON_FAIL((yyval.genOperand).cisa_gen_opnd =
            pBuilder->CISA_create_indirect(
                (yyvsp[-2].regAccess).cisa_decl, MODIFIER_NONE, (yyvsp[-2].regAccess).row, (yyvsp[-2].regAccess).elem, (yyvsp[-2].regAccess).immOff,
                (yyvsp[-1].cisa_region).v_stride, (yyvsp[-1].cisa_region).width, (yyvsp[-1].cisa_region).h_stride, (yyvsp[0].type), CISAlineno));
    }
#line 5339 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.12037.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 370: /* SrcIndirectOperand: SrcModifier IndirectVarAccess SrcRegionIndirect DataType  */
#line 2593 "CISA.y"
    {
        ABORT_ON_FAIL((yyval.genOperand).cisa_gen_opnd =
            pBuilder->CISA_create_indirect(
                (yyvsp[-2].regAccess).cisa_decl, (yyvsp[-3].src_mod).mod, (yyvsp[-2].regAccess).row, (yyvsp[-2].regAccess).elem, (yyvsp[-2].regAccess).immOff,
                (yyvsp[-1].cisa_region).v_stride, (yyvsp[-1].cisa_region).width, (yyvsp[-1].cisa_region).h_stride, (yyvsp[0].type), CISAlineno));
    }
#line 5350 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.12037.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 371: /* DstRegion: LANGLE IntExpNRA RANGLE  */
#line 2602 "CISA.y"
    {
        MUST_HOLD(((yyvsp[-1].intval) == 0 || (yyvsp[-1].intval) == 1 || (yyvsp[-1].intval) == 2 || (yyvsp[-1].intval) == 4),
             "Dst HorzStride must be 0, 1, 2, or 4");
        (yyval.intval) = (yyvsp[-1].intval);
    }
#line 5360 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.12037.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 372: /* SrcRegionDirect: LANGLE IntExp SEMI IntExp COMMA IntExpNRA RANGLE  */
#line 2620 "CISA.y"
    {
        MUST_HOLD(((yyvsp[-5].intval) == 0 || (yyvsp[-5].intval) == 1 || (yyvsp[-5].intval) == 2 || (yyvsp[-5].intval) == 4 || (yyvsp[-5].intval) == 8 || (yyvsp[-5].intval) == 16 || (yyvsp[-5].intval) == 32),
                 "Src Region VertStride must be 0, 1, 2, 4, 8, 16, or 32");
        MUST_HOLD(((yyvsp[-3].intval) == 0 || (yyvsp[-3].intval) == 1 || (yyvsp[-3].intval) == 2 || (yyvsp[-3].intval) == 4 || (yyvsp[-3].intval) == 8 || (yyvsp[-3].intval) == 16),
                 "Src Region Width must be 0, 1, 2, 4, 8 or 16");
        MUST_HOLD(((yyvsp[-1].intval) == 0 || (yyvsp[-1].intval) == 1 || (yyvsp[-1].intval) == 2 || (yyvsp[-1].intval) == 4),
                 "Src Region HorzStride must be 0, 1, 2, or 4");
        (yyval.cisa_region).v_stride = (unsigned)(yyvsp[-5].intval);
        (yyval.cisa_region).width = (unsigned)(yyvsp[-3].intval);
        (yyval.cisa_region).h_stride = (unsigned)(yyvsp[-1].intval);
    }
#line 5376 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.12037.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 374: /* SrcRegionIndirect: LANGLE IntExp COMMA DEC_LIT RANGLE  */
#line 2637 "CISA.y"
    {
        MUST_HOLD(((yyvsp[-3].intval) == 0 || (yyvsp[-3].intval) == 1 || (yyvsp[-3].intval) == 2 || (yyvsp[-3].intval) == 4 || (yyvsp[-3].intval) == 8 || (yyvsp[-3].intval) == 16),
                 "Width must be 0, 1, 2, 4, 8 or 16");
        MUST_HOLD(((yyvsp[-1].intval) == 0 || (yyvsp[-1].intval) == 1 || (yyvsp[-1].intval) == 2 || (yyvsp[-1].intval) == 4),
                 "HorzStride must be 0, 1, 2, or 4");
        (yyval.cisa_region).v_stride = -1;
        (yyval.cisa_region).width = (unsigned)(yyvsp[-3].intval);
        (yyval.cisa_region).h_stride = (unsigned)(yyvsp[-1].intval);
    }
#line 5390 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.12037.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 375: /* SrcRegionIndirect: LANGLE IntExpNRA RANGLE  */
#line 2648 "CISA.y"
    {
        MUST_HOLD(((yyvsp[-1].intval) == 0 || (yyvsp[-1].intval) == 1 || (yyvsp[-1].intval) == 2 || (yyvsp[-1].intval) == 4),
             "HorzStride must be 0, 1, 2, or 4");
        (yyval.cisa_region).v_stride = -1;
        (yyval.cisa_region).width = -1;
        (yyval.cisa_region).h_stride = (unsigned)(yyvsp[-1].intval);
    }
#line 5402 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.12037.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 376: /* IndirectVarAccess: IND_LBRACK AddrVarAccess COMMA IntExp RBRACK  */
#line 2658 "CISA.y"
                                                 {
        (yyval.regAccess) = (yyvsp[-3].regAccess);
        (yyval.regAccess).immOff = (int)(yyvsp[-1].intval);
    }
#line 5411 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.12037.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 377: /* IndirectVarAccess: IND_LBRACK AddrVarAccess RBRACK  */
#line 2663 "CISA.y"
                                                 {
          (yyval.regAccess) = (yyvsp[-1].regAccess);
          (yyval.regAccess).immOff = 0;
    }
#line 5420 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.12037.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 378: /* TwoDimOffset: LPAREN IntExp COMMA IntExp RPAREN  */
#line 2668 "CISA.y"
                                                {
        MUST_HOLD((yyvsp[-3].intval) >= 0, "row (register) offset must be positive");
        (yyval.offset).row = (int)(yyvsp[-3].intval);
        MUST_HOLD((yyvsp[-1].intval) >= 0 && (yyvsp[-1].intval) <= 0xFFFF, "sub-register offset out of bounds");
        (yyval.offset).elem = (int)(yyvsp[-1].intval);
    }
#line 5431 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.12037.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 379: /* PredVar: Var  */
#line 2676 "CISA.y"
        {
        (yyval.vISADecl) = pBuilder->CISA_find_decl((yyvsp[0].string));
        if ((yyval.vISADecl) == nullptr)
            PARSE_ERROR((yyvsp[0].string), ": undefined predicate variable");
        if ((yyval.vISADecl)->type != PREDICATE_VAR)
            PARSE_ERROR((yyvsp[0].string), ": not a predicate variable");
    }
#line 5443 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.12037.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 380: /* AddrVarAccess: Var LPAREN IntExp RPAREN  */
#line 2685 "CISA.y"
                             {
        (yyval.regAccess).cisa_decl = pBuilder->CISA_find_decl((yyvsp[-3].string));
        if ((yyval.regAccess).cisa_decl == nullptr) {
            PARSE_ERROR((yyvsp[-3].string), ": unbound variable");
        } else if ((yyval.regAccess).cisa_decl->type != ADDRESS_VAR) {
            PARSE_ERROR((yyvsp[-3].string), ": not an address variable");
        }
        (yyval.regAccess).row = 1;
        (yyval.regAccess).elem = (int)(yyvsp[-1].intval);
    }
#line 5458 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.12037.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 381: /* AddrVarAccessWithWidth: Var LPAREN IntExp RPAREN LANGLE IntExpNRA RANGLE  */
#line 2697 "CISA.y"
                                                     {
        (yyval.regAccess).cisa_decl = pBuilder->CISA_find_decl((yyvsp[-6].string));
        if ((yyval.regAccess).cisa_decl == nullptr) {
            PARSE_ERROR((yyvsp[-6].string), ": unbound variable");
        } else if ((yyval.regAccess).cisa_decl->type != ADDRESS_VAR) {
            PARSE_ERROR((yyvsp[-6].string), ": not an address variable");
        }
        (yyval.regAccess).row = (int)(yyvsp[-1].intval);
        (yyval.regAccess).elem = (int)(yyvsp[-4].intval);
    }
#line 5473 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.12037.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 382: /* SIMDMode: %empty  */
#line 2711 "CISA.y"
           {(yyval.intval) = 0;}
#line 5479 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.12037.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 383: /* SIMDMode: LPAREN DEC_LIT RPAREN  */
#line 2714 "CISA.y"
    {
       MUST_HOLD(((yyvsp[-1].intval) == 8 || (yyvsp[-1].intval) == 16 || (yyvsp[-1].intval) == 32),
                 "SIMD mode can only be 8, 16, or 32");
       (yyval.intval) = (yyvsp[-1].intval);
    }
#line 5489 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.12037.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 384: /* ElemNum: DOT DEC_LIT  */
#line 2725 "CISA.y"
    {
        (yyval.intval) = (yyvsp[0].intval);
    }
#line 5497 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.12037.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 385: /* ExecSize: LPAREN ExecSizeInt RPAREN  */
#line 2737 "CISA.y"
    {
        (yyval.emask_exec_size).emask = vISA_EMASK_M1;
        (yyval.emask_exec_size).exec_size = (int)(yyvsp[-1].intval);
    }
#line 5506 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.12037.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 386: /* ExecSize: LPAREN Var COMMA ExecSizeInt RPAREN  */
#line 2743 "CISA.y"
    {
        if (!ParseEMask((yyvsp[-3].string), (yyval.emask_exec_size).emask)) {
            PARSE_ERROR("invalid execution offset info");
        }
        (yyval.emask_exec_size).exec_size = (int)(yyvsp[-1].intval);
    }
#line 5517 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.12037.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 387: /* ExecSizeInt: DEC_LIT  */
#line 2751 "CISA.y"
    {
        if ((yyvsp[0].intval) != 1 && (yyvsp[0].intval) != 2 && (yyvsp[0].intval) != 4 && (yyvsp[0].intval) != 8 && (yyvsp[0].intval) != 16 && (yyvsp[0].intval) != 32) {
            PARSE_ERROR("invalid execution size");
        }
        (yyval.intval) = (unsigned short)(yyvsp[0].intval);
    }
#line 5528 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.12037.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 393: /* IntExpCond: IntExpAND QUESTION IntExpAND COLON IntExpCond  */
#line 2765 "CISA.y"
                                                    {(yyval.intval) = (yyvsp[-4].intval) ? (yyvsp[-2].intval) : (yyvsp[0].intval);}
#line 5534 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.12037.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 395: /* IntExpAND: IntExpAND AMP IntExpXOR  */
#line 2768 "CISA.y"
                               {(yyval.intval) = (yyvsp[-2].intval) & (yyvsp[0].intval);}
#line 5540 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.12037.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 397: /* IntExpXOR: IntExpXOR CIRC IntExpOR  */
#line 2771 "CISA.y"
                               {(yyval.intval) = (yyvsp[-2].intval) ^ (yyvsp[0].intval);}
#line 5546 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.12037.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 399: /* IntExpOR: IntExpOR PIPE IntExpCmp  */
#line 2774 "CISA.y"
                                {(yyval.intval) = (yyvsp[-2].intval) | (yyvsp[0].intval);}
#line 5552 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.12037.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 401: /* IntExpCmp: IntExpRel EQ IntExpRel  */
#line 2777 "CISA.y"
                               {(yyval.intval) = (yyvsp[-2].intval) == (yyvsp[0].intval);}
#line 5558 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.12037.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 402: /* IntExpCmp: IntExpRel NEQ IntExpRel  */
#line 2778 "CISA.y"
                               {(yyval.intval) = (yyvsp[-2].intval) != (yyvsp[0].intval);}
#line 5564 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.12037.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 404: /* IntExpRel: IntExpNRA LANGLE IntExpNRA  */
#line 2781 "CISA.y"
                                 {(yyval.intval) = (yyvsp[-2].intval) < (yyvsp[0].intval);}
#line 5570 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.12037.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 405: /* IntExpRel: IntExpNRA RANGLE IntExpNRA  */
#line 2782 "CISA.y"
                                 {(yyval.intval) = (yyvsp[-2].intval) > (yyvsp[0].intval);}
#line 5576 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.12037.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 406: /* IntExpRel: IntExpNRA LEQ IntExpNRA  */
#line 2783 "CISA.y"
                                 {(yyval.intval) = (yyvsp[-2].intval) <= (yyvsp[0].intval);}
#line 5582 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.12037.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 407: /* IntExpRel: IntExpNRA GEQ IntExpNRA  */
#line 2784 "CISA.y"
                                 {(yyval.intval) = (yyvsp[-2].intval) >= (yyvsp[0].intval);}
#line 5588 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.12037.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 410: /* IntExpShift: IntExpAdd SHL IntExpAdd  */
#line 2805 "CISA.y"
                               {(yyval.intval) = (yyvsp[-2].intval) << (yyvsp[0].intval);}
#line 5594 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.12037.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 411: /* IntExpShift: IntExpAdd SHRS IntExpAdd  */
#line 2806 "CISA.y"
                               {(yyval.intval) = (int64_t)(yyvsp[-2].intval) >> (int)(yyvsp[0].intval);}
#line 5600 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.12037.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 412: /* IntExpShift: IntExpAdd SHRZ IntExpAdd  */
#line 2807 "CISA.y"
                               {(yyval.intval) = (int64_t)((uint64_t)(yyvsp[-2].intval) >> (uint64_t)(yyvsp[0].intval));}
#line 5606 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.12037.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 414: /* IntExpAdd: IntExpAdd PLUS IntExpMul  */
#line 2810 "CISA.y"
                                {(yyval.intval) = (yyvsp[-2].intval) + (yyvsp[0].intval);}
#line 5612 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.12037.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 415: /* IntExpAdd: IntExpAdd MINUS IntExpMul  */
#line 2811 "CISA.y"
                                {(yyval.intval) = (yyvsp[-2].intval) - (yyvsp[0].intval);}
#line 5618 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.12037.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 417: /* IntExpMul: IntExpMul TIMES IntExpUnr  */
#line 2814 "CISA.y"
                                {(yyval.intval) = (yyvsp[-2].intval) * (yyvsp[0].intval);}
#line 5624 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.12037.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 418: /* IntExpMul: IntExpMul SLASH IntExpUnr  */
#line 2815 "CISA.y"
                                {
            if ((yyvsp[0].intval) == 0)
                PARSE_ERROR("division by 0");
            (yyval.intval) = (yyvsp[-2].intval) / (yyvsp[0].intval);
        }
#line 5634 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.12037.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 419: /* IntExpMul: IntExpMul PERCENT IntExpUnr  */
#line 2820 "CISA.y"
                                  {
            if ((yyvsp[0].intval) == 0)
                PARSE_ERROR("division by 0");
            (yyval.intval) = (yyvsp[-2].intval) % (yyvsp[0].intval);
        }
#line 5644 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.12037.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 421: /* IntExpUnr: MINUS IntExpUnr  */
#line 2827 "CISA.y"
                      {(yyval.intval) = -(yyvsp[0].intval);}
#line 5650 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.12037.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 422: /* IntExpUnr: TILDE IntExpUnr  */
#line 2828 "CISA.y"
                      {(yyval.intval) = ~(yyvsp[0].intval);}
#line 5656 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.12037.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 423: /* IntExpUnr: BANG IntExpUnr  */
#line 2829 "CISA.y"
                      {(yyval.intval) = !((yyvsp[0].intval));}
#line 5662 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.12037.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 427: /* IntExpPrim: LPAREN IntExp RPAREN  */
#line 2837 "CISA.y"
                           {(yyval.intval) = (yyvsp[-1].intval);}
#line 5668 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.12037.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 428: /* IntExpPrim: BUILTIN_SIZEOF IDENT  */
#line 2841 "CISA.y"
                           {
        (yyval.intval) = 0;
        ABORT_ON_FAIL(pBuilder->CISA_eval_sizeof_decl(CISAlineno, (yyvsp[0].string), (yyval.intval)));
    }
#line 5677 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.12037.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 429: /* IntExpPrim: BUILTIN_SIZEOF LPAREN IDENT RPAREN  */
#line 2845 "CISA.y"
                                         {
        // TODO: %AlignOf(...), %Max(..)
        (yyval.intval) = 0;
        ABORT_ON_FAIL(pBuilder->CISA_eval_sizeof_decl(CISAlineno, (yyvsp[-1].string), (yyval.intval)));
    }
#line 5687 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.12037.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 430: /* IntExpPrim: BUILTIN_DISPATCH_SIMD_SIZE  */
#line 2851 "CISA.y"
                                 {
        // e.g. %DispatchSimdSize
        // N.B. %sizeof happens above
        (yyval.intval) = 0;
        ABORT_ON_FAIL(pBuilder->CISA_lookup_builtin_constant(CISAlineno, "%DispatchSimd", (yyval.intval)));
    }
#line 5698 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.12037.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;


#line 5702 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.12037.1/redhat-linux-build/IGC/visa/CISA.tab.cpp"

      default: break;
    }
  /* User semantic actions sometimes alter yychar, and that requires
     that yytoken be updated with the new translation.  We take the
     approach of translating immediately before every use of yytoken.
     One alternative is translating here after every semantic action,
     but that translation would be missed if the semantic action invokes
     YYABORT, YYACCEPT, or YYERROR immediately after altering yychar or
     if it invokes YYBACKUP.  In the case of YYABORT or YYACCEPT, an
     incorrect destructor might then be invoked immediately.  In the
     case of YYERROR or YYBACKUP, subsequent parser actions might lead
     to an incorrect destructor call or verbose syntax error message
     before the lookahead is translated.  */
  YY_SYMBOL_PRINT ("-> $$ =", YY_CAST (yysymbol_kind_t, yyr1[yyn]), &yyval, &yyloc);

  YYPOPSTACK (yylen);
  yylen = 0;

  *++yyvsp = yyval;

  /* Now 'shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */
  {
    const int yylhs = yyr1[yyn] - YYNTOKENS;
    const int yyi = yypgoto[yylhs] + *yyssp;
    yystate = (0 <= yyi && yyi <= YYLAST && yycheck[yyi] == *yyssp
               ? yytable[yyi]
               : yydefgoto[yylhs]);
  }

  goto yynewstate;


/*--------------------------------------.
| yyerrlab -- here on detecting error.  |
`--------------------------------------*/
yyerrlab:
  /* Make sure we have latest lookahead translation.  See comments at
     user semantic actions for why this is necessary.  */
  yytoken = yychar == YYEMPTY ? YYSYMBOL_YYEMPTY : YYTRANSLATE (yychar);
  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
      {
        yypcontext_t yyctx
          = {yyssp, yytoken};
        char const *yymsgp = YY_("syntax error");
        int yysyntax_error_status;
        yysyntax_error_status = yysyntax_error (&yymsg_alloc, &yymsg, &yyctx);
        if (yysyntax_error_status == 0)
          yymsgp = yymsg;
        else if (yysyntax_error_status == -1)
          {
            if (yymsg != yymsgbuf)
              YYSTACK_FREE (yymsg);
            yymsg = YY_CAST (char *,
                             YYSTACK_ALLOC (YY_CAST (YYSIZE_T, yymsg_alloc)));
            if (yymsg)
              {
                yysyntax_error_status
                  = yysyntax_error (&yymsg_alloc, &yymsg, &yyctx);
                yymsgp = yymsg;
              }
            else
              {
                yymsg = yymsgbuf;
                yymsg_alloc = sizeof yymsgbuf;
                yysyntax_error_status = YYENOMEM;
              }
          }
        yyerror (pBuilder, yymsgp);
        if (yysyntax_error_status == YYENOMEM)
          YYNOMEM;
      }
    }

  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
         error, discard it.  */

      if (yychar <= YYEOF)
        {
          /* Return failure if at end of input.  */
          if (yychar == YYEOF)
            YYABORT;
        }
      else
        {
          yydestruct ("Error: discarding",
                      yytoken, &yylval, pBuilder);
          yychar = YYEMPTY;
        }
    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*---------------------------------------------------.
| yyerrorlab -- error raised explicitly by YYERROR.  |
`---------------------------------------------------*/
yyerrorlab:
  /* Pacify compilers when the user code never invokes YYERROR and the
     label yyerrorlab therefore never appears in user code.  */
  if (0)
    YYERROR;
  ++yynerrs;

  /* Do not reclaim the symbols of the rule whose action triggered
     this YYERROR.  */
  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);
  yystate = *yyssp;
  goto yyerrlab1;


/*-------------------------------------------------------------.
| yyerrlab1 -- common code for both syntax error and YYERROR.  |
`-------------------------------------------------------------*/
yyerrlab1:
  yyerrstatus = 3;      /* Each real token shifted decrements this.  */

  /* Pop stack until we find a state that shifts the error token.  */
  for (;;)
    {
      yyn = yypact[yystate];
      if (!yypact_value_is_default (yyn))
        {
          yyn += YYSYMBOL_YYerror;
          if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYSYMBOL_YYerror)
            {
              yyn = yytable[yyn];
              if (0 < yyn)
                break;
            }
        }

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
        YYABORT;


      yydestruct ("Error: popping",
                  YY_ACCESSING_SYMBOL (yystate), yyvsp, pBuilder);
      YYPOPSTACK (1);
      yystate = *yyssp;
      YY_STACK_PRINT (yyss, yyssp);
    }

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END


  /* Shift the error token.  */
  YY_SYMBOL_PRINT ("Shifting", YY_ACCESSING_SYMBOL (yyn), yyvsp, yylsp);

  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturnlab;


/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturnlab;


/*-----------------------------------------------------------.
| yyexhaustedlab -- YYNOMEM (memory exhaustion) comes here.  |
`-----------------------------------------------------------*/
yyexhaustedlab:
  yyerror (pBuilder, YY_("memory exhausted"));
  yyresult = 2;
  goto yyreturnlab;


/*----------------------------------------------------------.
| yyreturnlab -- parsing is finished, clean up and return.  |
`----------------------------------------------------------*/
yyreturnlab:
  if (yychar != YYEMPTY)
    {
      /* Make sure we have latest lookahead translation.  See comments at
         user semantic actions for why this is necessary.  */
      yytoken = YYTRANSLATE (yychar);
      yydestruct ("Cleanup: discarding lookahead",
                  yytoken, &yylval, pBuilder);
    }
  /* Do not reclaim the symbols of the rule whose action triggered
     this YYABORT or YYACCEPT.  */
  YYPOPSTACK (yylen);
  YY_STACK_PRINT (yyss, yyssp);
  while (yyssp != yyss)
    {
      yydestruct ("Cleanup: popping",
                  YY_ACCESSING_SYMBOL (+*yyssp), yyvsp, pBuilder);
      YYPOPSTACK (1);
    }
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif
  if (yymsg != yymsgbuf)
    YYSTACK_FREE (yymsg);
  return yyresult;
}

#line 2869 "CISA.y"

///////////////////////////////////////////////////////////////////////////////
//                                                                           //
//                        Utility Functions                                  //
//                                                                           //
///////////////////////////////////////////////////////////////////////////////

void CISAerror(CISA_IR_Builder* pBuilder, char const *s)
{
    pBuilder->RecordParseError(CISAlineno, s);
}

static bool ParseAlign(CISA_IR_Builder* pBuilder, const char *sym, VISA_Align &value)
{
    if (strcmp(sym, "byte") == 0) {
        value = ALIGN_BYTE;
    } else if (strcmp(sym, "word") == 0) {
        value = ALIGN_WORD;
    } else if (strcmp(sym, "dword") == 0) {
        value = ALIGN_DWORD;
    } else if (strcmp(sym, "qword") == 0) {
        value = ALIGN_QWORD;
    } else if (strcmp(sym, "oword") == 0) {
        value = ALIGN_OWORD;
    } else if (strcmp(sym, "GRF") == 0) {
        value = ALIGN_GRF;
    } else if (strcmp(sym, "GRFx2") == 0 || strcmp(sym, "2GRF") == 0) {
        value = ALIGN_2_GRF;
    } else if (strcmp(sym, "hword") == 0) {
        value = ALIGN_HWORD;
    } else if (strcmp(sym, "wordx32") == 0) {
        value = ALIGN_32WORD;
    } else if (strcmp(sym, "wordx64") == 0) {
        value = ALIGN_64WORD;
    } else {
        value = ALIGN_UNDEF;
        return false;
    }
    return true;
}


static VISA_Align AlignBytesToVisaAlignment(int bytes)
{
    VISA_Align val = ALIGN_UNDEF;
    switch (bytes) {
    case 1:   val = ALIGN_BYTE; break;
    case 2:   val = ALIGN_WORD; break;
    case 4:   val = ALIGN_DWORD; break;
    case 8:   val = ALIGN_QWORD; break;
    case 16:  val = ALIGN_OWORD; break;
    case 32:  val = ALIGN_HWORD; break;
    case 64:  val = ALIGN_32WORD; break;
    case 128: val = ALIGN_64WORD; break;
    default:  val = ALIGN_UNDEF; break;
    }
    return val;
}



static bool ParseEMask(
    const char* sym,
    VISA_EMask_Ctrl &emask)
{
    if (strcmp(sym, "NoMask") == 0) {
        emask = vISA_EMASK_M1_NM;
        return true;
    }
    for (int i = 0; i < vISA_NUM_EMASK +1; i++)
    {
        if (!strcmp(emask_str[i], sym))
        {
            emask = (VISA_EMask_Ctrl)i;
            return true;
        }
    }

    emask = vISA_NUM_EMASK;
    return false;
}

static int lscCheckExecSize(
    CISA_IR_Builder* pBuilder,
    LSC_SFID sfid,
    LSC_OP op,
    LSC_DATA_ORDER data_order,
    int exec_size)
{
    int is_vector_op =
        op != LSC_LOAD_BLOCK2D &&
        op != LSC_STORE_BLOCK2D;
        // other ops like LSC_LOAD_SURFACE_INFO may be SIMD1
    if (op == LSC_READ_STATE_INFO) {
        exec_size = 1;
    } else if (data_order == LSC_DATA_ORDER_NONTRANSPOSE && is_vector_op) {
        if (exec_size == UNDEFINED_EXEC_SIZE) {
            if (pBuilder->getPlatform() == Xe_DG2) // for DG2 typed is 8, untyped is 16
                exec_size = sfid == LSC_TGM ? 8 : 16;
            else if (pBuilder->getPlatform() >= Xe_PVC) // on PVC typed is 16, untyped is 32
                exec_size = sfid == LSC_TGM ? 16 : 32;
            else
                exec_size = 32; // the world is finally sane
        }
    } else {
        // block and transpose get SIMD by default
        if (exec_size == UNDEFINED_EXEC_SIZE) {
           exec_size = 1; // transpose is implicitly 1 if needed
        }
    }
    return exec_size;
}
